// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

//ICP DAS Include .h Files
#include "UARTCE.h"
#include "I7000CE.h"


//define basic var
static WORD m_ComPort=3;
static WORD m_DataBit=8;
static WORD m_StopBit=0;
static WORD m_Baudrate=9600;
static WORD m_Parity=0;
static WORD m_TimeOut=100;
static WORD m_Checksum=0;
static WORD m_7060Addr=2;
static WORD m_7021Addr=3;
static WORD m_7012Addr=4;
static WORD  m_wBuf[12];
static float m_fBuf[12];
static char  m_szSend[100];
static char  m_szReceive[100];
static bool  timerOn=false;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_BUTTON4, m_BtnManualDI);
	DDX_Control(pDX, IDC_BUTTON8, m_BtnAutoScan);
	DDX_Control(pDX, IDC_BUTTON7, m_BtnManualAI);
	DDX_Control(pDX, IDC_STATICON, m_On);
	DDX_Control(pDX, IDC_STATICOFF, m_Off);
	DDX_Control(pDX, IDC_CHECK1, m_CheckboxChecksum);
	DDX_Control(pDX, IDC_STATICDI3, m_DI3);
	DDX_Control(pDX, IDC_STATICDI2, m_DI2);
	DDX_Control(pDX, IDC_STATICDI1, m_DI1);
	DDX_Control(pDX, IDC_STATICDI0, m_DI0);
	DDX_Control(pDX, IDC_CHECK5, m_DO3);
	DDX_Control(pDX, IDC_CHECK4, m_DO2);
	DDX_Control(pDX, IDC_CHECK3, m_DO1);
	DDX_Control(pDX, IDC_CHECK2, m_DO0);
	DDX_Control(pDX, IDC_EDIT6, m_EditAI);
	DDX_Control(pDX, IDC_EDIT5, m_EditAO);
	DDX_Control(pDX, IDC_EDIT4, m_Edit7012);
	DDX_Control(pDX, IDC_EDIT3, m_Edit7021);
	DDX_Control(pDX, IDC_EDIT2, m_Edit7060);
	DDX_Control(pDX, IDC_EDIT1, m_EditTimeOut);
	DDX_Control(pDX, IDC_COMBO4, m_ComboParity);
	DDX_Control(pDX, IDC_COMBO2, m_ComboBaudrate);
	DDX_Control(pDX, IDC_COMBO5, m_ComboStopBit);
	DDX_Control(pDX, IDC_COMBO3, m_ComboDataBit);
	DDX_Control(pDX, IDC_COMBO1, m_ComboComPort);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeComboComPort)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeComboBaudrate)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnSelchangeComboDataBit)
	ON_CBN_SELCHANGE(IDC_COMBO5, OnSelchangeComboStopBit)
	ON_CBN_SELCHANGE(IDC_COMBO4, OnSelchangeComboParity)
	ON_BN_CLICKED(IDC_CHECK1, OnCheckCheckSum)
	ON_BN_CLICKED(IDC_BUTTON3, OnButtonSetAllValue)
	ON_BN_CLICKED(IDC_CHECK2, OnCheckDO0)
	ON_BN_CLICKED(IDC_BUTTON1, OnButtonOpenCOM)
	ON_BN_CLICKED(IDC_BUTTON2, OnButtonCloseCOM)
	ON_BN_CLICKED(IDC_CHECK3, OnCheckDO1)
	ON_BN_CLICKED(IDC_CHECK4, OnCheckDO2)
	ON_BN_CLICKED(IDC_CHECK5, OnCheckDO3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButtonManualDI)
	ON_BN_CLICKED(IDC_BUTTON6, OnButtonAO)
	ON_BN_CLICKED(IDC_BUTTON7, OnButtonManualAI)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON8, OnButtonAutoScan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_EditTimeOut.SetWindowText(_T("100"));
	m_Edit7060.SetWindowText(_T("2"));
	m_Edit7021.SetWindowText(_T("3"));
	m_Edit7012.SetWindowText(_T("4"));
	m_EditAO.SetWindowText(_T("0"));
	m_ComboComPort.SetCurSel(1);
	m_ComboDataBit.SetCurSel(3);
	m_ComboStopBit.SetCurSel(0);
	m_ComboBaudrate.SetCurSel(5);
	m_ComboParity.SetCurSel(0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CDemoDlg::OnSelchangeComboComPort() 
{
	// TODO: Add your control notification handler code here
	switch (m_ComboComPort.GetCurSel())
	{
		case 0:
			m_ComPort=2;
			break;
		case 1:
			m_ComPort=3;
			break;
	}
}

void CDemoDlg::OnSelchangeComboBaudrate() 
{
	// TODO: Add your control notification handler code here
	switch (m_ComboBaudrate.GetCurSel())
	{
		case 0:
			m_Baudrate=300;
			break;
		case 1:
			m_Baudrate=600;
			break;
		case 2:
			m_Baudrate=1200;
			break;
		case 3:
			m_Baudrate=2400;
			break;
		case 4:
			m_Baudrate=4800;
			break;
		case 5:
			m_Baudrate=9600;
			break;
		case 6:
			m_Baudrate=19200;
			break;
		case 7:
			m_Baudrate=38400;
			break;
		case 8:
			m_Baudrate=57600;
			break;
		case 9:
			m_Baudrate=(WORD)115200;
			break;
	}	
}

void CDemoDlg::OnSelchangeComboDataBit() 
{
	// TODO: Add your control notification handler code here
	switch (m_ComboDataBit.GetCurSel())
	{
		case 0:
			m_DataBit=5;
			break;
		case 1:
			m_DataBit=6;
			break;
		case 2:
			m_DataBit=7;
			break;
		case 3:
			m_DataBit=8;
			break;
	}	
}

void CDemoDlg::OnSelchangeComboStopBit() 
{
	// TODO: Add your control notification handler code here
	m_StopBit=(WORD)m_ComboStopBit.GetCurSel();
}

void CDemoDlg::OnSelchangeComboParity() 
{
	// TODO: Add your control notification handler code here
	m_Parity=(WORD)m_ComboParity.GetCurSel();	
}

void CDemoDlg::OnCheckCheckSum() 
{
	// TODO: Add your control notification handler code here
	m_Checksum=(WORD)m_CheckboxChecksum.GetCheck();

}

void CDemoDlg::OnButtonSetAllValue() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	m_EditTimeOut.GetWindowText(temp, 20);
	m_TimeOut=(WORD)_ttoi(temp);
	m_Edit7060.GetWindowText(temp, 20);
	m_7060Addr=(WORD)_ttoi(temp);
	m_Edit7021.GetWindowText(temp, 20);
	m_7021Addr=(WORD)_ttoi(temp);
	m_Edit7012.GetWindowText(temp, 20);
	m_7012Addr=(WORD)_ttoi(temp);
}

void CDemoDlg::OnButtonOpenCOM() 
{
	// TODO: Add your control notification handler code here
	Open_Com((char)m_ComPort, m_Baudrate, (char)m_DataBit, (char)m_Parity, (char)m_StopBit);	
}

void CDemoDlg::OnButtonCloseCOM() 
{
	// TODO: Add your control notification handler code here
	Close_Com((char)m_ComPort);	
}

void CDemoDlg::OnCheckDO0() 
{
	// TODO: Add your control notification handler code here
//Exp7K WORD CALLBACK DigitalBitOut(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];             // RS-232 port number: 1/2/3/4..../255
// wBuf[1];             // module address: 0x00 to 0xFF
// wBuf[2];             // module ID: 0x7050/60/63/65/66/67/42/43/44
// wBuf[3];             // checksum: 0=disable, 1=enable
// wBuf[4];             // TimeOut constant: normal=100
// wBuf[5];             // don't care
// wBuf[6];             // flag: 0=no save, 1=save send/receive string
// wBuf[7];             // which channel to output
// wBuf[8];             // data to output (0 or 1)
//---------------------- output ------------------------------------
                         // void
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7060Addr;
	m_wBuf[2]=0x7060;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;
	m_wBuf[7]=0;
	m_wBuf[8]=(WORD)m_DO0.GetCheck();
	DigitalBitOut(m_wBuf, m_fBuf, m_szSend, m_szReceive);
}


void CDemoDlg::OnCheckDO1() 
{
	// TODO: Add your control notification handler code here
//Exp7K WORD CALLBACK DigitalBitOut(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];             // RS-232 port number: 1/2/3/4..../255
// wBuf[1];             // module address: 0x00 to 0xFF
// wBuf[2];             // module ID: 0x7050/60/63/65/66/67/42/43/44
// wBuf[3];             // checksum: 0=disable, 1=enable
// wBuf[4];             // TimeOut constant: normal=100
// wBuf[5];             // don't care
// wBuf[6];             // flag: 0=no save, 1=save send/receive string
// wBuf[7];             // which channel to output
// wBuf[8];             // data to output (0 or 1)
//---------------------- output ------------------------------------
                         // void
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7060Addr;
	m_wBuf[2]=0x7060;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;
	m_wBuf[7]=1;
	m_wBuf[8]=(WORD)m_DO1.GetCheck();
	DigitalBitOut(m_wBuf, m_fBuf, m_szSend, m_szReceive);	
}

void CDemoDlg::OnCheckDO2() 
{
	// TODO: Add your control notification handler code here
//Exp7K WORD CALLBACK DigitalBitOut(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];             // RS-232 port number: 1/2/3/4..../255
// wBuf[1];             // module address: 0x00 to 0xFF
// wBuf[2];             // module ID: 0x7050/60/63/65/66/67/42/43/44
// wBuf[3];             // checksum: 0=disable, 1=enable
// wBuf[4];             // TimeOut constant: normal=100
// wBuf[5];             // don't care
// wBuf[6];             // flag: 0=no save, 1=save send/receive string
// wBuf[7];             // which channel to output
// wBuf[8];             // data to output (0 or 1)
//---------------------- output ------------------------------------
                         // void
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7060Addr;
	m_wBuf[2]=0x7060;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;
	m_wBuf[7]=2;
	m_wBuf[8]=(WORD)m_DO2.GetCheck();
	DigitalBitOut(m_wBuf, m_fBuf, m_szSend, m_szReceive);	
}

void CDemoDlg::OnCheckDO3() 
{
	// TODO: Add your control notification handler code here
//Exp7K WORD CALLBACK DigitalBitOut(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];             // RS-232 port number: 1/2/3/4..../255
// wBuf[1];             // module address: 0x00 to 0xFF
// wBuf[2];             // module ID: 0x7050/60/63/65/66/67/42/43/44
// wBuf[3];             // checksum: 0=disable, 1=enable
// wBuf[4];             // TimeOut constant: normal=100
// wBuf[5];             // don't care
// wBuf[6];             // flag: 0=no save, 1=save send/receive string
// wBuf[7];             // which channel to output
// wBuf[8];             // data to output (0 or 1)
//---------------------- output ------------------------------------
                         // void
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7060Addr;
	m_wBuf[2]=0x7060;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;
	m_wBuf[7]=3;
	m_wBuf[8]=(WORD)m_DO3.GetCheck();
	DigitalBitOut(m_wBuf, m_fBuf, m_szSend, m_szReceive);	
}

void CDemoDlg::OnButtonManualDI() 
{
	// TODO: Add your control notification handler code here
	unsigned char InTemp=0;

//Exp7K WORD CALLBACK DigitalIn(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];             // RS-232 port number: 1/2/3/4..../255
// wBuf[1];             // module address: 0x00 to 0xFF
// wBuf[2];             // module ID: 0x7050/52/53/58/60/63/65/41/44/11/12/14/16
// wBuf[3];             // checksum: 0=disable, 1=enable
// wBuf[4];             // TimeOut constant: normal=100
// wBuf[6];             // flag: 0=no save, 1=save send/receive string
//---------------------- output ------------------------------------
                         // wBuf[5]=digital input data
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7060Addr;
	m_wBuf[2]=0x7060;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;

	DigitalIn(m_wBuf,m_fBuf,m_szSend,m_szReceive);

	InTemp=(unsigned char)m_wBuf[5];

	if ((InTemp&0x01)==0)
		m_DI0.SetBitmap(m_Off.GetBitmap());
	else
		m_DI0.SetBitmap(m_On.GetBitmap());
	if ((InTemp&0x02)==0)
		m_DI1.SetBitmap(m_Off.GetBitmap());
	else
		m_DI1.SetBitmap(m_On.GetBitmap());				
	if ((InTemp&0x04)==0)
		m_DI2.SetBitmap(m_Off.GetBitmap());
	else
		m_DI2.SetBitmap(m_On.GetBitmap());	
	if ((InTemp&0x08)==0)
		m_DI3.SetBitmap(m_Off.GetBitmap());
	else
		m_DI3.SetBitmap(m_On.GetBitmap());
}

void CDemoDlg::OnButtonAO() 
{
	// TODO: Add your control notification handler code here
//Exp7K WORD CALLBACK AnalogOut(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];   // RS-232 port number: 1/2/3/4..../255
// wBuf[1];   // module address: 0x00 to 0xFF
// wBuf[2];   // module ID: 0x7016/21/22/24
// wBuf[3];   // checksum: 0=disable, 1=enable
// wBuf[4];   // TimeOut constant: normal=100
// wBuf[5];   // Not used if module ID is 7016/7021
			  // Channel No.(0 to 1) if module ID is 7022
              // Channel No.(0 to 3) if module ID is 7024
// wBuf[6];   // flag: 0=no save, 1=save send/receive string
// fBuf[0];   // analog output value
//---------------------- output ------------------------------------
                           // void
	TCHAR temp[20],*stopstring;
	float AO;
	m_EditAO.GetWindowText(temp, 20);
	AO=(float)wcstod(temp, &stopstring);

	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7021Addr;
	m_wBuf[2]=0x7021;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;
	m_fBuf[0]=AO;
	AnalogOut(m_wBuf, m_fBuf, m_szSend, m_szReceive);
}

void CDemoDlg::OnButtonManualAI() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

//Exp7K WORD CALLBACK AnalogIn(WORD wBuf[], float fBuf[],
//        char szSend[], char szReceive[]);
//---------------------- input -------------------------------------
// wBuf[0];             // RS-232 port number: 1/2/3/4..../255
// wBuf[1];             // module address: 0x00 to 0xFF
// wBuf[2];             // module ID: 0x7011/12/13/14/16/17/18/33
// wBuf[3];             // checksum: 0=disable, 1=enable
// wBuf[4];             // TimeOut constant: normal=100
// wBuf[5];             // channel number for multi-channel
// wBuf[6];             // flag: 0=no save, 1=save send/receive string
//---------------------- output ------------------------------------
                         // fBuf[0]=analog input value
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7012Addr;
	m_wBuf[2]=0x7012;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[5]=0;
	m_wBuf[6]=0;
	AnalogIn(m_wBuf, m_fBuf, m_szSend, m_szReceive);
	swprintf(temp, _T("%.3f"), m_fBuf[0]);
	m_EditAI.SetWindowText(temp);
}

void CDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	unsigned char InTemp=0;
	TCHAR temp[20];
//Auto Scan DI
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7060Addr;
	m_wBuf[2]=0x7060;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[6]=0;

	DigitalIn(m_wBuf,m_fBuf,m_szSend,m_szReceive);

	InTemp=(unsigned char)m_wBuf[5];

	if ((InTemp&0x01)==0)
		m_DI0.SetBitmap(m_Off.GetBitmap());
	else
		m_DI0.SetBitmap(m_On.GetBitmap());
	if ((InTemp&0x02)==0)
		m_DI1.SetBitmap(m_Off.GetBitmap());
	else
		m_DI1.SetBitmap(m_On.GetBitmap());				
	if ((InTemp&0x04)==0)
		m_DI2.SetBitmap(m_Off.GetBitmap());
	else
		m_DI2.SetBitmap(m_On.GetBitmap());	
	if ((InTemp&0x08)==0)
		m_DI3.SetBitmap(m_Off.GetBitmap());
	else
		m_DI3.SetBitmap(m_On.GetBitmap());	

//Auto Scan AI
	m_wBuf[0]=m_ComPort;
	m_wBuf[1]=m_7012Addr;
	m_wBuf[2]=0x7012;
	m_wBuf[3]=m_Checksum;
	m_wBuf[4]=m_TimeOut;
	m_wBuf[5]=0;
	m_wBuf[6]=0;
	AnalogIn(m_wBuf, m_fBuf, m_szSend, m_szReceive);
	swprintf(temp, _T("%.3f"), m_fBuf[0]);
	m_EditAI.SetWindowText(temp);
	CDialog::OnTimer(nIDEvent);
}

void CDemoDlg::OnButtonAutoScan() 
{
	// TODO: Add your control notification handler code here
	if (timerOn)
	{
		timerOn=false;
		m_BtnAutoScan.SetWindowText(_T("Auto Scan DI/AI Enable"));
		m_BtnManualDI.EnableWindow(true);
		m_BtnManualAI.EnableWindow(true);
		KillTimer(100);
	}
	else
	{
		timerOn=true;
		m_BtnAutoScan.SetWindowText(_T("Auto Scan DI/AI Disable"));
		m_BtnManualDI.EnableWindow(false);
		m_BtnManualAI.EnableWindow(false);
		SetTimer(100,100,NULL);
	}		
}
