// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

//ICP DAS use .h files
#include "WinconSDK.h"
#include "UARTCE.h"
#include "I7000CE.h"

#define i87055	0x87055
#define i87024	0x87024
#define i87017	0x87017
#define i87055_slot	1
#define i87024_slot	2
#define i87017_slot	3
//define i-87K default setting value
#define comport	1  //com port of Wincon-8000 slot is 1.
#define baudrate 115200	
#define	address	0
#define parity	0
#define timeout 100
#define checksum 0
#define databit	8
#define stopbit	0
#define flag	0

//define basic var
bool timerOnDI=false;
bool timerOnAI=false;
static DWORD m_dwBuf[12];
static float m_fBuf[12];
static char  m_szSend[100];
static char  m_szReceive[100];

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_EDIT12, m_AI7);
	DDX_Control(pDX, IDC_EDIT11, m_AI6);
	DDX_Control(pDX, IDC_EDIT10, m_AI5);
	DDX_Control(pDX, IDC_EDIT9, m_AI4);
	DDX_Control(pDX, IDC_EDIT8, m_AI3);
	DDX_Control(pDX, IDC_EDIT7, m_AI2);
	DDX_Control(pDX, IDC_EDIT6, m_AI1);
	DDX_Control(pDX, IDC_EDIT5, m_AI0);
	DDX_Control(pDX, IDC_EDIT4, m_AO3);
	DDX_Control(pDX, IDC_EDIT3, m_AO2);
	DDX_Control(pDX, IDC_EDIT2, m_AO1);
	DDX_Control(pDX, IDC_EDIT1, m_AO0);
	DDX_Control(pDX, IDC_BUTTON6, m_BtnManualAI);
	DDX_Control(pDX, IDC_BUTTON5, m_BtnAutoAI);
	DDX_Control(pDX, IDC_BUTTON3, m_BtnManualDI);
	DDX_Control(pDX, IDC_BUTTON2, m_BtnAutoDI);
	DDX_Control(pDX, IDC_STATICON, m_On);
	DDX_Control(pDX, IDC_STATICOFF, m_Off);
	DDX_Control(pDX, IDC_STATICDI7, m_DI7);
	DDX_Control(pDX, IDC_STATICDI6, m_DI6);
	DDX_Control(pDX, IDC_STATICDI5, m_DI5);
	DDX_Control(pDX, IDC_STATICDI4, m_DI4);
	DDX_Control(pDX, IDC_STATICDI3, m_DI3);
	DDX_Control(pDX, IDC_STATICDI2, m_DI2);
	DDX_Control(pDX, IDC_STATICDI1, m_DI1);
	DDX_Control(pDX, IDC_STATICDI0, m_DI0);
	DDX_Control(pDX, IDC_CHECK8, m_DO7);
	DDX_Control(pDX, IDC_CHECK7, m_DO6);
	DDX_Control(pDX, IDC_CHECK6, m_DO5);
	DDX_Control(pDX, IDC_CHECK5, m_DO4);
	DDX_Control(pDX, IDC_CHECK4, m_DO3);
	DDX_Control(pDX, IDC_CHECK3, m_DO2);
	DDX_Control(pDX, IDC_CHECK2, m_DO1);
	DDX_Control(pDX, IDC_CHECK1, m_DO0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButtonDigitalOutput)
	ON_BN_CLICKED(IDC_BUTTON3, OnButtonManualDI)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON2, OnButtonAutoScanDI)
	ON_BN_CLICKED(IDC_BUTTON4, OnButtonAnalogOutput)
	ON_BN_CLICKED(IDC_BUTTON6, OnButtonManualAI)
	ON_BN_CLICKED(IDC_BUTTON5, OnButtonAutoAI)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here

	//Open COM1 on slot of Wincon-8000
	
	Open_Com(comport, baudrate, databit, parity, stopbit);

	m_AO0.SetWindowText(_T("0"));
	m_AO1.SetWindowText(_T("0"));
	m_AO2.SetWindowText(_T("0"));
	m_AO3.SetWindowText(_T("0"));
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CDemoDlg::OnButtonDigitalOutput() 
{
	// TODO: Add your control notification handler code here
	unsigned char OutTemp=0;
	OutTemp=(m_DO0.GetCheck()==1)?(OutTemp|0x01):(OutTemp&0xFE);
	OutTemp=(m_DO1.GetCheck()==1)?(OutTemp|0x02):(OutTemp&0xFD);
	OutTemp=(m_DO2.GetCheck()==1)?(OutTemp|0x04):(OutTemp&0xFB);
	OutTemp=(m_DO3.GetCheck()==1)?(OutTemp|0x08):(OutTemp&0xF7);
	OutTemp=(m_DO4.GetCheck()==1)?(OutTemp|0x10):(OutTemp&0xEF);
	OutTemp=(m_DO5.GetCheck()==1)?(OutTemp|0x20):(OutTemp&0xDF);
	OutTemp=(m_DO6.GetCheck()==1)?(OutTemp|0x40):(OutTemp&0xBF);
	OutTemp=(m_DO7.GetCheck()==1)?(OutTemp|0x80):(OutTemp&0x7F);

//---------------------- input -------------------------------------
// dwBuf[0];             // RS-232 port number: 1/2/3/4..../255
// dwBuf[1];             // module address: 0x00 to 0xFF
// dwBuf[2];             // module ID: 0x87054/55/56/57/60/63/64/65/66/68
// dwBuf[3];             // checksum: 0=disable, 1=enable
// dwBuf[4];             // TimeOut constant: normal=100
// dwBuf[5];             // 16-bit digital data to output
// dwBuf[6];             // flag: 0=no save, 1=save send/receive string
	m_dwBuf[0]=comport;
	m_dwBuf[1]=address;
	m_dwBuf[2]=i87055;
	m_dwBuf[3]=checksum;
	m_dwBuf[4]=timeout;
	m_dwBuf[5]=OutTemp;
	m_dwBuf[6]=flag;

	ChangeSlotTo87K(i87055_slot);
	DigitalOut_87K(m_dwBuf,m_fBuf,m_szSend,m_szReceive);
}

void CDemoDlg::OnButtonManualDI() 
{
	// TODO: Add your control notification handler code here
	unsigned char InTemp=0;
//---------------------- input -------------------------------------
// dwBuf[0];             // RS-232 port number: 1/2/3/4..../255
// dwBuf[1];             // module address: 0x00 to 0xFF
// dwBuf[2];             // module ID: 0x8051/52/53/54/55/63
// dwBuf[3];             // checksum: 0=disable, 1=enable
// dwBuf[4];             // TimeOut constant: normal=100

// dwBuf[6];             // flag: 0=no save, 1=save send/receive string
//---------------------- output ------------------------------------
                         // dwBuf[5]; // Read 16-bit input digital data
	m_dwBuf[0]=comport;
	m_dwBuf[1]=address;
	m_dwBuf[2]=i87055;
	m_dwBuf[3]=checksum;
	m_dwBuf[4]=timeout;
	m_dwBuf[6]=flag;

	ChangeSlotTo87K(i87055_slot);
	DigitalIn_87K(m_dwBuf,m_fBuf,m_szSend,m_szReceive);

	InTemp=(unsigned char)m_dwBuf[5];

	if ((InTemp&0x01)==0)
		m_DI0.SetBitmap(m_Off.GetBitmap());
	else
		m_DI0.SetBitmap(m_On.GetBitmap());
	if ((InTemp&0x02)==0)
		m_DI1.SetBitmap(m_Off.GetBitmap());
	else
		m_DI1.SetBitmap(m_On.GetBitmap());				
	if ((InTemp&0x04)==0)
		m_DI2.SetBitmap(m_Off.GetBitmap());
	else
		m_DI2.SetBitmap(m_On.GetBitmap());	
	if ((InTemp&0x08)==0)
		m_DI3.SetBitmap(m_Off.GetBitmap());
	else
		m_DI3.SetBitmap(m_On.GetBitmap());

	if ((InTemp&0x10)==0)
		m_DI4.SetBitmap(m_Off.GetBitmap());
	else
		m_DI4.SetBitmap(m_On.GetBitmap());
	if ((InTemp&0x20)==0)
		m_DI5.SetBitmap(m_Off.GetBitmap());
	else
		m_DI5.SetBitmap(m_On.GetBitmap());
	if ((InTemp&0x40)==0)
		m_DI6.SetBitmap(m_Off.GetBitmap());
	else
		m_DI6.SetBitmap(m_On.GetBitmap());
	if ((InTemp&0x80)==0)
		m_DI7.SetBitmap(m_Off.GetBitmap());
	else
		m_DI7.SetBitmap(m_On.GetBitmap());	
}

void CDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	unsigned char InTemp=0;
	TCHAR temp[20];
	float m_fAI[8];	
	int i;

	switch (nIDEvent)
	{
		case 100:
				m_dwBuf[0]=comport;
				m_dwBuf[1]=address;
				m_dwBuf[2]=i87055;
				m_dwBuf[3]=checksum;
				m_dwBuf[4]=timeout;
				m_dwBuf[6]=flag;

				ChangeSlotTo87K(i87055_slot);
				DigitalIn_87K(m_dwBuf,m_fBuf,m_szSend,m_szReceive);

				InTemp=(unsigned char)m_dwBuf[5];

				if ((InTemp&0x01)==0)
					m_DI0.SetBitmap(m_Off.GetBitmap());
				else
					m_DI0.SetBitmap(m_On.GetBitmap());
				if ((InTemp&0x02)==0)
					m_DI1.SetBitmap(m_Off.GetBitmap());
				else
					m_DI1.SetBitmap(m_On.GetBitmap());				
				if ((InTemp&0x04)==0)
					m_DI2.SetBitmap(m_Off.GetBitmap());
				else
					m_DI2.SetBitmap(m_On.GetBitmap());	
				if ((InTemp&0x08)==0)
					m_DI3.SetBitmap(m_Off.GetBitmap());
				else
					m_DI3.SetBitmap(m_On.GetBitmap());

				if ((InTemp&0x10)==0)
					m_DI4.SetBitmap(m_Off.GetBitmap());
				else
					m_DI4.SetBitmap(m_On.GetBitmap());
				if ((InTemp&0x20)==0)
					m_DI5.SetBitmap(m_Off.GetBitmap());
				else
					m_DI5.SetBitmap(m_On.GetBitmap());
				if ((InTemp&0x40)==0)
					m_DI6.SetBitmap(m_Off.GetBitmap());
				else
					m_DI6.SetBitmap(m_On.GetBitmap());
				if ((InTemp&0x80)==0)
					m_DI7.SetBitmap(m_Off.GetBitmap());
				else
					m_DI7.SetBitmap(m_On.GetBitmap());	
			break;
		case 101:
				m_dwBuf[0]=comport;
				m_dwBuf[1]=address;
				m_dwBuf[2]=i87017;
				m_dwBuf[3]=checksum;
				m_dwBuf[4]=timeout;
				m_dwBuf[6]=flag;
				ChangeSlotTo87K(i87017_slot);
				AnalogInAll_87K(m_dwBuf,m_fBuf,m_szSend,m_szReceive);
				for(i=0; i<8; i++)
				{
					m_fAI[i]=m_fBuf[i];
				}

				swprintf(temp, _T("%.3f"), m_fAI[0]);
				m_AI0.SetWindowText(temp);	
				swprintf(temp, _T("%.3f"), m_fAI[1]);
				m_AI1.SetWindowText(temp);
				swprintf(temp, _T("%.3f"), m_fAI[2]);
				m_AI2.SetWindowText(temp);
				swprintf(temp, _T("%.3f"), m_fAI[3]);
				m_AI3.SetWindowText(temp);
				swprintf(temp, _T("%.3f"), m_fAI[4]);
				m_AI4.SetWindowText(temp);
				swprintf(temp, _T("%.3f"), m_fAI[5]);
				m_AI5.SetWindowText(temp);
				swprintf(temp, _T("%.3f"), m_fAI[6]);
				m_AI6.SetWindowText(temp);
				swprintf(temp, _T("%.3f"), m_fAI[7]);
				m_AI7.SetWindowText(temp);

			break;
	}
	CDialog::OnTimer(nIDEvent);
}

void CDemoDlg::OnButtonAutoScanDI() 
{
	// TODO: Add your control notification handler code here
	if (timerOnDI)
	{
		timerOnDI=false;
		m_BtnAutoDI.SetWindowText(_T("Auto Scan DI Enable"));
		m_BtnManualDI.EnableWindow(true);
		KillTimer(100);
	}
	else
	{
		timerOnDI=true;
		m_BtnAutoDI.SetWindowText(_T("Auto Scan DI Disable"));
		m_BtnManualDI.EnableWindow(false);
		SetTimer(100,100,NULL);
	}	
}

void CDemoDlg::OnButtonAnalogOutput() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20],*stopstring;
	float m_fAO[4];

	m_AO0.GetWindowText(temp, 20);
	m_fAO[0]=(float)wcstod(temp, &stopstring);
	m_AO1.GetWindowText(temp, 20);
	m_fAO[1]=(float)wcstod(temp, &stopstring);
	m_AO2.GetWindowText(temp, 20);
	m_fAO[2]=(float)wcstod(temp, &stopstring);
	m_AO3.GetWindowText(temp, 20);
	m_fAO[3]=(float)wcstod(temp, &stopstring);

	ChangeSlotTo87K(i87024_slot);
	for(int i=0; i<4; i++)
	{
//---------------------- input -------------------------------------
// dwBuf[0];   // RS-232 port number: 1/2/3/4..../255
// dwBuf[1];   // module address: 0x00 to 0xFF
// dwBuf[2];   // module ID: 0x87024
// dwBuf[3];   // checksum: 0=disable, 1=enable
// dwBuf[4];   // TimeOut constant: normal=100
// dwBuf[5];   // Channel No.(0 to 3) 
// dwBuf[6];   // flag: 0=no save, 1=save send/receive string
// m_fBuf[0];   // analog output value
//---------------------- output ------------------------------------
// void 
		m_dwBuf[0]=comport;
		m_dwBuf[1]=address;
		m_dwBuf[2]=i87024;
		m_dwBuf[3]=checksum;
		m_dwBuf[4]=timeout;
		m_dwBuf[5]=i;
		m_dwBuf[6]=flag;
		m_fBuf[0]=m_fAO[i];
		AnalogOut_87K(m_dwBuf,m_fBuf,m_szSend,m_szReceive);
	}
}

void CDemoDlg::OnButtonManualAI() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	float m_fAI[8];	
	int i;

/*
====== Input parameter ====================================
 dwBuf[0]; RS-232 port number: 1 ~ 255
 dwBuf[1]; Module address: 0x00 ~ 0xFF
 dwBuf[2]; Module ID:	0x87013 for I-87013,
						0x87017 for I-87017,
						0x87018 for I-87018
 dwBuf[3]; Checksum: 0=disable, 1=enable
 dwBuf[4]; TimeOut: Normal=100 (ms)
 dwBuf[6]; Debug:	0=disable
					1=enable:	copy command string (sent to module)
								to szSend and response string (received from module)
								to szReceive.
 dwBuf[7];				// Data Foramt, 0:Engineer 1:FSR  2:Hex
====== Output parameter ===================================
 if dwBuf[2] is 0x87013
 fBuf[0]=analog input value of channel_0
 fBuf[1]=analog input value of channel_1
 fBuf[2]=analog input value of channel_2
 fBuf[3]=analog input value of channel_3

 if dwBuf[2] is 0x87017/18
 fBuf[0]=analog input value of channel_0
 fBuf[1]=analog input value of channel_1
 ........................................
 fBuf[7]=analog input value of channel_7
*/
	
	m_dwBuf[0]=comport;
	m_dwBuf[1]=address;
	m_dwBuf[2]=i87017;
	m_dwBuf[3]=checksum;
	m_dwBuf[4]=timeout;
	m_dwBuf[6]=flag;
	ChangeSlotTo87K(i87017_slot);
	AnalogInAll_87K(m_dwBuf,m_fBuf,m_szSend,m_szReceive);
	for(i=0; i<8; i++)
	{
		m_fAI[i]=m_fBuf[i];
	}

	swprintf(temp, _T("%.3f"), m_fAI[0]);
	m_AI0.SetWindowText(temp);	
	swprintf(temp, _T("%.3f"), m_fAI[1]);
	m_AI1.SetWindowText(temp);
	swprintf(temp, _T("%.3f"), m_fAI[2]);
	m_AI2.SetWindowText(temp);
	swprintf(temp, _T("%.3f"), m_fAI[3]);
	m_AI3.SetWindowText(temp);
	swprintf(temp, _T("%.3f"), m_fAI[4]);
	m_AI4.SetWindowText(temp);
	swprintf(temp, _T("%.3f"), m_fAI[5]);
	m_AI5.SetWindowText(temp);
	swprintf(temp, _T("%.3f"), m_fAI[6]);
	m_AI6.SetWindowText(temp);
	swprintf(temp, _T("%.3f"), m_fAI[7]);
	m_AI7.SetWindowText(temp);

}

void CDemoDlg::OnButtonAutoAI() 
{
	// TODO: Add your control notification handler code here
	if (timerOnAI)
	{
		timerOnAI=false;
		m_BtnAutoAI.SetWindowText(_T("Auto Scan AI Enable"));
		m_BtnManualAI.EnableWindow(true);
		KillTimer(101);
	}
	else
	{
		timerOnAI=true;
		m_BtnAutoAI.SetWindowText(_T("Auto Scan AI Disable"));
		m_BtnManualAI.EnableWindow(false);
		SetTimer(101,100,NULL);
	}		
}


