// Freq1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Freq1.h"
#include "Freq1Dlg.h"
#include "WinconSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int slot=1;
bool AutoRead=false;
int chA0=0;
int chB3=7;

short AutoTT;			// time period for auto mode, unit=mS
short AutoVV;			// min. counts to upadte frequency
short LowTT,LowVV;		// for Low Frequency Mode
short HighTT,HighVV;		// for High Frequency Mode	




/////////////////////////////////////////////////////////////////////////////
// CFreq1Dlg dialog

CFreq1Dlg::CFreq1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFreq1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFreq1Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFreq1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFreq1Dlg)
	DDX_Control(pDX, IDC_EDIT20, m_C6);
	DDX_Control(pDX, IDC_EDIT19, m_C5);
	DDX_Control(pDX, IDC_EDIT18, m_C4);
	DDX_Control(pDX, IDC_EDIT17, m_C3);
	DDX_Control(pDX, IDC_EDIT16, m_C2);
	DDX_Control(pDX, IDC_EDIT15, m_C1);
	DDX_Control(pDX, IDC_EDIT14, m_DiXor);
	DDX_Control(pDX, IDC_EDIT13, m_Register);
	DDX_Control(pDX, IDC_BUTTON3, m_AutoReadBtn);
	DDX_Control(pDX, IDC_BUTTON4, m_ReadBtn);
	DDX_Control(pDX, IDC_EDIT12, m_B3Value);
	DDX_Control(pDX, IDC_EDIT11, m_A0Value);
	DDX_Control(pDX, IDC_EDIT10, m_B3);
	DDX_Control(pDX, IDC_EDIT9, m_B2);
	DDX_Control(pDX, IDC_EDIT8, m_B1);
	DDX_Control(pDX, IDC_EDIT7, m_B0);
	DDX_Control(pDX, IDC_EDIT6, m_A3);
	DDX_Control(pDX, IDC_EDIT5, m_A2);
	DDX_Control(pDX, IDC_EDIT4, m_A1);
	DDX_Control(pDX, IDC_EDIT3, m_A0);
	DDX_Control(pDX, IDC_EDIT2, m_SetMode);
	DDX_Control(pDX, IDC_EDIT1, m_Slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFreq1Dlg, CDialog)
	//{{AFX_MSG_MAP(CFreq1Dlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnSetModeBtn)
	ON_BN_CLICKED(IDC_BUTTON2, OnReadModeBtn)
	ON_BN_CLICKED(IDC_BUTTON3, OnAutoReadBtn)
	ON_BN_CLICKED(IDC_BUTTON4, OnReadBtn)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON5, OnRegisterBtn)
	ON_BN_CLICKED(IDC_BUTTON6, OnDiXorBtn)
	ON_BN_CLICKED(IDC_BUTTON7, OnReadConfigBtn)
	ON_BN_CLICKED(IDC_BUTTON8, OnSetConfigBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFreq1Dlg message handlers

BOOL CFreq1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	int i;
	TCHAR temp[20];
	int mode=0x02;

	swprintf(temp,_T("%d"), mode);

	m_SetMode.SetWindowText(temp);

	for(slot=1; slot<8; slot++)
	{
		i=i8080_InitDriver(slot);
		if (!i)
		{
			swprintf(temp, _T("%d"), slot);
			m_Slot.SetWindowText(temp);
			SetTimer(100, 3, NULL);   // scan every 3 ms
			break;
		}
	}

	i8080_ReadFreqConfiguration(slot,&AutoTT,&AutoVV,&LowTT,&LowVV,&HighTT,&HighVV);

	swprintf(temp,_T("%d"), AutoTT);
	m_C1.SetWindowText(temp);

	swprintf(temp,_T("%d"), AutoVV);
	m_C2.SetWindowText(temp);

	swprintf(temp,_T("%d"), LowTT);
	m_C3.SetWindowText(temp);

	swprintf(temp,_T("%d"), LowVV);
	m_C4.SetWindowText(temp);

	swprintf(temp,_T("%d"), HighTT);
	m_C5.SetWindowText(temp);

	swprintf(temp,_T("%d"), HighVV);
	m_C6.SetWindowText(temp);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CFreq1Dlg::OnSetModeBtn() 
{
	// TODO: Add your control notification handler code here
	int mode=3;
	TCHAR temp[10];

	m_SetMode.GetWindowText(temp,10);
	mode=_ttoi(temp);

	i8080_SetChannelMode(slot,chA0,mode);// Channel_A0, frequemcy, auto mode = 0x02

	i8080_SetChannelMode(slot,chB3,mode);// Channel_B3, frequemcy, auto mode = 0x02
				       // Xor=0, isolated + active_Low	
}

void CFreq1Dlg::OnReadModeBtn() 
{
	// TODO: Add your control notification handler code here
	int i;
	short mode=3;
	short V[8];
	TCHAR temp[20];
	for (i=0; i<8; i++)
	{
		i8080_ReadChannelMode(slot,i,&mode);
		V[i]=mode;
	}

	swprintf(temp,_T("%02X"),V[0]);
	m_A0.SetWindowText(temp);
	
	swprintf(temp,_T("%02X"),V[1]);
	m_A1.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[2]);
	m_A2.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[3]);
	m_A3.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[4]);
	m_B0.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[5]);
	m_B1.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[6]);
	m_B2.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[7]);
	m_B3.SetWindowText(temp);	
}

void CFreq1Dlg::OnAutoReadBtn() 
{
	// TODO: Add your control notification handler code here
	if (!AutoRead)
	{
		SetTimer(101,300,NULL);	
		m_AutoReadBtn.SetWindowText(_T("Disable Auto Read"));
		AutoRead=true;
		m_ReadBtn.EnableWindow(false);		
	}
	else
	{
		KillTimer(101);
		m_AutoReadBtn.SetWindowText(_T("Enable Auto Read"));
		AutoRead=false;
		m_ReadBtn.EnableWindow(true);
	}		
}

void CFreq1Dlg::OnReadBtn() 
{
	// TODO: Add your control notification handler code here
	float f;
	TCHAR temp[80];

	i8080_ReadFreq(slot, chA0, &f);  // Read i-8080 Freq Value Channel A0
	swprintf(temp,_T("%.1f"), f);    
	m_A0Value.SetWindowText(temp);   // Show FreqValue to Edit Box

	i8080_ReadFreq(slot, chB3, &f);  // Read i-8080 Freq Value Channel B3
	swprintf(temp,_T("%.1f"), f);    
	m_B3Value.SetWindowText(temp);   // Show FreqValue to Edit Box	
}

void CFreq1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	float f;
	TCHAR temp[80];

	switch (nIDEvent)
	{
		case 100:
			i8080_AutoScan();
			break;
		case 101:
			i8080_ReadFreq(slot, chA0, &f);  // Read i-8080 Freq Value Channel A0
			swprintf(temp,_T("%.1f"), f);    
			m_A0Value.SetWindowText(temp);   // Show FreqValue to Edit Box

			i8080_ReadFreq(slot, chB3, &f);  // Read i-8080 Freq Value Channel B3
			swprintf(temp,_T("%.1f"), f);    
			m_B3Value.SetWindowText(temp);   // Show FreqValue to Edit Box	
			break;
	}	

	CDialog::OnTimer(nIDEvent);
}

void CFreq1Dlg::OnRegisterBtn() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[80];
	short j;
	i8080_ReadXorRegister(slot, &j);
	swprintf(temp,_T("%2X"), j);
	m_Register.SetWindowText(temp);	
}

void CFreq1Dlg::OnDiXorBtn() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[80];
	short j;
	i8080_ReadDiXor(slot,&j);
	swprintf(temp,_T("%2X"),j);
	m_DiXor.SetWindowText(temp);	
}

void CFreq1Dlg::OnReadConfigBtn() 
{
	// TODO: Add your control notification handler code here

	i8080_ReadFreqConfiguration(slot,&AutoTT,&AutoVV,&LowTT,&LowVV,&HighTT,&HighVV);

	TCHAR temp[80];

	swprintf(temp,_T("%d"), AutoTT);
	m_C1.SetWindowText(temp);

	swprintf(temp,_T("%d"), AutoVV);
	m_C2.SetWindowText(temp);

	swprintf(temp,_T("%d"), LowTT);
	m_C3.SetWindowText(temp);

	swprintf(temp,_T("%d"), LowVV);
	m_C4.SetWindowText(temp);

	swprintf(temp,_T("%d"), HighTT);
	m_C5.SetWindowText(temp);

	swprintf(temp,_T("%d"), HighVV);
	m_C6.SetWindowText(temp);

}



void CFreq1Dlg::OnSetConfigBtn() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	m_C1.GetWindowText(temp,20);
	AutoTT=(short)_ttoi(temp);

	m_C2.GetWindowText(temp,20);
	AutoVV=(short)_ttoi(temp);

	m_C3.GetWindowText(temp,20);
	LowTT=(short)_ttoi(temp);

	m_C4.GetWindowText(temp,20);
	LowVV=(short)_ttoi(temp);

	m_C5.GetWindowText(temp,20);
	HighTT=(short)_ttoi(temp);

	m_C6.GetWindowText(temp,20);
	HighVV=(short)_ttoi(temp);

	i8080_SetFreqConfiguration(slot,AutoTT,AutoVV,LowTT,LowVV,HighTT,HighVV);
}
