﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using System.Net;
using System.Reflection;

namespace TcpServerClient_CE
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.Text = "TcpServerClient_CE  v" + Assembly.GetExecutingAssembly().GetName().Version.ToString();

            radioButtonServer.Checked = true;

            buttonClose.Enabled = false;
            panel2.Enabled = false;
            buttonTimerStop.Enabled = false;
            buttonSend.Enabled = false;
        }

        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            try { thRecv.Abort(); }
            catch { }

            try { client.Close(); }
            catch { }

            try { listen.Stop(); }
            catch { }
        }

        TcpListener listen;
        TcpClient client;
        NetworkStream ns;
        Thread thRecv;

        void Recv()
        {
            byte[] buff = new byte[1024];
            int n;

            while (true)
            {
                try
                {
                    n = ns.Read(buff, 0, 1024);
                    strReceive = Encoding.ASCII.GetString(buff, 0, n);
                    //myUI_txt(Encoding.ASCII.GetString(buff, 0, n), textBoxReceive);
                    this.Invoke(new EventHandler(HandleReceive));

                }
                catch (Exception ex)
                {
                    thRecv.Abort();
                    MessageBox.Show(ex.Message);
                }
            }
        }

        string strReceive = "";
        string strCheckData = "";
        int ErrorCnt = 0;

        private void HandleReceive(object sender, EventArgs e)
        {
            if (checkBoxResponseTime.Checked)
            {
                dtEnd = DateTime.Now;
                textBoxRtt.Text = (dtEnd - dtStart).TotalMilliseconds.ToString();
                textBoxAvgRtt.Text = ((dtEnd - dtConst).TotalMilliseconds / SendCntRtt).ToString();
            }

            textBoxSendCnt.Text = SendCnt.ToString();

            if (!checkBoxDontDisplay.Checked)
            {
                textBoxReceive.Text += strReceive;
            }

            if (strReceive != strCheckData && strCheckData != "")
            {
                ErrorCnt++;
                textBoxErrCnt.Text = ErrorCnt.ToString();
            }

            strCheckData = strReceive;

            if (checkBoxAutoEcho.Checked)
            {
                buttonSend_Click(sender, e);
            }
        }

        void Check_Connect()
        {
            Thread.Sleep(777);
            try
            {
                if (client.Client.Connected == false)
                { client.Client.Close(); }
            }
            catch { }
        }

        private void Listener()
        {
            try
            {
                listen = new TcpListener(IPAddress.Any, iPort);
                listen.Start();
                client = listen.AcceptTcpClient();
                ns = client.GetStream();

                thRecv = new Thread(Recv);
                thRecv.Start();
            }

            catch (SocketException ex)
            {
                listen.Stop();
                MessageBox.Show(ex.Message);
            }
        }

        int iPort;

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            try
            {
                if (radioButtonServer.Checked)
                {
                    iPort = Convert.ToInt32(textBoxPort.Text);
                    Thread th = new Thread(Listener);
                    th.Start();
                }
                else
                {
                    Thread nT = new Thread(Check_Connect);
                    nT.Start();

                    client = new TcpClient();
                    client.Connect(textBoxIP.Text, Convert.ToInt32(textBoxPort.Text));
                    ns = client.GetStream();

                    thRecv = new Thread(Recv);
                    thRecv.Start();
                }

                radioButtonClient.Enabled = false;
                radioButtonServer.Enabled = false;
                buttonConnect.Enabled = false;
                buttonClose.Enabled = true;
                panel2.Enabled = true;
                buttonSend.Enabled = true;
            }
            catch (Exception ex)
            {
                client.Close();
                MessageBox.Show(ex.Message);
            }
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            radioButtonClient.Enabled = true;
            radioButtonServer.Enabled = true;
            buttonConnect.Enabled = true;
            buttonClose.Enabled = false;
            panel2.Enabled = false;
            buttonSend.Enabled = false;

            try { thRecv.Abort(); }
            catch { }

            try { client.Close(); }
            catch { }

            try { listen.Stop(); }
            catch { }
        }

        DateTime dtStart;
        DateTime dtEnd;
        bool IsFirstClick = false;
        DateTime dtConst;

        int SendCnt = 0;
        int SendCntRtt = 0;

        private void buttonSend_Click(object sender, EventArgs e)
        {
            if (checkBoxResponseTime.Checked)
            {
                SendCnt++;
                SendCntRtt++;

                textBoxSendCnt.Text = SendCntRtt.ToString();

                dtStart = DateTime.Now;

                if (!IsFirstClick)
                {
                    IsFirstClick = true;
                    dtConst = DateTime.Now;
                }
            }

            try
            {
                ns.Write(Encoding.ASCII.GetBytes(textBoxData.Text), 0, textBoxData.Text.Length);
            }
            catch { }
        }

        private void buttonTimerStart_Click(object sender, EventArgs e)
        {
            timer1.Interval = Convert.ToInt32(textBoxTimerInterval.Text);
            timer1.Enabled = true;
            buttonTimerStart.Enabled = false;
            buttonTimerStop.Enabled = true;
        }

        private void buttonTimerStop_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            buttonTimerStart.Enabled = true;
            buttonTimerStop.Enabled = false;
        }

        private void buttonClearReceive_Click(object sender, EventArgs e)
        {
            textBoxReceive.Text = "";
        }

        private void radioButtonServerClient_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonServer.Checked)
            {
                textBoxIP.Visible = false;
                buttonConnect.Text = "Listener";
            }
            else
            {
                textBoxIP.Visible = true;
                buttonConnect.Text = "Connect";
            }
        }

        private void buttonErrCntClear_Click(object sender, EventArgs e)
        {
            ErrorCnt = 0;
            textBoxErrCnt.Text = "0";
        }

        private void buttonRttClear_Click(object sender, EventArgs e)
        {
            IsFirstClick = false;
            textBoxRtt.Text = "0";
            textBoxAvgRtt.Text = "0";
        }

        private void buttonSendCntClear_Click(object sender, EventArgs e)
        {
            SendCnt = 0;
            textBoxSendCnt.Text = "0";
        }
    }
}