﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace _87k_ai
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            cmbSlot.SelectedIndex = 1;
        }

        private void btnReadAI_Click(object sender, EventArgs e)
        {
            IntPtr hPort;

            //AIValue is read data parameter
            float AIValue=0;
            bool iRet;
            int intSlot;

            //Get slot data
            intSlot = Convert.ToInt16(cmbSlot.Text);

            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Read and get data
            iRet = PACNET.PAC_IO.ReadAI(hPort, intSlot, Convert.ToInt32(txtChannelRead.Text), Convert.ToInt16(txtChannel.Text), ref AIValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                txtAIValue.Text = Convert.ToString(AIValue);
            }

            PACNET.UART.Close(hPort);

        }

        private void button1_Click(object sender, EventArgs e)
        {
            IntPtr hPort;

            int buffsize = Convert.ToInt16(txtChannel.Text);

            //AIValue is read data parameter
            float[] AIValue = new float[buffsize];
            bool iRet;
            int intSlot;

            int len = 0;

            //Get slot data
            intSlot = Convert.ToInt16(cmbSlot.Text);

            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Read and get data
            iRet = PACNET.PAC_IO.ReadAIAllExt(
                hPort, 
                intSlot, 
                AIValue,
                buffsize,
                ref len);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                textBox1.Text = "";

                for (int i = 0; i < buffsize; i++)
                {
                    textBox1.Text += i + ": " + AIValue[i] + "\r\n";
                }

                textBox1.Text += "real total channel: " + len + "\r\n";
            }

            PACNET.UART.Close(hPort);           
        }
    }
}