﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _87k_ao
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            //Set default slot
            cmbSlot.SelectedIndex = 1;
        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            bool iRet;
            IntPtr hPort;

            //Get slot data
            int intSlot = Convert.ToInt16(cmbSlot.Text);

            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Write data
            iRet = PACNET.PAC_IO.WriteAO(hPort, intSlot, Convert.ToInt16(txtChannelWrite.Text), Convert.ToInt16(txtChannel.Text), Convert.ToSingle(txtAOValue.Text));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            //Close com port
            PACNET.UART.Close(hPort);
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            bool iRet;
            IntPtr hPort;
            
            //Get slot data
            int intSlot = Convert.ToInt16(cmbSlot.Text);

            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Write ao data be '0' to clear
            iRet = PACNET.PAC_IO.WriteAO(hPort, intSlot, Convert.ToInt16(txtChannelWrite.Text), Convert.ToInt16(txtChannel.Text), 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }
    }
}