﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;




namespace _87k_ao_poweron_safe
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cmbDOSlot.SelectedIndex = 3;
        }

        int iSlot;
        int iCurrentCh;
        int iTotalCh;
        float fValue;

        private void GetTxtValue()
        {
            iSlot = Convert.ToInt32(cmbDOSlot.Text);
            iCurrentCh = Convert.ToInt32(txtCurrentCH.Text);
            iTotalCh = Convert.ToInt32(txtTotalCH.Text);
            fValue = Convert.ToSingle(txtValue.Text);
        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            IntPtr hPort = PACNET.UART.Open("");
            //Write AO value
            bool iRet = PACNET.PAC_IO.WriteAO(hPort, iSlot, iCurrentCh, iTotalCh, fValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnClear_Click(object sender, EventArgs e) //Clear DO
        {
            GetTxtValue();

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.WriteAO(hPort, iSlot, iCurrentCh, iTotalCh, 0F);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtValue.Text = "0";
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            float data = 0;

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.ReadAO(hPort, iSlot, iCurrentCh, iTotalCh, ref data);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtRead.Text = "Read AO: " + data.ToString();
        }

        private void btnRefreshWDT_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.RefreshModuleWDT(hPort, iSlot);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnRestWDT_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.ResetModuleWDT(hPort, iSlot);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnCfgWDT_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            int WTDTimeout = 0;

            WTDTimeout = Convert.ToInt32(txtbWTDTimeout.Text);

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.SetModuleWDTConfig(hPort, iSlot, 1, WTDTimeout, 0); //87k module without WTDOverwrite

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnGetWDT_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            //pac_GetModuleWDTConfig
            int WTDOverwrite = 0;
            int WTDTimeout = 0;
            short ebStatus = 0;

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.GetModuleWDTConfig(hPort, iSlot, ref ebStatus, ref WTDTimeout, ref WTDOverwrite);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtbWTDTimeout.Text = WTDTimeout.ToString();
        }

        private void btnReadSafe_Click(object sender, EventArgs e)
        {
            GetTxtValue();
            float data = 0;

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.ReadModuleSafeValueAO(hPort, iSlot, iCurrentCh, iTotalCh, ref data);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtRead.Text = "Read Safe ValueAO: " + data.ToString();
        }

        private void btnWriteSafe_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.WriteModuleSafeValueAO(hPort, iSlot, iCurrentCh, iTotalCh, fValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnReadPower_Click(object sender, EventArgs e)
        {  
            GetTxtValue();
            float data = 0;

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.ReadModulePowerOnValueAO(hPort, iSlot, iCurrentCh, iTotalCh, ref data);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtRead.Text = "Read PowerOn ValueAO: " + data.ToString();
        }

        private void btnWritePower_Click(object sender, EventArgs e)
        {
            GetTxtValue();

            IntPtr hPort = PACNET.UART.Open("");
            bool iRet = PACNET.PAC_IO.WriteModulePowerOnValueAO(hPort, iSlot, iCurrentCh, iTotalCh, fValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);         
        }
    }
}