﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _87k_basic
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            btnCloseCom.Enabled = false;
        }

        IntPtr hPort;

        private void btnOpenCom_Click(object sender, EventArgs e)
        {
            uint iRet;

            hPort = PACNET.UART.Open("");

            if (hPort == (IntPtr)(-1))
            {
                iRet = PACNET.ErrHandling.GetLastError();
                MessageBox.Show("Open com error(Error code:" + iRet + ")");
            }

            btnCloseCom.Enabled = true;
            btnOpenCom.Enabled = false;
        }

        private void btnCloseCom_Click(object sender, EventArgs e)
        {
            PACNET.UART.Close(hPort);
            btnOpenCom.Enabled = true;
            btnCloseCom.Enabled = false;
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            byte[] result = new byte[20];
            byte[] CmdTemp = new byte[20];
            byte[] respone = new byte[60];

            PACNET.Sys.ChangeSlot(Convert.ToByte(cmbSlot.Text));

            bool iRet = PACNET.UART.SendCmdExt(
                hPort, 
                PACNET.MISC.AnsiString(txtSend.Text),
                (uint)txtSend.Text.Length,
                respone,
                (uint)respone.Length
                );

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRespone.Text = PACNET.MISC.WideString(respone);
        }
    }
}