﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _87k_di_latch
{
    public partial class Form1 : Form
    {
        Button[] btn = new Button[32];
        uint diValue;
        uint HighValue;
        uint LowValue;

        public Form1()
        {
            InitializeComponent();
            //Set default value
            cmbSlot.SelectedIndex = 1; //Slot default is '1';
            cmbChannel.SelectedIndex = 1; //Channel default is '16'
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            int intSlot = cmbSlot.SelectedIndex;
            int intChannel = int.Parse(cmbChannel.Text);

            //Open default com port , default com port is com 1
            IntPtr hPort = PACNET.UART.Open("");

            //Read DI data
            diValue = 0;
            bool iRet = PACNET.PAC_IO.ReadDI(hPort, intSlot, intChannel,ref diValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtDIValue.Text = diValue.ToString("X");

            //Read DI High latch Data
            HighValue = 0;
            iRet = PACNET.PAC_IO.ReadDILatch(hPort, intSlot, intChannel, 1, ref HighValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtHighValue.Text = HighValue.ToString("X");

            //Read DI Low latch Data
            LowValue = 0;
            iRet = PACNET.PAC_IO.ReadDILatch(hPort, intSlot, intChannel, 0, ref LowValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtLowValue.Text = LowValue.ToString("X");

            PACNET.UART.Close(hPort);
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            int intSlot = Convert.ToInt16(cmbSlot.Text);

            //Open default com port , default com port is com 1
            IntPtr hPort = PACNET.UART.Open("");

            //Clear DI latch data
            bool iRet = PACNET.PAC_IO.ClearDILatch(hPort, intSlot);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);

            txtDIValue.Text = "0";
            txtHighValue.Text = "0";
            txtLowValue.Text = "0";
        }
    }
}