﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _8k_dio
{
    public partial class Form1 : Form
    {
        Int32 intSlot = 0, ModuleType = 0;
        byte byteSlot;

        public Form1()
        {
            InitializeComponent();
            cmbSlot.SelectedIndex = 1;
        }

        private void btnWriteDO_Click(object sender, EventArgs e)
        {
            //Get int state Slot data
            intSlot = Convert.ToInt32(cmbSlot.Text);

            //Get byte state Slot data
            byteSlot = Convert.ToByte(cmbSlot.Text);

            //8k module have not using com port to send or write data and use pac_WriteDO to write DO value
            bool iRet = PACNET.PAC_IO.WriteDO((IntPtr)null, intSlot, Convert.ToInt32(txtDOChannel.Text), Convert.ToUInt32(txtDOValue.Text, 16));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            //8k module have not using com port to send or write data and give DO '0' value to clear
            bool iRet = PACNET.PAC_IO.WriteDO((IntPtr)null, intSlot, Convert.ToInt16(txtDOChannel.Text), 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtDOValue.Text = "0";
        }

        private void btnDIRead_Click(object sender, EventArgs e)
        {
            uint intbufer = 0;
            uint intOut = 0;

            intSlot = Convert.ToInt32(cmbSlot.Text);
            byteSlot = Convert.ToByte(cmbSlot.Text);
            ModuleType = PACNET.Sys.GetModuleType(byteSlot);
            //8k module have not using com port to send or write data and DIO module must use pac_ReadDIO read di data
            bool iRet = PACNET.PAC_IO.ReadDIO((IntPtr)null, intSlot, Convert.ToInt32(txtDIChannel.Text), Convert.ToInt32(txtDOChannel.Text), ref intbufer,ref intOut);
            txtDIValue.Text = intbufer.ToString("x");

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }
    }
}