﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _8k_do
{
    public partial class Form1 : Form
    {
        Int32 intSlot=0;
        byte byteSlot;

        public Form1()
        {
            InitializeComponent();
            cmbSlot.SelectedIndex = 1;
        }

        private void btnWriteDO_Click(object sender, EventArgs e)
        {
            //Get int state slot data 
            intSlot = Convert.ToInt16(cmbSlot.Text);

            //Get byte state slot data
            byteSlot = Convert.ToByte(cmbSlot.Text);

            //8k module have not using com port to send or write data and use pac_WriteDO to write data
            bool iRet = PACNET.PAC_IO.WriteDO((IntPtr)null,intSlot,Convert.ToInt32(txtChannel.Text),Convert.ToUInt32(txtDOValue.Text,16));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {   
            intSlot = Convert.ToInt16(cmbSlot.Text);

            //8k module have not using com port to send or write data and give DO '0' value to clear
            bool iRet = PACNET.PAC_IO.WriteDO((IntPtr)null, intSlot, Convert.ToInt32(txtChannel.Text), 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtDOValue.Text = "0";
        }
    }
}