using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using pac8017HWNet;

namespace pac_i8017H_Dotnet
{
    public partial class Form1 : Form
    {
        private string[] typeStr = new string[5];
        private string[] slotStr = new string[8];
        private string[] jumperStr = new string[2];

       

        
        public Form1()
        {
            typeStr[0] = "Voltage +/- 10.0 V ";
            typeStr[1] = "Voltage +/-  5.0 V ";
            typeStr[2] = "Voltage +/-  2.5 V ";
            typeStr[3] = "Voltage +/-  1.25 V ";
            typeStr[4] = "Voltage +/- 20.0 mA ";

            slotStr[0] = "Slot 0";
            slotStr[1] = "Slot 1";
            slotStr[2] = "Slot 2";
            slotStr[3] = "Slot 3";
            slotStr[4] = "Slot 4";
            slotStr[5] = "Slot 5";
            slotStr[6] = "Slot 6";
            slotStr[7] = "Slot 7";

            jumperStr[0] = "Differential";
            jumperStr[1] = "Single Ended";
            

            InitializeComponent();
        }




        private void Form1_Load(object sender, EventArgs e)
        {
            
            for (int i = 0; i < 5; i++)
            {
                cboRange.Items.Add(typeStr[i]);
            }
            for (int i = 0; i < 8; i++)
            {
                cboSlotIndex.Items.Add(slotStr[i]);
            }

        }

   

        private void btnAI_Click(object sender, EventArgs e)
        {
             int slotIndex;
             int gain;
             Int16 ifSingleEnded=0;
             Int16 firmware = 0;
             int totalCh;
             Int16 ret;
            TextBox[] aiText = new TextBox[] { txtAI00, txtAI01, txtAI02, txtAI03, txtAI04, txtAI05, txtAI06, txtAI07, txtAI08, txtAI09, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            float fValue = 0;
            Int16 iValue = 0;
            string valStr;

            slotIndex = cboSlotIndex.SelectedIndex;

            ret=pac8017HW.Init(slotIndex);

            txtLibVer.Text = String.Format("{0:X4}", pac8017HW.LibVersion());            

            txtLibDate.Text = pac8017HW.LibDate();
            pac8017HW.FirmwareVersion(slotIndex, ref firmware);
            txtFirmware.Text = String.Format("{0:X4}", firmware);


            pac8017HW.SingleEndJumper(slotIndex, ref ifSingleEnded);
            txtJumper.Text = jumperStr[ifSingleEnded];
            if (ifSingleEnded == 1)
                totalCh = 16;
            else
                totalCh = 8;

            gain = cboRange.SelectedIndex;
            
            int ch;
            for (ch = 0; ch < totalCh; ch++)
            {
                if (frdo.Checked == true)
                {
                    ret=pac8017HW.ReadAI(slotIndex, ch, gain, ref fValue);                   
                    valStr = String.Format("{0:00.000}", fValue);                    
                    aiText[ch].Text = valStr;
                }
                else
                {
                    ret=pac8017HW.ReadAIHex(slotIndex, ch, gain, ref iValue);                   
                    valStr = String.Format("{0:X4}", iValue);                    
                    aiText[ch].Text = valStr ;                    
                }
            }
           
        }        
       

        private void btnExit_Click(object sender, EventArgs e)
        {

            
            
            Application.Exit();
        }

       
    }
}