using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using pac8084WNet;

namespace pac_i8084W_Dotnet
{
    public partial class Form1 : Form
    {
        private string[] typeStr = new string[5];
        private string[] slotStr = new string[8];       
        private int slotIndex;
        
        public Form1()
        {
            typeStr[0] = "Pulse / Dir";
            typeStr[1] = "Up / Down";
            typeStr[2] = "Frequency";
            typeStr[3] = "Up Counter";
            typeStr[4] = "A/B Phase";

            slotStr[0] = "Slot 0";
            slotStr[1] = "Slot 1";
            slotStr[2] = "Slot 2";
            slotStr[3] = "Slot 3";
            slotStr[4] = "Slot 4";
            slotStr[5] = "Slot 5";
            slotStr[6] = "Slot 6";
            slotStr[7] = "Slot 7";

            InitializeComponent();
        }




        private void Form1_Load(object sender, EventArgs e)
        {
            
            for (int i = 0; i < 5; i++)
            {
                cboRange.Items.Add(typeStr[i]);
            }
            for (int i = 0; i < 8; i++)
            {
                cboSlotIndex.Items.Add(slotStr[i]);
            }

        }

   

 
       

        private void btnExit_Click(object sender, EventArgs e)
        {

            
            
            Application.Exit();
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            
            
            Int16 firmware = 0;
            Int16 ret, mode;
            TextBox[] valText = new TextBox[] { txtCH00, txtCH01, txtCH02, txtCH03, txtCH04, txtCH05, txtCH06, txtCH07};
            TextBox[] ovText = new TextBox[] { txtOv0, txtOv1, txtOv2, txtOv3, txtOv4, txtOv5, txtOv6, txtOv7};
            UInt32 ulVal = 0;
            UInt16 uVal=0;
            Int32 lVal = 0;
            Int16 iVal = 0;


            string valStr;

            

           // ret = pac8084W.Init(slotIndex);



            mode = (Int16) cboRange.SelectedIndex;

            int ch;
            for (ch = 0; ch < 8 ; ch++)
            {
               
                switch (mode)
                {
                    case 0:
                        pac8084W.ReadPulseDir(slotIndex, ch, ref lVal, ref iVal);
                        valText[ch].Text = lVal.ToString();
                        ovText[ch].Text = iVal.ToString();
                        break;
                    case 1:
                        pac8084W.ReadUpDown(slotIndex, ch, ref lVal, ref iVal);
                        valText[ch].Text = lVal.ToString();
                        ovText[ch].Text = iVal.ToString();
                        break;
                    case 2:
                        pac8084W.ReadFreq(slotIndex, ch, ref ulVal);
                        valText[ch].Text = ulVal.ToString();
                        ovText[ch].Text = "-none-";
                        break;
                    case 3:
                        pac8084W.ReadUpCnt(slotIndex, ch, ref ulVal, ref uVal);
                        valText[ch].Text = ulVal.ToString();
                        ovText[ch].Text = uVal.ToString();
                        break;
                    case 4:
                        pac8084W.ReadABPhase(slotIndex, ch, ref lVal, ref iVal);
                        valText[ch].Text = lVal.ToString();
                        ovText[ch].Text = iVal.ToString();
                        break;
                }

            }
        }

        private void btnInit_Click(object sender, EventArgs e)
        {
            
            slotIndex = cboSlotIndex.SelectedIndex;
            pac8084W.Init(slotIndex);
            txtLibVer.Text = String.Format("{0:X4}", pac8084W.LibVersion());

            txtLibDate.Text = pac8084W.LibDate();
 
        }

        private void btnSetMode_Click(object sender, EventArgs e)
        {
            Int16 mode;
            mode = (Int16)cboRange.SelectedIndex;
            int ch;
            for (ch = 0; ch < 8; ch++)
            {
                pac8084W.SetChannelMode(slotIndex, ch, mode); // for Demo to set all channels as same channel mode

                pac8084W.ClrCnt(slotIndex, ch);
            }
        }

        private void btnClr_Click(object sender, EventArgs e)
        {
            for (int ch = 0; ch < 8; ch++)
                pac8084W.ClrCnt(slotIndex, ch);
        }

    }
}