﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using pac8172WNet;


namespace pac_i8172AI
{
    public partial class Form1 : Form
    {

        private static int slotIndex = 0,port=0,  group = 8;
        private static Int16 bitMode = 12, jumper = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void cboSlot_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = -1;  

            ret =pac8172W.Init(cboSlot.SelectedIndex);
            if (ret == 0)
            {
                slotIndex = cboSlot.SelectedIndex;
            }
            else
            {
                MessageBox.Show("I-8172W is not at slot " + cboSlot.SelectedIndex.ToString());
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i;
            ComboBox[] cbo = { cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, cboType12, cboType13, cboType14, cboType15 };
            
            cboPort.SelectedIndex = 0;
            cboGroup.SelectedIndex = 0;
            cboJumper.SelectedIndex = 0;
            cboBit.SelectedIndex = 0;
            for (i = 0; i < 16; i++)
            {
                cbo[i].SelectedIndex = 1; // type code = 0x8 +-10 V
            }

        }

        private void btnAIHex_Click(object sender, EventArgs e)
        {
            Int16 ret,ch=0, flag=-1, i;
            Int16[] checkArr, typeCode, iArr ;
	        Int16  iVal=0;
	        //float[] aiFloat= new float[16];
            float fVal=0;
	        int maxCh=8;

            TextBox[] txtAI = { txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            ComboBox[] cbo = { cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, cboType12, cboType13, cboType14, cboType15 };

            checkArr = new Int16[16];
            typeCode = new Int16[16];
            iArr = new Int16[16];

            int groupStatus = pac8172W.ReadInputGroupStatus(slotIndex, port, group);
            if (groupStatus == 1)
                lbGroupStatus.Text = "Online";
            else
                lbGroupStatus.Text = "Offline";

	        if(bitMode==16)
	        {
		        maxCh=1;
	        }
	        else
	        {
		        if(jumper==0)		
			        maxCh=8;
		        else
			        maxCh=16;
	        }
	        for(i=0;i<maxCh;i++)
	        {
		        iArr[i]=0;
		        checkArr[i]=0;
		        
		        if(cbo[i].SelectedIndex==7) //0x1a
			        typeCode[i] = 0x1a;
		        else
                    typeCode[i] = (Int16)(cbo[i].SelectedIndex + 7);
	        }
	        for(;;)
	        {
		        ret = pac8172W.ReadAIHex( slotIndex,port, group, bitMode, ref ch , ref iVal);
		        
		        if(ret>=0)
		        {
			        flag=1;
			        iArr[ch]=iVal;
			        checkArr[ch]++;			
		        }	
		        for(i=0;i<maxCh;i++)
		        {
			        if(checkArr[i]==0)
			        {
				        flag=-1;
				        break;
			        }
		        }
		        if(flag==1)
		        {

                    for (i = 0; i < maxCh; i++)
                    {

                        pac8172W.AIHexToFloat(iArr[i], typeCode[i], bitMode, ref fVal);
                        txtAI[i].Text = fVal.ToString();
                    }
			        return ;
        			
		        }
	        }
        }

        private void cboPort_SelectedIndexChanged(object sender, EventArgs e)
        {
            port = cboPort.SelectedIndex;
        }

        private void cboGroup_SelectedIndexChanged(object sender, EventArgs e)
        {
            group = cboGroup.SelectedIndex + 8;
        }

        private void cboJumper_SelectedIndexChanged(object sender, EventArgs e)
        {
            jumper = (Int16)cboJumper.SelectedIndex;
        }

        private void cboBit_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboBit.SelectedIndex == 0)
                bitMode = 12;
            else
                bitMode = 16;
        }

        private void btnAICh_Click(object sender, EventArgs e)
        {
            short ret,ch, i;
            Int16[] typeCode= new Int16[16];
	        float fVal=0;
	        float[] aiFloat= new float[16];
	        int maxCh=8;
	        int cboIndex;
            TextBox[] txtAI = { txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            ComboBox[] cbo = { cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, cboType12, cboType13, cboType14, cboType15 };
	       
        	

	        if(bitMode==16)
	        {
		        maxCh=1;
	        }
	        else
	        {
		        if(jumper==0)		
			        maxCh=8;
		        else
			        maxCh=16;
	        }
	        for(i=0;i<maxCh;i++)
	        {	
		        
		        if(cbo[i].SelectedIndex ==7) //0x1a
			        typeCode[i] = 0x1a;
		        else
                    typeCode[i] =(Int16)( cbo[i].SelectedIndex + 7);
	        }
	        for(ch=0;ch<maxCh;ch++)
	        {
                ret = pac8172W.ReadAI_Ch(slotIndex, port, group, bitMode, typeCode[ch], ch, ref fVal);
		        if(ret>=0)
		        {		
			        txtAI[ch].Text =fVal.ToString();
			        
		        }
	        }	
        }

        private void btnAIAll_Click(object sender, EventArgs e)
        {
            short ret,ch, i;
            Int16[] typeCode= new Int16[16];
	        float fVal;
	        float[] aiFloat= new float[16];
	        Int16 maxCh=8;
            TextBox[] txtAI = { txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            ComboBox[] cbo = { cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, cboType12, cboType13, cboType14, cboType15 };
	               
        	

	        if(bitMode==16)
	        {
		        maxCh=1;
	        }
	        else
	        {
		        if(jumper==0)		
			        maxCh=8;
		        else
			        maxCh=16;
	        }
	        for(i=0;i<maxCh;i++)
	        {	
		        
		       
                if (cbo[i].SelectedIndex == 7) //0x1a
			        typeCode[i] = 0x1a;
		        else
                    typeCode[i] = (Int16)(cbo[i].SelectedIndex + 7);
	        }
	        ret = pac8172W.ReadAI_All( slotIndex,port, group, bitMode, jumper,typeCode,aiFloat);
	        if(ret >0)
	        {
		        for(ch=0;ch<maxCh;ch++)
		        {

                    txtAI[ch].Text = aiFloat[ch].ToString();
		        }	
	        }
        }



    }
}