using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using pac8172WNet;

namespace pac_i8172W_Dotnet
{
    public partial class Form1 : Form
    {
       
        private int slotIndex=-1;

        public Form1()
        {
          



            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            for (int i = 0; i < 2; i++)
            {
                cboSelectPort.Items.Add("Port " + i.ToString());
            }
            for (int i = 0; i < 8; i++)
            {
                cboSlotIndex.Items.Add("Slot " + i.ToString() );
                // for DI , group start from 8
                cboGroupDI.Items.Add((i+8).ToString());
                // for DIO, DO group start from 0 and DI group start from 8
                cboGroupDIO.Items.Add(i.ToString());
                // for DO , group start from 0
                cboGroupDO.Items.Add(i.ToString());
            }
            cboGroupDO.SelectedIndex = -1;
            cboGroupDIO.SelectedIndex = -1;
            cboGroupDI.SelectedIndex = -1;
            cboSelectPort.SelectedIndex = -1;

        }


        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }


       

     



      

        private void cboSlotIndex_SelectedIndexChanged(object sender, EventArgs e)
        {
            int ret = pac8172W.Init(cboSlotIndex.SelectedIndex);
            if (ret == 0)
            {
                slotIndex = cboSlotIndex.SelectedIndex;
                lbver.Text = String.Format("{0:X4}", pac8172W.LibVersion());
                lbdate.Text = pac8172W.LibDate();

            }
            else
            {
                lbStatus.Text = "Can not find I-8172 at Slot " + cboSlotIndex.SelectedIndex.ToString() + ",error code= " + ret.ToString();
                lbver.Text = "-1";
                lbdate.Text = "none";
            }

        }

        private void WriteDOBit(object sender, EventArgs e)
        {
            
            CheckBox[] doBitArr = new CheckBox[] { ckDO0, ckDO1, ckDO2, ckDO3, ckDO4, ckDO5, ckDO6, ckDO7, ckDO8, ckDO9, ckDO10, ckDO11, ckDO12,ckDO13, ckDO14, ckDO15 };
            Int16 index = Int16.Parse(((CheckBox)sender).Tag.ToString());
            int portIndex = cboSelectPort.SelectedIndex;
            int groupIndex = cboGroupDO.SelectedIndex;

            if (portIndex != -1 && groupIndex != -1)
            {
                if (doBitArr[index].Checked == true)
                    pac8172W.WriteDOBit(slotIndex, portIndex, groupIndex, index, 1);
                else
                    pac8172W.WriteDOBit(slotIndex, portIndex, groupIndex, index, 0);
            }

        }

        private void DIO_WriteDOBit(object sender, EventArgs e)
        {
            CheckBox[] doBitArr = new CheckBox[] { ckDIO_DO0, ckDIO_DO1, ckDIO_DO2, ckDIO_DO3, ckDIO_DO4, ckDIO_DO5, ckDIO_DO6, ckDIO_DO7};
            Int16 index = Int16.Parse(((CheckBox)sender).Tag.ToString());
            int portIndex = cboSelectPort.SelectedIndex;
            int groupIndex = cboGroupDIO.SelectedIndex;
            if (portIndex != -1 && groupIndex != -1)
            {
                if (doBitArr[index].Checked == true)
                    pac8172W.DIO_WriteDOBit(slotIndex, portIndex, groupIndex, index, 1);
                else
                    pac8172W.DIO_WriteDOBit(slotIndex, portIndex, groupIndex, index, 0);
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            string[] lineStatus = new string[] { "Off Line", "On Line" };
            Label[] diBitArr = new Label[] { lbDI0, lbDI1, lbDI2, lbDI3, lbDI4, lbDI5, lbDI6, lbDI7,lbDI8,lbDI9,lbDI10,lbDI11,lbDI12,lbDI13,lbDI14,lbDI15 };
            Label[] dio_diBitArr = new Label[] { lbDIO_DI0, lbDIO_DI1, lbDIO_DI2, lbDIO_DI3, lbDIO_DI4, lbDIO_DI5, lbDIO_DI6, lbDIO_DI7 };
            int ch;

            int portIndex = cboSelectPort.SelectedIndex;
            int groupIndex = cboGroupDI.SelectedIndex;
            if (portIndex != -1 && groupIndex != -1)
            {
                for (ch = 0; ch < 16; ch++)
                {
                    UInt16 status = pac8172W.ReadDIBit(slotIndex, portIndex, groupIndex + 8, ch);
                    diBitArr[ch].Text = status.ToString();
                }

                int groupStatus = pac8172W.ReadInputGroupStatus(slotIndex, portIndex, groupIndex);
                lb53GroupStatus.Text = lineStatus[groupStatus];
            }

            portIndex = cboSelectPort.SelectedIndex;
            groupIndex = cboGroupDIO.SelectedIndex;
            if (portIndex != -1 && groupIndex != -1)
            {
                for (ch = 0; ch < 8; ch++)
                {
                    UInt16 status = pac8172W.DIO_ReadDIBit(slotIndex, portIndex, groupIndex +8 , ch);
                    dio_diBitArr[ch].Text = status.ToString();
                }
                int groupStatus = pac8172W.ReadInputGroupStatus(slotIndex, portIndex, groupIndex);
                lb54GroupStatus.Text = lineStatus[groupStatus];

            }

        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
        }

        private void label5_ParentChanged(object sender, EventArgs e)
        {

        }





    }
}