﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _7k_ao
{
    public partial class Form1 : Form
    {
        IntPtr hPort;

        public Form1()
        {
            InitializeComponent();
            //Set default com port number is '1'
            cmbComPort.SelectedIndex = 0;
        }

        private void btnOpenCom_Click(object sender, EventArgs e)
        {
            //Open port
            hPort = PACNET.UART.Open("COM" + cmbComPort.Text + ":," + txtBaudRate.Text);

            if (hPort == (IntPtr)(-1))
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                btnCloseCom.Enabled = true;
                btnOpenCom.Enabled = false;
            }
        }

        private void btnCloseCom_Click(object sender, EventArgs e)
        {
            //Close port
            PACNET.UART.Close(hPort);
            btnCloseCom.Enabled = false;
            btnOpenCom.Enabled = true;
        }

        private void btnWriteData_Click(object sender, EventArgs e)
        {
            //Write AO data
            bool iRet = PACNET.PAC_IO.WriteAO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt32(txtWriteChannel.Text), Convert.ToInt32(txtChannel.Text), Convert.ToSingle(txtWriteData.Text));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }
    }
}