﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _7k_basic
{
    public partial class Form1 : Form
    {
        IntPtr hPort;
        public Form1()
        {
            InitializeComponent();
        }

        private void btn_OpenPort_Click(object sender, EventArgs e)
        {
            //Open com port
            hPort = PACNET.UART.Open("COM" + cmbPort.Text + "," + txtBaurdRate.Text);

            if (hPort == (IntPtr)(-1))
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                btnOpenPort.Enabled = false;
                btnClosePort.Enabled = true;
            }
        }

        private void btnClosePort_Click(object sender, EventArgs e)
        {
            //Clos com port
            PACNET.UART.Close(hPort);
            btnClosePort.Enabled = false;
            btnOpenPort.Enabled = true;
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            bool iRet;
            byte[] result = new byte[20];

            //Send command
            iRet = PACNET.UART.SendCmdExt(
                hPort, 
                PACNET.MISC.AnsiString(txtSendValue.Text), 
                (uint)txtSendValue.Text.Length,
                result,
                (uint)result.Length
            );

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                //Show Response to TextBox
                txtResponseValue.Text = PACNET.MISC.WideString(result);
            }
        }
    }
}