﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _7k_DIO_latch
{
    public partial class Form1 : Form
    {
        IntPtr hPort;
        uint DIValue;
        uint DIHighLatchValue;
        uint DILowLatchValue;
        uint DOValue;
        uint DOHighLatchValue;
        uint DOLowLatchValue;

        int intDiTotalCh;
        int intDoTotalCh;

        public Form1()
        {
            InitializeComponent();
            cmbComPort.SelectedIndex = 0;
        }


		private void btnOn_Click_1(object sender, EventArgs e)
		{
            intDiTotalCh = Convert.ToInt16(txtTotalDiChannel.Text);
            intDoTotalCh = Convert.ToInt16(txtTotalDoChannel.Text);

            //Open com port
            hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

            DIValue = 0;
            DOValue = 0;

            //Read DI and DO data
            bool iRet = PACNET.PAC_IO.ReadDIO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intDiTotalCh, intDoTotalCh, ref DIValue, ref DOValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtReadDIValue.Text = DIValue.ToString("X");
            txtReadDoValue.Text = DOValue.ToString("X");

            DILowLatchValue = 0;
            DOLowLatchValue = 0;

            //Read DI and DO low latch data
            iRet = PACNET.PAC_IO.ReadDIOLatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intDiTotalCh, intDoTotalCh, 0, ref DILowLatchValue, ref DOLowLatchValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtDiLowValue.Text = DILowLatchValue.ToString("X");
            txtDoLowValue.Text = DOLowLatchValue.ToString("X");

            DIHighLatchValue = 0;
            DOHighLatchValue = 0;

            //Read DI and DO high latch data
            iRet = PACNET.PAC_IO.ReadDIOLatch(hPort,  PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intDiTotalCh, intDoTotalCh, 1, ref DIHighLatchValue, ref DOHighLatchValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtDiHighValue.Text = DIHighLatchValue.ToString("X");
            txtDoHighValue.Text = DOHighLatchValue.ToString("X");

            PACNET.UART.Close(hPort);
		}	

		private void btnOff_Click(object sender, EventArgs e)
		{
            //Open com port
            hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

            //Clear DI and DO latch
            bool iRet = PACNET.PAC_IO.ClearDIOLatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            //Set DO data be '0' to clear
            txtDiLowValue.Text = "0";
            txtDiHighValue.Text = "0";
            txtDoHighValue.Text = "0";
            txtDoLowValue.Text = "0";

            PACNET.UART.Close(hPort);
		}


        private void btnWriteDo_Click_1(object sender, EventArgs e)
        {
            bool iRet;

            hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

            iRet = PACNET.PAC_IO.WriteDO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)),Convert.ToInt32(txtTotalDoChannel.Text), Convert.ToUInt32(txtDOWriteValue.Text, 16));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }
    }
}