﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;
using System.Threading;


namespace _7k_do_poweron_safe
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cmbCOMPort.SelectedIndex = 3;
            cmbBaudRate.SelectedIndex = 1;
            panel1.Enabled = false;
            btnClose.Enabled = false;
        }

        int iAddress;
        int iTotalCh;
        uint lDO_Value;

        IntPtr hPort = IntPtr.Zero;

        private void GetTextValue()
        {
            iAddress = PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)); ; //Get slot  
            lDO_Value = Convert.ToUInt32(txtValue.Text, 16); //Get DO Value
            iTotalCh = Convert.ToInt32(txtChannels.Text); //Get Total Channels
        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteDO(hPort, iAddress, iTotalCh, lDO_Value); //Write DO value

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnClear_Click(object sender, EventArgs e) //Clear DO
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteDO(hPort, iAddress, iTotalCh, 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtValue.Text = "0";
        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            GetTextValue();

            uint data = 0;

            bool iRet = PACNET.PAC_IO.ReadDO(hPort, iAddress, iTotalCh, ref data);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRead.Text = "ReadDO(HEX): " + data.ToString("x");
        }

        private void btnWritePower_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteModulePowerOnValueDO(hPort, iAddress, iTotalCh, lDO_Value);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnRefreshWDT_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.RefreshModuleWDT(hPort, iAddress);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnWriteSafe_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteModuleSafeValueDO(hPort, iAddress, iTotalCh, lDO_Value);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnRestWDT_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.ResetModuleWDT(hPort, iAddress);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnCfgWDT_Click(object sender, EventArgs e)
        {
            GetTextValue();

            int WTDTimeout = 0;

            WTDTimeout = Convert.ToInt32(txtbWTDTimeout.Text);

            bool iRet = PACNET.PAC_IO.SetModuleWDTConfig(hPort, iAddress, 1, WTDTimeout, 0); //87k module without WTDOverwrite

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void btnReadPower_Click(object sender, EventArgs e)
        {
            GetTextValue();

            uint lValue = 0;

            bool iRet = PACNET.PAC_IO.ReadModulePowerOnValueDO(hPort, iAddress, iTotalCh, ref lValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRead.Text = "Read PowerOn ValueDO(HEX): " + lValue.ToString("x");
        }

        private void btnReadSafe_Click(object sender, EventArgs e)
        {
            GetTextValue();

            uint lValue = 0;

            bool iRet = PACNET.PAC_IO.ReadModuleSafeValueDO(hPort, iAddress, iTotalCh, ref lValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRead.Text = "Read Safe ValueDO(HEX): " + lValue.ToString("x");
        }

        private void btnGetWDT_Click(object sender, EventArgs e)
        {
            GetTextValue();

            int WTDOverwrite = 0;
            int WTDTimeout = 0;
            short ebStatus = 0;

            bool iRet = PACNET.PAC_IO.GetModuleWDTConfig(hPort, iAddress, ref ebStatus, ref WTDTimeout, ref WTDOverwrite);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtbWTDTimeout.Text = WTDTimeout.ToString();
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            hPort = PACNET.UART.Open(cmbCOMPort.Text + "," + cmbBaudRate.Text);
            btnOpen.Enabled = false;
            btnClose.Enabled = true;
            panel1.Enabled = true;
            
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            PACNET.UART.Close(hPort);

            btnOpen.Enabled = true;
            btnClose.Enabled = false;
            panel1.Enabled = false;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            GetTextValue();

            uint data = 0;

            bool iRet = PACNET.PAC_IO.ReadDO_MF(hPort, iAddress, iTotalCh, ref data);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRead.Text = "ReadDO(HEX): " + data.ToString("x");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteDO_MF(hPort, iAddress, iTotalCh, lDO_Value); //Write DO value

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteDO_MF(hPort, iAddress, iTotalCh, 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtValue.Text = "0";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            GetTextValue();

            uint lValue = 0;

            bool iRet = PACNET.PAC_IO.ReadModulePowerOnValueDO_MF(hPort, iAddress, iTotalCh, ref lValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRead.Text = "Read PowerOn ValueDO(HEX): " + lValue.ToString("x");
        }

        private void button7_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteModulePowerOnValueDO_MF(hPort, iAddress, iTotalCh, lDO_Value);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            GetTextValue();

            uint lValue = 0;

            bool iRet = PACNET.PAC_IO.ReadModuleSafeValueDO_MF(hPort, iAddress, iTotalCh, ref lValue);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            txtRead.Text = "Read Safe ValueDO(HEX): " + lValue.ToString("x");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            GetTextValue();

            bool iRet = PACNET.PAC_IO.WriteModuleSafeValueDO_MF(hPort, iAddress, iTotalCh, lDO_Value);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }
    }
}