﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _7k_dobit
{
    public partial class Form1 : Form
    {
        IntPtr hPort;
		byte byteOnoff = 0;
        public Form1()
        {
            InitializeComponent();
            cmbComPort.SelectedIndex = 0;
        }

        private void btnOpenCom_Click(object sender, EventArgs e)
        {
            //Open com port
            hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

            if (hPort == (IntPtr)(-1))
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                btnCloseCom.Enabled = true;
                btnOpenCom.Enabled = false;
            }
        }

        private void btnCloseCom_Click(object sender, EventArgs e)
        {
            //Close com port
            PACNET.UART.Close(hPort);
            btnOpenCom.Enabled = true;
            btnCloseCom.Enabled = false;
        }

		public void FL_CheckMF(byte byteOnoff)
		{
			bool iRet = true;

			if (!checkBox1.Checked)
			{
				//Write DO data 
				iRet = PACNET.PAC_IO.WriteDOBit(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt32(txtTotalChannel.Text), Convert.ToInt32(txtChannel.Text), Convert.ToInt32(byteOnoff));
			}
			else
			{
				//Write DO data MF
				//iRet = PACNET.PAC_IO.WriteDO_MF(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt16(txtAddress.Text)), Convert.ToInt16(txtTotalChannel.Text), Convert.ToUInt32(txtChannel.Text, 16));
				iRet = true;
				MessageBox.Show("not support MF");
			}


			if (!iRet)
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}

		}


		private void btnOn_Click_1(object sender, EventArgs e)
		{
			byteOnoff = 1;
			FL_CheckMF(byteOnoff);
		}	

		private void btnOff_Click(object sender, EventArgs e)
		{
			byteOnoff = 0;
			FL_CheckMF(byteOnoff);
		}



       /* private void button1_Click(object sender, EventArgs e)
        {
            bool iRet;

			//Write DO data MF
			iRet = PACNET.PAC_IO.WriteDO_MF(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt16(txtAddress.Text)), Convert.ToInt16(txtTotalChannel.Text), Convert.ToUInt32(txtChannel.Text, 16));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }*/
    }
}