﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DIP
{
    public partial class Form1 : Form
    {
        const int ORIGIN_X = 10;
        const int ORIGIN_Y = 10;
        const int GAP_SLOT = 30;
        const int UNIT_SLOT = 30;
        const int GAP_LABEL_SLOT = 5;

        int dipValue;
        Label[] numbers = new Label[8];
        Label ON = new Label();

        public Form1()
        {
            InitializeComponent();

            //ON Label:
            ON.Size = new Size(UNIT_SLOT, UNIT_SLOT / 2);
            ON.Location = new Point(
                ORIGIN_X + GAP_SLOT,
                ORIGIN_Y + GAP_SLOT - GAP_LABEL_SLOT - UNIT_SLOT / 2
                );
            ON.Font = new Font(FontFamily.GenericMonospace, 12, FontStyle.Bold);
            ON.Text = "ON";
            ON.ForeColor = Color.White;
            ON.BackColor = Color.Red;
            this.panel1.Controls.Add(ON);

            //number Labels:
            for (int i = 0; i < 8; i++)
            {
                numbers[i] = new Label();
                numbers[i].Size = new Size(UNIT_SLOT, UNIT_SLOT / 2);
                numbers[i].Location = new Point(
                    ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i,
                    ORIGIN_Y + GAP_SLOT + UNIT_SLOT * 2 + GAP_LABEL_SLOT
                    );
                numbers[i].Font = new Font(FontFamily.GenericMonospace, 12, FontStyle.Bold);
                numbers[i].Text = (i + 1).ToString();
                numbers[i].ForeColor = Color.White;
                numbers[i].BackColor = Color.Red;
                this.panel1.Controls.Add(numbers[i]);
            }
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            Brush RED = new SolidBrush(Color.Red);
            Brush WHITE = new SolidBrush(Color.White);
            Pen black = new Pen(Color.Black, 5);

            //Red base
            e.Graphics.FillRectangle(
                RED, 
                ORIGIN_X, 
                ORIGIN_Y, 
                9 * GAP_SLOT + 8 * UNIT_SLOT, 
                2 * GAP_SLOT + 2 * UNIT_SLOT
                );
            
            //White slots
            for (int i = 0; i < 8; i++)
            {
                e.Graphics.FillRectangle(
                    WHITE,
                    ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i,
                    ORIGIN_Y + GAP_SLOT,
                    UNIT_SLOT,
                    UNIT_SLOT * 2
                    );
            }

            //black slide
            for (int i = 0; i < 8; i++)
            {
                if (1 == ((dipValue >> i) & 1)) //ON
                {
                    e.Graphics.DrawRectangle(
                        black,
                        ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i,
                        ORIGIN_Y + GAP_SLOT,
                        UNIT_SLOT,
                        UNIT_SLOT
                        );
                }
                else  //OFF
                {
                    e.Graphics.DrawRectangle(
                        black,
                        ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i,
                        ORIGIN_Y + GAP_SLOT + UNIT_SLOT,
                         UNIT_SLOT,
                         UNIT_SLOT
                         );
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            dipValue = PACNET.Sys.GetDIPSwitch();
            textBox1.Text = dipValue.ToString("X");
            panel1.Refresh();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            button1_Click(sender, e);
        }
    }
}


