﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace MicroSD_Management
{
    public partial class Form1 : Form
    {
        [DllImport("PACSDK.dll", EntryPoint = "_pac_get_partition_info")]
        public static extern bool _pac_get_partition_info(string szPartName, string szFileSys, string szVolName);
        
        delegate void SetButtonCallback(bool flag);

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            MicroSDInfo();
            ThreadStart worker = new ThreadStart(btn_work);
            Thread t = new Thread(worker);
            t.Start();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PACNET.Memory.SDMount("Part00");
            buttonMount.Enabled = false;
            buttonUnmount.Enabled = true;
            MicroSDInfo();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            PACNET.Memory.SDUnmount();
            buttonMount.Enabled = true;
            buttonUnmount.Enabled = false;
            MicroSDInfo();
        }

        public void MicroSDInfo()
        {
            string strName = new string(' ', 256);
            string strFileSys = new string(' ',256);
            string strVolName = new string(' ', 256);

            _pac_get_partition_info(strName, strFileSys, strVolName);
                      
            labelFileSystem.Text = strFileSys;
            labelPartitionName.Text = strName;
            labelVolumeName.Text = strVolName.Substring(1);        
        }
        private void btn_work()
        {
            while (true)
            {                
                Thread.Sleep(1000);
                if (PACNET.Memory.SDOnside())
                {
                    if (PACNET.Memory.SDExists())
                    {
                        SetBtn1(false);
                        SetBtn2(true);
                    }
                    else
                    {
                        SetBtn1(true);
                        SetBtn2(false);
                    }
                }
                else
                {
                    SetBtn1(false);
                    SetBtn2(false);
                }
            }
        }

        private void SetBtn1(bool flag)
        {
            if (this.buttonMount.InvokeRequired)
            {
                SetButtonCallback d = new SetButtonCallback(SetBtn1);
                this.Invoke(d, new object[] { flag });
            }
            else
            {
                this.buttonMount.Enabled = flag;
            }
        }

        private void SetBtn2(bool flag)
        {
            if (this.buttonUnmount.InvokeRequired)
            {
                SetButtonCallback d = new SetButtonCallback(SetBtn2);
                this.Invoke(d, new object[] { flag });
            }
            else
            {
                this.buttonUnmount.Enabled = flag;
            }
        }
    }
}