﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;

namespace ReadTimeTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        [DllImport("mmtimer.dll")]
        static extern uint timeBeginPeriod(uint period);

        [DllImport("mmtimer.dll")]
        static extern uint timeEndPeriod(uint period);

        [DllImport("mmtimer.dll")]
        static extern uint timeSetEvent(uint uDelay, uint uResolution, TimerCallback lpTimeProc, UIntPtr dwUser, uint fuEvent);

        [DllImport("mmtimer.dll")]
        static extern uint timeKillEvent(uint uTimerID);

        [Flags]
        public enum fuEvent : uint
        {
            TIME_ONESHOT = 0,      //Event occurs once, after uDelay milliseconds.
            TIME_PERIODIC = 1,
            TIME_CALLBACK_FUNCTION = 0x0000,  /* callback is function */
            //TIME_CALLBACK_EVENT_SET = 0x0010, /* callback is event - use SetEvent */
            //TIME_CALLBACK_EVENT_PULSE = 0x0020  /* callback is event - use PulseEvent */
        }

        public IntPtr hPort;
        public int iSlot, iDOChs;
        public uint uDOValue;

        delegate void TimerCallback(uint uTimerID, uint uMsg, UIntPtr dwUser, UIntPtr dw1, UIntPtr dw2);
        TimerCallback _timeproc;
        bool bled = false;

        void TimeProc_(uint uID, uint uMsg, UIntPtr dwUser, UIntPtr dw1, UIntPtr dw2)
        {
            if (bled)
            {
                PACNET.PAC_IO.WriteDO(hPort, iSlot, iDOChs, uDOValue);
                bled = false;
            }
            else
            {
                PACNET.PAC_IO.WriteDO(hPort, iSlot, iDOChs, 0);
                bled = true;
            }
        }

        uint uiTimerID;
        private void btntimeSetEvent_Click(object sender, EventArgs e)
        {
            iSlot = Convert.ToInt32(cmbDOSlot.SelectedItem.ToString());
            iDOChs = Convert.ToInt32(txtDOChannels.Text);
            uDOValue = Convert.ToUInt32(txtDOValue.Text, 16);
            hPort = PACNET.UART.Open("");

            //Use timeSetEvent to do real time operation
            timeBeginPeriod(1);
            fuEvent f = fuEvent.TIME_PERIODIC;
            _timeproc = TimeProc_;
            uiTimerID = timeSetEvent(1000, 1, _timeproc, UIntPtr.Zero, (uint)f);
        }

        private void btntimeKillEvent_Click(object sender, EventArgs e)
        {
            timeKillEvent(uiTimerID);
            timeEndPeriod(1);
            PACNET.UART.Close(hPort);
        }

        private void btnPriority_Click(object sender, EventArgs e)
        {
            /*
		       Set timeSetEvent priority
	        */
            bool iRet;
            //Check if key exists
            iRet = PACNET.PAC_Reg.RegKeyExist("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\");
            if (!iRet)
            {
                //Create Key
                iRet = PACNET.PAC_Reg.RegCreateKey("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\");

                if (!iRet)
                {
                    uint ec = PACNET.ErrHandling.GetLastError();
                    MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
                }
            }

            //Set priority value
            uint uPriority = Convert.ToUInt32(txtPriority.Text);
            iRet = PACNET.PAC_Reg.RegSetDWORD("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\Priority256", uPriority);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
        }
    }
}