﻿Public Class Form1

    Dim DIValue As UInteger
    Dim DIHighLatchValue As UInteger
    Dim DILowLatchValue As UInteger
    Dim DOValue As UInteger
    Dim DOHighLatchValue As UInteger
    Dim DOLowLatchValue As UInteger

    Private Sub btnReadDIOValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadDIOValue.Click
        Dim hPort As IntPtr = PACNET.UART.Open("")

        Dim slot As Integer = cmbSlot.Text
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOChannel As Integer = txtDOChannel.Text

        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO(hPort, slot, DIChannel, DOChannel, DIValue, DOValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDIValue.Text = DIValue.ToString("X")
        txtDOValue.Text = DOValue.ToString("X")

        iret = PACNET.PAC_IO.ReadDIOLatch(hPort, slot, DIChannel, DOChannel, 1, DIHighLatchValue, DOHighLatchValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDIHighValue.Text = DIHighLatchValue.ToString("X")
        txtDOHighValue.Text = DOHighLatchValue.ToString("X")

        DIHighLatchValue = 0
        DOHighLatchValue = 0

        iret = PACNET.PAC_IO.ReadDIOLatch(hPort, slot, DIChannel, DOChannel, 0, DILowLatchValue, DOLowLatchValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDILowValue.Text = DILowLatchValue.ToString("X")
        txtDOLowValu.Text = DOLowLatchValue.ToString("X")

        PACNET.UART.Close(hPort)

    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim slot As Integer = cmbSlot.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")

        Dim iret As Boolean = PACNET.PAC_IO.ClearDIOLatch(hPort, slot)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDIHighValue.Text = "0"
        txtDOHighValue.Text = "0"
        txtDILowValue.Text = "0"
        txtDOLowValu.Text = "0"

        PACNET.UART.Close(hPort)

    End Sub

    Private Sub btnWriteDo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDo.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim DOValue As UInteger = Convert.ToUInt32(txtDOWriteValue.Text, 16)

        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, slot, DOChannel, DOValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)

    End Sub
End Class
