﻿Imports System.Threading
Imports System.IO
Imports pac8014WNet
Public Class Form1
    <System.Runtime.InteropServices.DllImport("coredll.dll")> _
Private Shared Function GetTickCount() As UInt32
    End Function

    <System.Runtime.InteropServices.DllImport("coredll.dll")> _
    Private Shared Function GetModuleFileName(ByVal hModule As IntPtr, ByVal lpFileName As System.Text.StringBuilder, ByVal nSize As Integer) As UInteger
    End Function


    Private Shared MAX_FIFO As Int16 = 4096
    Private Shared slotIndex As Int16 = 0, jumper As Int16 = 0, maxCh As Int16 = 8

    Private chArr As Int16() = New Int16(15) {}
    Private gainArr As Int16() = New Int16(15) {}
    Private scanChCount As Int16
    Private T1 As UInt32, T2 As UInt32

    Private sampleRate As Single, realsampleRate As Single = 0
    Private Shared runCnt As Integer = 0

    Private scanMode As Short, triggerSource As Short, triggerState As Short
    Private hexData As Short() = New Short(8191) {}
    Private totalScanned As Int16 = 0
    Private GainStr As String() = {"+/-10V", "+/-5V", "+/-2.5V", "+/-1.25V", "+/-20mA"}

    Private ModeStr As String() = {"M1:Standard ", "M2:Sample and Hold "}
    Private SourceStr As String() = {"Software Command", "Internal Interrupt Signal", "External Trigger Signal"}
    Private StateStr As String() = {"High", "Low"}

    Private ConfigFlag As Boolean = False
    Private TargetCnt As Int16


    Private startTime As DateTime = DateTime.Now

    Private Function GetAppPath() As String
        Dim csCurDir As String = ""

        Dim sb As New System.Text.StringBuilder(256)

        If GetModuleFileName(IntPtr.Zero, sb, sb.Capacity) > 0 Then
            csCurDir = sb.ToString()
        Else
            Return String.Empty
        End If

        Dim iStart As Integer = 0
        While Not csCurDir.EndsWith("\")
            iStart = csCurDir.Length - 1
            csCurDir = csCurDir.Remove(iStart, 1)
        End While
        Return csCurDir
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        Dim cboType As ComboBox() = {cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, _
         cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, _
         cboType12, cboType13, cboType14, cboType15}
        Dim cboChArray As ComboBox() = {cboChArr0, cboChArr1, cboChArr2, cboChArr3, cboChArr4, cboChArr5, _
         cboChArr6, cboChArr7, cboChArr8, cboChArr9, cboChArr10, cboChArr11, _
         cboChArr12, cboChArr13, cboChArr14, cboChArr15}

        cboChCnt.SelectedIndex = 0
        cboScanMode.SelectedIndex = 0
        cboTrigSrc.SelectedIndex = 0
        cboTrigState.SelectedIndex = 0
        For i = 0 To 15
            cboType(i).SelectedIndex = 0
            cboChArray(i).SelectedIndex = 0
        Next i

    End Sub




    


    Private Sub ShowAI()
        Dim i As Integer
        Dim calibratedAI As Single = 0

        lstData.Items.Clear()
        'Console.Write("Start to Print all data:\n\n\r");
        For i = 0 To totalScanned - 1

            pac8014W.CalibrateData(slotIndex, gainArr(i Mod scanChCount), hexData(i), calibratedAI)

            lstData.Items.Add([String].Format("CH[{0}]= {1}", chArr(i Mod scanChCount), calibratedAI))
        Next i


    End Sub
    Private Sub SaveAI()
        Dim i As Integer
        Dim tStr As String = [String].Format("{0:00}_{1:00}_{2:00}_{3:00}_{4:00}", DateTime.Now.Month, DateTime.Now.Day, DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second)
        Dim fPath As String = GetAppPath() + "\SampleData" + tStr + ".csv"
        Dim data As String = String.Empty
        Dim Dsw As New StreamWriter(fPath, False, System.Text.Encoding.[Default])
        Dim calibratedAI As Single = 0
        ' Console.Write("Start to Print all data:\n\n\r");

        i = 0
        While i < totalScanned
            pac8014W.CalibrateData(slotIndex, gainArr(i Mod scanChCount), hexData(i), calibratedAI)
            If (i Mod scanChCount) <> 0 Then
                data += "," + calibratedAI.ToString()
            Else
                If i <> 0 Then
                    Dsw.WriteLine(data)
                End If
                data = i.ToString() + "," + calibratedAI.ToString()
            End If
            System.Math.Max(System.Threading.Interlocked.Increment(i), i - 1)
        End While
        Dsw.WriteLine(data)
        Dsw.Flush()
        Dsw.Close()
    End Sub

    Private Sub cboSlot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlot.SelectedIndexChanged
        Dim ret As Integer = -1

        Dim SingleEndedStr As String() = New String(1) {}

        SingleEndedStr(0) = "Differential"
        SingleEndedStr(1) = "Single Ended"
        ret = pac8014W.Init(cboSlot.SelectedIndex)
        If ret = 0 Then
            slotIndex = cboSlot.SelectedIndex
            jumper = pac8014W.SingleEndJumper(slotIndex)


            lbJumper.Text = SingleEndedStr(jumper)
        Else
            MessageBox.Show("I-8014W is not at slot " + cboSlot.SelectedIndex.ToString())
        End If
    End Sub

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        Dim ret As Short
        Dim buf As Int16() = New Int16(4095) {}

        Dim readFromFIFO As Long = 0

        If Not ConfigFlag Then
            MessageBox.Show("Please Configure the Magic Scan Parameters first", "Error")
            Return
        End If
        'Send external trigger for I-8014W module

        If triggerSource = 2 Then
            lstMsg.Items.Add([String].Format("Wait for external trigger signal source to {0} .....", StateStr(triggerState)))
        End If

        totalScanned = 0
        pac8014W.StartMagicScan(slotIndex)
        T1 = GetTickCount()
       
        ret = pac8014W.ReadFIFO_BlockMode(slotIndex, hexData, TargetCnt, readFromFIFO)
        pac8014W.StopMagicScan(slotIndex)
        txtDataCnt.Text = readFromFIFO.ToString()
        If ret = (ErrorCode.FIFO_LATCHED) OrElse (readFromFIFO <> TargetCnt) Then
            T2 = GetTickCount() - T1



            MessageBox.Show("Please try to use lower sample rate and try again", "FIFO Latched")
        End If

        If readFromFIFO > 0 Then
            totalScanned = readFromFIFO
            T2 = GetTickCount() - T1
        End If
        txtTicks.Text = T2.ToString()
        ShowAI()

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()

    End Sub

    Private Sub btnSet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSet.Click
        Dim i As Int16, ret As Int16
        Dim cboType As ComboBox() = {cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, _
         cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, _
         cboType12, cboType13, cboType14, cboType15}
        Dim cboChArray As ComboBox() = {cboChArr0, cboChArr1, cboChArr2, cboChArr3, cboChArr4, cboChArr5, _
         cboChArr6, cboChArr7, cboChArr8, cboChArr9, cboChArr10, cboChArr11, _
         cboChArr12, cboChArr13, cboChArr14, cboChArr15}
        lstMsg.Items.Clear()

        Dim SingleEndedStr As String() = New String(1) {}



        scanChCount = cboChCnt.SelectedIndex + 1
        ' scan channel count must begin at 1
        For i = 0 To scanChCount - 1

            chArr(i) = cboChArray(i).SelectedIndex
            gainArr(i) = cboType(i).SelectedIndex

            lstMsg.Items.Add([String].Format("Selected Magic Scan Channel Gain Array[{0}] C = {1}  G ={2}", i, chArr(i), gainArr(i)))
        Next i



        ' Sample channel counts
        ' scanChCount can be 1 ~ 16 (max =16 for both Differential and Single Ended)

        sampleRate = Convert.ToSingle(txtSampleRate.Text)
        scanMode = cboScanMode.SelectedIndex + 1


        ' trigger source 0, start magic scan via polling Mode, software command can only trigger one slot I-8014
        ' trigger source 1, start magic scan via internal interrupt signal Mode, internal interrupt signal can trigger all I-8014Ws on slots at the same time.
        ' trigger source 2, start magic scan via external trigger signal Mode, extern trigger can also trigger all I-8014Ws on slots at the same time.



        triggerSource = cboTrigSrc.SelectedIndex

        ' triggerState only related with external DI trigger signal.
        ' if triggerState 0, external DI trigger signal must be high to start magic scan (default)
        ' if triggerState 1, external DI trigger signal must be low to start magic scan




        triggerState = cboTrigState.SelectedIndex

        ' When Configure Sample Rate of Magic Scan, the result sample rate may be different from input sample rate 
        ' Note i8014W_ConfigMagicScan only tell I-8014W how to start magic scan,it will not start magic scan
        ' We have to call i8014W_StartMagicScan to start up the magic scan.

        pac8014W.ConfigMagicScan(slotIndex, chArr, gainArr, scanChCount, sampleRate, scanMode, _
         triggerSource, triggerState, realsampleRate)


        lstMsg.Items.Add([String].Format("The Magic Scan Configurations of I-8014W are:"))
        TargetCnt = Convert.ToInt16(txtTargetCnt.Text)
        lstMsg.Items.Add([String].Format("Scan channel count = {0}, Total sample count ={1}", scanChCount, TargetCnt))
        For i = 0 To scanChCount - 1
            lstMsg.Items.Add([String].Format("CH[{0}]= {1} Gain[{2}]= {3} ( {4} )", i, chArr(i), i, gainArr(i), GainStr(gainArr(i))))
        Next i
        lstMsg.Items.Add([String].Format("Scan Mode = {0} ( {1} )", scanMode, ModeStr(scanMode - 1)))
        lstMsg.Items.Add([String].Format("Trigger Source = {0} ( {1} )", triggerSource, SourceStr(triggerSource)))
        If triggerSource = 2 Then
            lstMsg.Items.Add([String].Format("Trigger State = {0} ( {1} )", triggerState, StateStr(triggerState)))
        Else
            lstMsg.Items.Add([String].Format("Trigger State = {0} ( No need for External Trigger Signal )", triggerState))
        End If
        lstMsg.Items.Add([String].Format("Set Sample Rate = {0}  Real Sample Rate = {1}", sampleRate, realsampleRate))

        ConfigFlag = True
    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click

        SaveAI()
    End Sub

   
End Class
