Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports PACNET
Imports System.Runtime.InteropServices
Imports System.Threading
Public Class Form1

    Dim iSlot As Int32
    Private Sub btnWriteDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDO.Click
        Dim hPort As IntPtr
        Dim ModuleType As Int32 = 0

        hPort = PACNET.UART.Open("")

        'Get slot
        iSlot = Convert.ToInt32(cmbDOSlot.Text)

        'Read module type
        ModuleType = PACNET.Sys.GetModuleType(iSlot)
        If ModuleType = &HE0 OrElse ModuleType = &HC0 OrElse ModuleType = &H80 OrElse ModuleType = &H81 Then
            'Write DO value
            PACNET.PAC_IO.WriteDO(hPort, iSlot, Convert.ToInt32(txtbDOChannels.Text), Convert.ToUInt32(txtbDOValue.Text, 16))
        Else
            MessageBox.Show("No module or module is wriong" & ModuleType.ToString())
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmbDOSlot.SelectedIndex = 0
    End Sub

    Private Sub btnClearDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearDO.Click
        Dim hPort As IntPtr

        hPort = PACNET.UART.Open("")

        'Clear DO
        iSlot = Convert.ToInt32(cmbDOSlot.Text)
        PACNET.PAC_IO.WriteDO(hPort, iSlot, Convert.ToInt32(txtbDOChannels.Text), 0)

        txtbDOValue.Text = "0"
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim hPort As IntPtr
        iSlot = Convert.ToInt32(cmbDOSlot.Text)
        hPort = PACNET.UART.Open("")
        Dim data As UInteger = 0
        PACNET.PAC_IO.ReadDO(hPort, iSlot, Convert.ToInt32(txtbDOChannels.Text), data)
        txtbReadDo.Text = data.ToString("x")
    End Sub
    <DllImport("WinPacSDK.dll", EntryPoint:="_pac_slot_inp")> _
    Public Shared Function pac_slot_inp(ByVal slot As Integer, ByVal addr As Integer) As Integer
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_LastOutputSource")> _
    Public Shared Function pac_LastOutputSource(ByVal slot As Integer) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_GetWDTStatus")> _
    Public Shared Function pac_GetWDTStatus(ByVal slot As Integer, ByRef wdtStatus As Short, ByRef wdtTimeout As Single) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_SetWDTConfig")> _
    Public Shared Function pac_SetWDTConfig(ByVal slot As Integer, ByVal enStatus As Short, ByVal wdtTimeout As Single, ByVal ifWDT_Overwrite As Integer) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_ReadSafeValue")> _
    Public Shared Function pac_ReadSafeValue(ByVal slot As Integer, ByRef lValue As Long) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_WriteSafeValue")> _
    Public Shared Function pac_WriteSafeValue(ByVal slot As Integer, ByVal lData As Long) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_ReflashWDT")> _
    Public Shared Function pac_ReflashWDT(ByVal slot As Integer) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_SetPowerOnEnStatus")> _
    Public Shared Function pac_SetPowerOnEnStatus(ByVal slot As Integer, ByVal enStatus As Short) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_GetPowerOnEnStatus")> _
    Public Shared Function pac_GetPowerOnEnStatus(ByVal slot As Integer, ByRef enStatus As Short) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_WritePowerOnValue")> _
    Public Shared Function pac_WritePowerOnValue(ByVal slot As Integer, ByVal lData As Long) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="pac_ReadPowerOnValue")> _
    Public Shared Function pac_ReadPowerOnValue(ByVal slot As Integer, ByRef lValue As Long) As Short
    End Function

    <DllImport("WinPacSDK.dll", EntryPoint:="ReturnIfWDTCanOverWritwDo")> _
    Public Shared Function ReturnIfWDTCanOverWritwDo(ByVal slot As Integer) As Integer
    End Function
    Private Sub button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button4.Click
        iSlot = Convert.ToInt32(cmbDOSlot.Text)
        Dim hPort As IntPtr
        hPort = PACNET.UART.Open("")
        PACNET.PAC_IO.WriteModulePowerOnValueDO(hPort, iSlot, 32, Convert.ToUInt32(txtbDOValue.Text, 16))
        Dim result As DialogResult = MessageBox.Show("Power on value will show after reboot." & vbLf & "Do you want to reboot now?", "Note", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)
        If result = DialogResult.Yes Then
            PACNET.Sys.Reboot()
        End If
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub butSetSafeValue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butSetSafeValue.Click
        Dim WTDOverwrite As Integer = 0
        Dim WTDTimeout As Integer = 0
        Dim hPort As IntPtr
        hPort = PACNET.UART.Open("")
        iSlot = Convert.ToInt32(cmbDOSlot.Text)
        PACNET.PAC_IO.WriteModuleSafeValueDO(hPort, iSlot, 32, Convert.ToUInt32(txtbDOValue.Text, 16))

        If chkWTDOverwrite.Checked Then 'enable WTD overwrite after WTD start
            WTDOverwrite = 1
        End If
        WTDTimeout = Int16.Parse(txtbWTDTimeout.Text)
        PACNET.PAC_IO.SetModuleWDTConfig(hPort, iSlot, 1, WTDTimeout, WTDOverwrite)
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub butRefreshWTD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butRefreshWTD.Click
        iSlot = Convert.ToInt32(cmbDOSlot.Text)
        Dim hPort As IntPtr
        hPort = PACNET.UART.Open("")
        PACNET.PAC_IO.RefreshModuleWDT(hPort, iSlot)
        PACNET.UART.Close(hPort)
    End Sub
End Class
