Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Windows.Forms
Imports PACNET
Imports pac_i8048WNet

Public Class Form1
    <DllImport("WinpacSDK.dll", EntryPoint:="_pac_outp")> _
    Public Shared Sub PAC_OUTP(ByVal addr As Integer, ByVal val As Byte)
    End Sub

#Region "Parameters"
    Private Const ChannelMax As Integer = 8
    Private iSlot As Integer = 0
    Private TotalCnt As UInteger 'total count
    Private RisingEdgeCnt(7) As UInteger
    Private FallingEdgeCnt(7) As UInteger
    Private SecondCnt As UInteger = 0
#End Region
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmbSlot.SelectedIndex = 0
        cmbTriggerType.SelectedIndex = 0
    End Sub

    Private Sub txtInit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtInit.Click 'Init i8048
        Dim TriType, ThreadPriority As Integer
        Dim BPRetriggerTime As Byte = 0

        'Get slot number
        iSlot = cmbSlot.SelectedIndex

        'Get trigger type
        TriType = cmbTriggerType.SelectedIndex

        'Set thread priority
        ThreadPriority = 97

        'Set backplane(bp) retrigger
        BPRetriggerTime = 10
        '            
        'The re-trigger level is used for the backplane interrupt of WinPAC.
        'The CPU lost to receive the interrupt signal triggered by i8048W, and
        'this re-trigger mechanism will make the backplane processer to re-send 
        'the interrupt signal to CPU again.    
        '                    
        'It's recommended to set the re-trigger level to 10
        '(unit is 10 microsecond, 10*10 =100 microsecond)         
        '            

        'Retrigger unit            
        Backplane.pac_EnableRetrigger(BPRetriggerTime)

        TotalCnt = 0

        For ch As Integer = 0 To ChannelMax - 1 'Ҧcount]w
            RisingEdgeCnt(ch) = 0
            FallingEdgeCnt(ch) = 0
        Next ch

        If pac8048W.Init(iSlot) = 0 Then 'set trigger type in rising or falling
            If TriType = 0 Then
                For ch As Integer = 0 To ChannelMax - 1
                    pac8048W.Set_RisingReg(iSlot, ch, 1)
                    pac8048W.Set_FallingReg(iSlot, ch, 0)
                Next ch
            Else
                For ch As Integer = 0 To ChannelMax - 1
                    pac8048W.Set_FallingReg(iSlot, ch, 1)
                    pac8048W.Set_RisingReg(iSlot, ch, 0)
                Next ch
            End If
            '                
            'The default priority level of the interrupt service thread,Interrupt_Fun function 
            'for i8048W is 97
            'Many higher priority levels (247 through zero) are assigned to real-time applications, drivers, and system processes. .

            'Range(Description)
            '0 through 96 	Reserved for real-time above drivers.
            '97 through 152 	Used by the default Windows CE-based device drivers.
            '153 through 247 	Reserved for real-time below drivers.

            'It() 's recommended to set the priority level between 97 and 152 for i8048w IST         
            'Please refer to http://msdn.microsoft.com/en-us/library/aa450596.aspx for mode details.

            Dim callbackFunc As New pac8048W.PAC_CALLBACK_FUNC(AddressOf Interrupt_Fun)
            pac8048W.InstallISR(iSlot, callbackFunc, ThreadPriority)

            Dim ec As System.UInt32 = ErrHandling.pac_GetLastError()
            If (ec > 0) Then
                MessageBox.Show((CType(ec, ErrCode)).ToString() + "\nError Code: 0x" + ec.ToString("X"))
            Else
                btnStop.Enabled = True
                txtInit.Enabled = False
                timer1.Enabled = True
            End If
        Else
            MessageBox.Show(" pac8048W.Init failed")
        End If

    End Sub

    Private Function Interrupt_Fun() As Integer 'Interrupt Function
        For ch As Integer = 0 To ChannelMax - 1
            If pac8048W.Read_RisingReg(iSlot, ch) <> 0 Then 'Read Rising Interrupt Status
                RisingEdgeCnt(ch) += 1
                TotalCnt += 1 'Total Interrupt count
                'Add user's ISR code for channels here. 
            End If
            If pac8048W.Read_FallingReg(iSlot, ch) <> 0 Then
                FallingEdgeCnt(ch) += 1
                TotalCnt += 1
                'Add user's ISR code for channels here. 
            End If
            pac8048W.UnFreezeINT(iSlot, ch)
        Next ch
        Return 0
    End Function


    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim DI As Integer = pac8048W.DI_ALL(iSlot)
        SecondCnt += 1
        txtCh0_REC.Text = RisingEdgeCnt(0).ToString()
        txtCh1_REC.Text = RisingEdgeCnt(1).ToString()
        txtCh2_REC.Text = RisingEdgeCnt(2).ToString()
        txtCh3_REC.Text = RisingEdgeCnt(3).ToString()
        txtCh4_REC.Text = RisingEdgeCnt(4).ToString()
        txtCh5_REC.Text = RisingEdgeCnt(5).ToString()
        txtCh6_REC.Text = RisingEdgeCnt(6).ToString()
        txtCh7_REC.Text = RisingEdgeCnt(7).ToString()

        txtCh0_FEC.Text = FallingEdgeCnt(0).ToString()
        txtCh1_FEC.Text = FallingEdgeCnt(1).ToString()
        txtCh2_FEC.Text = FallingEdgeCnt(2).ToString()
        txtCh3_FEC.Text = FallingEdgeCnt(3).ToString()
        txtCh4_FEC.Text = FallingEdgeCnt(4).ToString()
        txtCh5_FEC.Text = FallingEdgeCnt(5).ToString()
        txtCh6_FEC.Text = FallingEdgeCnt(6).ToString()
        txtCh7_FEC.Text = FallingEdgeCnt(7).ToString()

        txtTotalCnt.Text = TotalCnt.ToString()
    End Sub

    Private Sub btnClearCnt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearCnt.Click
        SecondCnt = 0
        For ch As Integer = 0 To ChannelMax - 1
            RisingEdgeCnt(ch) = 0
            FallingEdgeCnt(ch) = 0
        Next ch
        TotalCnt = 0
    End Sub


    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        timer1.Enabled = False
        pac8048W.UnInstallISR(iSlot)
        btnStop.Enabled = False
        txtInit.Enabled = True
    End Sub

    Private Sub Form1_Closed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        pac8048W.UnInstallISR(iSlot)
    End Sub
End Class
