﻿Imports System.IO.Ports

Public Class Form1

    Public Sub New()
        InitializeComponent()
        'Load com port data to comobox Object
        LoadComPort()
        btnCloseCOM.Enabled = False
    End Sub

    Private hPort As IntPtr

    Private Sub LoadComPort()
        Dim ports As String() = SerialPort.GetPortNames()
        Array.Sort(ports)

        For Each port As String In ports
            cmbComPort.Items.Add(port)
        Next

        cmbComPort.SelectedIndex = 0

    End Sub

    Private Sub btnOpenCOM_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenCOM.Click
        'Open com port
        Me.hPort = PACNET.UART.Open(cmbComPort.Text + "," + txtBaurdRate.Text)

        If hPort = CType(-1, IntPtr) Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else

            btnOpenCOM.Enabled = False
            btnCloseCOM.Enabled = True
        End If
    End Sub

    Private Sub btnCloseCOM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCloseCOM.Click
        'Close com port
        PACNET.UART.Close(hPort)
        btnOpenCOM.Enabled = True
        btnCloseCOM.Enabled = False
    End Sub

    Private Sub btnReadAI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadAI.Click
        Dim fValue As Single = 0
        Dim iRet As Boolean
        Dim intReadChannel As Integer = Integer.Parse(txtReadChannel.Text)
        Dim intChannel As Integer = Integer.Parse(txtChannel.Text)
        If intReadChannel <= intChannel Then
            'Read data
            iRet = PACNET.PAC_IO.ReadAI(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt32(txtReadChannel.Text), Convert.ToInt16(txtChannel.Text), fValue)
            If Not iRet Then
                Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
                MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
            Else
                txtAIValue.Text = fValue.ToString()
            End If
        Else
            MessageBox.Show("Your read channel is error , please rewrite read channel")
        End If
    End Sub


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim buffsize As Integer = txtChannel.Text
        Dim fValue As Single() = New Single(buffsize - 1) {}
        Dim iRet As Boolean
        Dim intReadChannel As Integer = Integer.Parse(txtReadChannel.Text)
        Dim intChannel As Integer = Integer.Parse(txtChannel.Text)
        Dim len As Integer = 0
        If intReadChannel <= intChannel Then
            'Read data
            iRet = PACNET.PAC_IO.ReadAIAllExt(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), fValue, buffsize, len)
            If Not iRet Then
                Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
                MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
            Else
                textBox1.Text = ""

                For i As Integer = 0 To buffsize - 1
                    textBox1.Text += (i.ToString() & ": ") + fValue(i).ToString() & vbCr & vbLf
                Next

                textBox1.Text += "real total channel: " & len & vbCr & vbLf
            End If
        Else
            MessageBox.Show("Your read channel is error , please rewrite read channel")
        End If
    End Sub
End Class
