﻿Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace Diagnostic
    Partial Public Class Form1
        Inherits Form
        Const startX As Integer = 20
        Const startY As Integer = 30
        Const UNIT_LENGTH As Integer = 50
        Const GAP_SLOT As Integer = 5
        Const GAP_MODULE_LABEL As Integer = 20
        Const LABEL_HEIGHT As Integer = 20

        Private slotCount As Integer = 0
        Private ModuleExist As Boolean() = New Boolean(7) {}
        Private ModuleName As String() = New String(7) {}
        Private lbSlot As Label() = New Label(7) {}
        Private lbmoduleName As Label() = New Label(7) {}

        Private headImage As Image
        'image of CPU-power module
        Private moduleImage As Image
        'image of I/O slot module
        Private emptyImage As Image
        'image of a slot in empty status
        Private pbHead As New PictureBox()
        Private pbModule As PictureBox() = New PictureBox(7) {}
        Dim iSlotStart As Integer = 0

        Public Sub New()
            InitializeComponent()

            If Environment.OSVersion.Version.Major = 5 Then
                iSlotStart = 0
            Else
                iSlotStart = 1
            End If

            headImage = imageList1.Images(1)
            moduleImage = imageList1.Images(2)
            emptyImage = imageList1.Images(0)

            'initialize image of CPU-power module
            pbHead.Image = headImage
            pbHead.SizeMode = PictureBoxSizeMode.StretchImage
            pbHead.Size = New Size(UNIT_LENGTH * 3, UNIT_LENGTH * 3)
            pbHead.Location = New Point(startX, startY)
            Me.Controls.Add(pbHead)

            For i As Integer = 0 To 7 - iSlotStart
                'initialize Labels of Slot1, Slot2, ...
                lbSlot(i) = New Label()
                lbSlot(i).Text = "Slot " & (i + iSlotStart).ToString()
                lbSlot(i).Size = New Size(UNIT_LENGTH, LABEL_HEIGHT)
                Me.Controls.Add(lbSlot(i))

                'initialize PictureBoxs which hold image of I/O module status
                pbModule(i) = New PictureBox()
                pbModule(i).SizeMode = PictureBoxSizeMode.StretchImage
                pbModule(i).Size = New Size(UNIT_LENGTH, UNIT_LENGTH * 3)
                pbModule(i).Location = New Point(startX + UNIT_LENGTH * 3 + GAP_SLOT + (UNIT_LENGTH + GAP_SLOT) * i, startY)
                pbModule(i).Image = emptyImage
                Me.Controls.Add(pbModule(i))

                'initialize Labels to hold module names
                lbmoduleName(i) = New Label()
                lbmoduleName(i).Size = New Size(UNIT_LENGTH, LABEL_HEIGHT)
                Me.Controls.Add(lbmoduleName(i))
            Next
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
            slotCount = PACNET.Sys.GetSlotCount()

            If Environment.OSVersion.Version.Major = 5 Then
                slotCount -= 1
            End If

            printSlotLabels(startX + UNIT_LENGTH * 3 + GAP_SLOT, startY + UNIT_LENGTH * 3 + GAP_MODULE_LABEL)

            button1_Click(sender, e)
        End Sub

        Private Sub showModuleImages()
            For i As Integer = iSlotStart To 7
                If i <= slotCount Then
                    If ModuleExist(i - iSlotStart) Then
                        pbModule(i - iSlotStart).Image = moduleImage
                    Else
                        pbModule(i - iSlotStart).Image = emptyImage
                    End If
                Else
                    pbModule(i - iSlotStart).Visible = False

                End If
            Next
        End Sub

        Private Sub printSlotLabels(ByVal x As Integer, ByVal y As Integer)
            For i As Integer = iSlotStart To 7
                If i <= slotCount Then
                    lbSlot(i - iSlotStart).Location = New Point(x + (UNIT_LENGTH + GAP_SLOT) * (i - iSlotStart), y)
                Else
                    lbSlot(i - iSlotStart).Visible = False

                End If
            Next
        End Sub

        Private Sub printModuleNameLabels(ByVal x As Integer, ByVal y As Integer)
            For i As Integer = iSlotStart To 7
                If i <= slotCount Then
                    lbmoduleName(i - iSlotStart).Location = New Point(x + (UNIT_LENGTH + GAP_SLOT) * (i - iSlotStart), y)
                Else
                    lbmoduleName(i - iSlotStart).Visible = False

                End If
            Next
        End Sub

        Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
            'Diagnose
            Dim h As IntPtr = PACNET.UART.Open("")
            'COM1:,115200,N,8,1
            Dim _for_8K As IntPtr = IntPtr.Zero
            ' (IntPtr)0;    //used for pac_ModuleExists
            Dim moduleType As Integer = 0
            Dim cmd As Byte() = New Byte(63) {}
            Dim result As Byte() = New Byte(63) {}

            cmd = PACNET.MISC.AnsiString("$00M")
            For i As Byte = iSlotStart To slotCount
                ModuleExist(i - iSlotStart) = PACNET.Sys.ModuleExists(_for_8K, i)
                'for 8K IO module only
                If ModuleExist(i - iSlotStart) Then
                    moduleType = PACNET.Sys.GetModuleName(i, ModuleName(i - iSlotStart))
                    If 255 = moduleType Then
                        '87K IO modules
                        PACNET.Sys.ChangeSlot(i)
                        Dim iret As Boolean = PACNET.UART.SendCmd(h, cmd, result)
                        ' $00M: ask the device name
                        If Not iret Then
                            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
                            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
                        End If
                        Dim strResult As String = PACNET.MISC.WideString(result)
                        'return format for example: !0087055
                        ModuleName(i - iSlotStart) = strResult.Substring(3)
                    End If
                Else
                    ModuleName(i - iSlotStart) = ""
                End If
                lbmoduleName(i - iSlotStart).Text = ModuleName(i - iSlotStart)
            Next

            PACNET.UART.Close(h)

            printModuleNameLabels(startX + UNIT_LENGTH * 3 + GAP_SLOT, startY - GAP_MODULE_LABEL)

            showModuleImages()
        End Sub
    End Class
End Namespace

