﻿Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace GetRotaryID
    Public Partial Class Form1
        Inherits Form
        Const ROTARY_SWITH_UNIT As Integer = 400
        Const ARROW_UNIT As Integer = 120
        Const CIRCLE_UNIT As Integer = 150
        Const NUMBER_UNIT As Integer = 175
        Const ORIGIN_X As Integer = ROTARY_SWITH_UNIT / 2
        Const ORIGIN_Y As Integer = ROTARY_SWITH_UNIT / 2
        
        'arrowPoints = vertices of the arrow shape
        Private arrowPointsX As Double() = New Double() {1, 0, 0, -1, -1, 0, _
        	0}
        Private arrowPointsY As Double() = New Double() {0, -1, -0.5, -0.5, 0.5, 0.5, _
        	1}
        Const ARROW_POINT_NUM As Integer = 7
        
        Private lbNumbers As Label() = New Label(9) {}
        'numbers of the rotary switch
        Private CurrentRotaryID As Integer = 0
        Private previousRotaryID As Integer = 0
        'used to prevent flash
        Public Sub New()
            InitializeComponent()
            Dim angle As Double
            Dim x As Integer, y As Integer
            For i As Integer = 0 To 9
                angle = Math.PI * 2 / 10 * i
                
                'labels of number initialization
                lbNumbers(i) = New Label()
                x = Convert.ToInt32(Math.Cos(angle) * NUMBER_UNIT + ORIGIN_X)
                y = Convert.ToInt32(Math.Sin(angle) * NUMBER_UNIT + ORIGIN_Y)
                lbNumbers(i).Location = New Point(x, y)
                lbNumbers(i).Text = i.ToString()
                lbNumbers(i).Font = New Font(FontFamily.GenericSerif, 16, FontStyle.Bold)
                lbNumbers(i).ForeColor = Color.White
                lbNumbers(i).BackColor = Color.Black
                lbNumbers(i).Size = New Size(20, 20)
                Me.panel1.Controls.Add(lbNumbers(i))
            Next
        End Sub
        
        Private Function rotate(ByVal x As Double(), ByVal y As Double(), ByVal length As Integer, ByVal graduation As Integer) As Double()
            'vector rotation formula:
            ' x2 = x1 * cos - y1 * sin
            'y2 = y1 * cos + x1 * sin
            
            Dim angle As Double = Math.PI * 2 / 10 * graduation
            Dim dbArray As New ArraySegment(Of Double)(New Double(length * 2 - 1) {}, 0, length * 2)
            
            For i As Integer = 0 To length - 1
                dbArray.Array(2 * i) = x(i) * Math.Cos(angle) - y(i) * Math.Sin(angle)
                dbArray.Array(2 * i + 1) = y(i) * Math.Cos(angle) + x(i) * Math.Sin(angle)
            Next
            Return dbArray.Array
        End Function
        
        Private Function CalculateArrowPoints(ByVal graduation As Integer) As Point()
            Dim rotatedArrowPoints As Double() = New Double(ARROW_POINT_NUM * 2 - 1) {}
            Dim rotatedArrow As Point() = New Point(ARROW_POINT_NUM - 1) {}
            Dim x As Integer, y As Integer
            
            rotatedArrowPoints = rotate(arrowPointsX, arrowPointsY, ARROW_POINT_NUM, graduation)
            For i As Integer = 0 To ARROW_POINT_NUM - 1
                x = Convert.ToInt32(ARROW_UNIT * rotatedArrowPoints(2 * i) + ORIGIN_X)
                y = Convert.ToInt32(ARROW_UNIT * rotatedArrowPoints(2 * i + 1) + ORIGIN_Y)
                rotatedArrow(i) = New Point(x, y)
            Next
            Return rotatedArrow
        End Function
        
        Private Sub panel1_Paint(ByVal sender As Object, ByVal e As PaintEventArgs)
            Dim BLACK As Brush = New SolidBrush(Color.Black)
            Dim WHITE As Brush = New SolidBrush(Color.White)
            Dim GRAY As Brush = New SolidBrush(Color.Gray)
            Dim arrowPt As Point() = New Point(ARROW_POINT_NUM - 1) {}
            
            e.Graphics.FillRectangle(BLACK, 0, 0, ROTARY_SWITH_UNIT, ROTARY_SWITH_UNIT)
            
            e.Graphics.FillEllipse(WHITE, ORIGIN_X - CIRCLE_UNIT, ORIGIN_Y - CIRCLE_UNIT, CIRCLE_UNIT * 2, CIRCLE_UNIT * 2)
            
            arrowPt = CalculateArrowPoints(CurrentRotaryID)
                
            e.Graphics.FillPolygon(GRAY, arrowPt)
        End Sub
        
        Private Sub timer1_Tick(ByVal sender As Object, ByVal e As EventArgs)
            previousRotaryID = CurrentRotaryID
            CurrentRotaryID = PACNET.Sys.GetRotaryID()
            
            If CurrentRotaryID <> previousRotaryID Then
                'to prevent flash
                panel1.Refresh()
            End If
        End Sub
        
    End Class
End Namespace
