﻿Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace Memory
    Public Partial Class Form1
        Inherits Form
        Private MEM_TYPE As Integer
        
        Public Sub New()
            InitializeComponent()
        End Sub
        
        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs)
            Dim sizeOfSRAM As UInteger = 0
            Dim sizeOfEEPROM As UInteger = 0
            
            radioButton1.Checked = True
            MEM_TYPE = 0
            'SRAM
            sizeOfSRAM = PACNET.Memory.GetMemorySize(PACNET.Memory.PAC_MEM_SRAM)
            sizeOfEEPROM = PACNET.Memory.GetMemorySize(PACNET.Memory.PAC_MEM_EEPROM)

            label1.Text = "of size, " & sizeOfSRAM.ToString() & " bytes"
            label2.Text = "of size, " & sizeOfEEPROM.ToString() & " bytes"
        End Sub

        Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs)
            Dim index As UInteger
            Dim buf As Byte() = New Byte(63) {}
            Dim writeString As String = tbWrite.Text
            buf = PACNET.MISC.AnsiString(writeString)
            Dim length As UInteger = Convert.ToUInt32(writeString.Length)
            Dim size As UInteger = PACNET.Memory.GetMemorySize(MEM_TYPE)

            Dim dR As DialogResult
            dR = MessageBox.Show("The data stored in memory may be erased!", "Warning!", MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button2)

            If dR = DialogResult.OK Then
                Try
                    index = UInteger.Parse(tbIndex.Text)
                    If index < 0 Then
                        index = 0
                    End If
                    If index > size - 1 Then
                        index = size - 1
                    End If
                Catch
                    index = 0
                    tbIndex.Text = "0"
                End Try

                If MEM_TYPE = PACNET.Memory.PAC_MEM_EEPROM Then
                    PACNET.Memory.EnableEEPROM(True)
                End If

                PACNET.Memory.WriteMemory(index, buf, length, MEM_TYPE)

                If MEM_TYPE = PACNET.Memory.PAC_MEM_EEPROM Then
                    PACNET.Memory.EnableEEPROM(False)
                End If
            End If
        End Sub

        Private Sub radioButton1_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)
            If radioButton1.Checked = True Then
                MEM_TYPE = PACNET.Memory.PAC_MEM_SRAM
            Else
                MEM_TYPE = PACNET.Memory.PAC_MEM_EEPROM
            End If
        End Sub

        Private Sub button2_Click(ByVal sender As Object, ByVal e As EventArgs)
            Dim index As UInteger
            Dim byteNum2Read As UInteger
            Dim buf As Byte() = New Byte(63) {}
            Dim size As UInteger = PACNET.Memory.GetMemorySize(MEM_TYPE)

            Try
                index = UInteger.Parse(tbIndex.Text)
                If index < 0 Then
                    index = 0
                End If
                If index > size - 1 Then
                    index = size - 1
                End If
            Catch
                index = 0
                tbIndex.Text = "0"
            End Try

            Try
                byteNum2Read = UInteger.Parse(tbByteNum.Text)
            Catch
                byteNum2Read = 1
                tbByteNum.Text = "1"
            End Try

            PACNET.Memory.ReadMemory(index, buf, byteNum2Read, MEM_TYPE)

            tbRead.Text = PACNET.MISC.WideString(buf)
        End Sub
        
    End Class
End Namespace
