﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.Threading


Public Class Form1

    <DllImport("mmtimer.dll")> _
    Private Shared Function timeBeginPeriod(ByVal period As UInteger) As UInteger
    End Function

    <DllImport("mmtimer.dll")> _
    Private Shared Function timeEndPeriod(ByVal period As UInteger) As UInteger
    End Function

    <DllImport("mmtimer.dll")> _
    Private Shared Function timeSetEvent(ByVal uDelay As UInteger, ByVal uResolution As UInteger, ByVal lpTimeProc As TimerCallback, ByVal dwUser As UIntPtr, ByVal fuEvent As UInteger) As UInteger
    End Function

    <DllImport("mmtimer.dll")> _
    Private Shared Function timeKillEvent(ByVal uTimerID As UInteger) As UInteger
    End Function

    Public hPort As IntPtr
    Public iSlot As Integer, iDOChs As Integer
    Public uDOValue As UInteger

    Private _bDOEnable As Boolean

    <Flags()> _
    Public Enum fuEvent As UInteger
        TIME_ONESHOT = 0
        'Event occurs once, after uDelay milliseconds.
        TIME_PERIODIC = 1
        TIME_CALLBACK_FUNCTION = &H0
    End Enum

   Private Delegate Sub TimerCallback(uTimerID As UInteger, uMsg As UInteger, dwUser As UIntPtr, dw1 As UIntPtr, dw2 As UIntPtr)
		Private _timeproc As TimerCallback
		Private bled As Boolean = False

    Private Sub TimeProc_(ByVal uTimerID As UInteger, ByVal uMsg As UInteger, ByVal dwUser As UIntPtr, ByVal dw1 As UIntPtr, ByVal dw2 As UIntPtr)

        If bled Then
            PACNET.PAC_IO.WriteDO(hPort, iSlot, iDOChs, uDOValue)
            bled = False
        Else
            PACNET.PAC_IO.WriteDO(hPort, iSlot, iDOChs, 0)
            bled = True
        End If
    End Sub

    Private uiTimerID As UInteger

    Private Sub btnPriority_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPriority.Click
        '
        '		       Set timeSetEvent priority
        '	        

        Dim ret As Boolean
        'Check if key exists
        If Not PACNET.PAC_Reg.RegKeyExist("HKEY_LOCAL_MACHINE\System\MMTIMER\") Then
            'Create Key
            ret = PACNET.PAC_Reg.RegCreateKey("HKEY_LOCAL_MACHINE\System\MMTIMER\")
            If Not ret Then
                MessageBox.Show("Create registry key fail.(""HKEY_LOCAL_MACHINE\System\MMTIMER\"")" & vbLf)
            End If
        End If

        'Set priority value
        Dim uPriority As UInteger = Convert.ToUInt32(txtPriority.Text)
        ret = PACNET.PAC_Reg.RegSetDWORD("HKEY_LOCAL_MACHINE\System\MMTIMER\Priority256", uPriority)
        If Not ret Then
            MessageBox.Show("Set priority value fail.(pac_RegSetDWORD() function fail)" & vbLf)
        End If
    End Sub

    Private Sub btntimeSetEvent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btntimeSetEvent.Click
        iSlot = Convert.ToInt32(cmbDOSlot.SelectedItem.ToString())
			iDOChs = Convert.ToInt32(txtDOChannels.Text)
			uDOValue = Convert.ToUInt32(txtDOValue.Text, 16)
			hPort = PACNET.UART.Open("")

			'Use timeSetEvent to do real time operation
			timeBeginPeriod(1)
			Dim f As fuEvent = fuEvent.TIME_PERIODIC
			_timeproc = AddressOf TimeProc_
			uiTimerID = timeSetEvent(1000, 1, _timeproc, UIntPtr.Zero, CUInt(f))
    End Sub

    Private Sub btntimeKillEvent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btntimeKillEvent.Click
        timeKillEvent(uiTimerID)
        timeEndPeriod(1)
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmbDOSlot.SelectedIndex = 1
    End Sub
End Class
