﻿Imports System
Imports System.Collections.Generic
Imports System.Text

Public Class CEDateTime
    Private Shared m_offset As Integer = 0
    Public Shared tTick As New HighResolutionTimer()
    Public Sub New()

        'Dim s As Integer = DateTime.Now.Second
        'Do
        '    Dim s2 As Integer = DateTime.Now.Second
        '    ' wait for a rollover
        '    If s <> s2 Then
        '        m_offset = Environment.TickCount Mod 1000
        '        Exit Do
        '    End If
        'Loop
        'Console.WriteLine("cedatatime offset=" + m_offset);

        tTick.Start()
        Dim s As Integer = DateTime.Now.Second
        Do
            Dim s2 As Integer = DateTime.Now.Second
            ' wait for a rollover
            If s <> s2 Then
                'm_offset = Environment.TickCount Mod 1000
                tTick.Stop()
                m_offset = tTick.ElapsedTime Mod 1000
                Exit Do
            End If
        Loop

    End Sub
    Public Shared Sub ReNew()

        'Dim s As Integer = DateTime.Now.Second
        'Do
        '    Dim s2 As Integer = DateTime.Now.Second
        '    ' wait for a rollover
        '    If s <> s2 Then
        '        m_offset = Environment.TickCount Mod 1000
        '        Exit Do
        '    End If
        'Loop
        'Console.WriteLine("cedatatime offset=" + m_offset);

        tTick.Start()
        Dim s As Integer = DateTime.Now.Second
        Do
            Dim s2 As Integer = DateTime.Now.Second
            ' wait for a rollover
            If s <> s2 Then
                'm_offset = Environment.TickCount Mod 1000
                tTick.Stop()
                m_offset = tTick.ElapsedTime Mod 1000
                Exit Do
            End If
        Loop

    End Sub

    Public Shared ReadOnly Property Now() As DateTime
        'Get
        '    ' find where we are based on the os tick
        '    Dim tick As Integer = Environment.TickCount Mod 1000
        '    ' calculate our ms shift from our base m_offset
        '    Dim ms As Integer '= If(tick >= m_offset, (tick - m_offset), (1000 -(m_offset - tick)))
        '    If tick >= m_offset Then
        '        ms = (tick - m_offset)
        '    Else
        '        ms = (1000 - (m_offset - tick))
        '    End If
        '    ' build a new DateTime with our calculated ms
        '    ' we use a new DateTime because some devices fill ms with a non-zero garbage value
        '    'INSTANT VB NOTE: The local variable now was renamed since Visual Basic will not allow local variables with the same name as their enclosing function or property:
        '    Dim now_Renamed As DateTime = DateTime.Now
        '    '                Console.WriteLine(now);
        '    Return New DateTime(now_Renamed.Year, now_Renamed.Month, now_Renamed.Day, now_Renamed.Hour, now_Renamed.Minute, now_Renamed.Second, ms)
        'End Get

        Get
            ' find where we are based on the os tick
            tTick.Stop()

            Dim tick As Integer = tTick.ElapsedTime() Mod 1000 'Environment.TickCount Mod 1000
            Dim now_Renamed As DateTime = DateTime.Now
            ' calculate our ms shift from our base m_offset
            Dim ms As Integer '= If(tick >= m_offset, (tick - m_offset), (1000 -(m_offset - tick)))
            If tick >= m_offset Then
                ms = (tick - m_offset)
            Else
                ms = (1000 - (m_offset - tick))
            End If
            ' build a new DateTime with our calculated ms
            ' we use a new DateTime because some devices fill ms with a non-zero garbage value
            'INSTANT VB NOTE: The local variable now was renamed since Visual Basic will not allow local variables with the same name as their enclosing function or property:

            '                Console.WriteLine(now);
            Return New DateTime(now_Renamed.Year, now_Renamed.Month, now_Renamed.Day, now_Renamed.Hour, now_Renamed.Minute, now_Renamed.Second, ms)
        End Get
    End Property

    Public Sub Calibrate(ByVal seconds As Integer)
        Dim s As Integer = CEDateTime.Now.Second
        Dim sum As Integer = 0
        Dim remaining As Integer = seconds
        Do While remaining > 0
            Dim dt As Date = CEDateTime.Now
            Dim s2 As Integer = dt.Second
            If s <> s2 Then
                'System.Diagnostics.Debug.WriteLine("ms=" & dt.Millisecond)
                'Console.WriteLine("m_offset=" & m_offset)
                remaining -= 1
                ' store the offset from zero
                If (dt.Millisecond > 500) Then
                    sum += (dt.Millisecond - 1000)
                Else
                    sum += dt.Millisecond
                End If
                s = dt.Second
            End If
        Loop
        ' adjust the offset by the average deviation from zero (round to the integer farthest from zero)
        If sum < 0 Then
            m_offset += CInt(Fix(Math.Floor(sum / CSng(seconds))))
        Else
            m_offset += CInt(Fix(Math.Ceiling(sum / CSng(seconds))))
        End If
        'Console.WriteLine("m_offset=" & m_offset)
    End Sub
End Class
Public Class HighResolutionTimer
    ' Windows CE native library with QueryPerformanceCounter().
    'private const string lib = "coredll.dll";          
    <System.Runtime.InteropServices.DllImport("coredll.dll", CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Private Shared Function QueryPerformanceCounter(ByRef performanceCount As Long) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("coredll.dll", CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Private Shared Function QueryPerformanceFrequency(ByRef frequency As Long) As Boolean
    End Function

    'INSTANT VB NOTE: The variable start was renamed since Visual Basic does not allow class members with the same name:
    Public start_Renamed As Long
    'INSTANT VB NOTE: The variable stop was renamed since Visual Basic does not allow class members with the same name:
    Public stop_Renamed As Long
    Public frequency As Long

    Public Sub New()
        QueryPerformanceFrequency(frequency)
    End Sub

    Public Sub Start()
        QueryPerformanceCounter(start_Renamed)
    End Sub

    Public Sub [Stop]()
        QueryPerformanceCounter(stop_Renamed)
    End Sub

    Public ReadOnly Property ElapsedTime() As Single
        Get
            Dim elapsed As Single = ((CSng(stop_Renamed - start_Renamed) * 1000) / (CSng(frequency))) 'ms
            Return elapsed
        End Get
    End Property
End Class
