Imports System
Imports System.Collections.Generic
Imports System.Text
 
Namespace QueryPerformance
    Public Class HiResTimer
        ' Windows CE native library with QueryPerformanceCounter().
        'private const string lib = "coredll.dll";
        <System.Runtime.InteropServices.DllImport("coredll.dll")> _
        Private Shared Function QueryPerformanceCounter(ByRef count As Int64) As Integer
        End Function
        <System.Runtime.InteropServices.DllImport("coredll.dll")> _
        Private Shared Function QueryPerformanceFrequency(ByRef frequency As Int64) As Integer
        End Function

 
        Private Shared isPerfCounterSupported As Boolean =  False 
 
        Public Shared frequency As Int64 =  1000 
 
        'public static Int64 counterAtStart=0;
        ' public  static Int64 counterAtEnd = 0;
 
        Public Sub New()
            'Query the high-resolution timer only if it is supported.
            ' A returned frequency of 1000 typically indicates that it is not
            ' supported and is emulated by the OS using the same value that is
            ' returned by Environment.TickCount.
            ' A return value of 0 indicates that the performance counter is
            ' not supported.

            Dim returnVal As Integer = QueryPerformanceFrequency(frequency)

            If returnVal <> 0 AndAlso frequency <> 1000 Then
                ' The performance counter is supported.
                isPerfCounterSupported = True
            Else
                ' The performance counter is not supported. Use
                ' Environment.TickCount instead.
                frequency = 1000
            End If
        End Sub

        'Public ReadOnly Property Frequency() As Int64
        '    Get
        '        Return frequency
        '    End Get
        'End Property

        Public ReadOnly Property Value() As Int64
            Get
                Dim tickCount As Int64 = 0

                If isPerfCounterSupported Then
                    ' Get the value here if the counter is supported.
                    QueryPerformanceCounter(tickCount)
                    Return tickCount
                Else
                    ' Otherwise, use Environment.TickCount.
                    Return DirectCast(Environment.TickCount, Int32)
                End If
            End Get
        End Property
    End Class
End Namespace


