// 87k_basicDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_basic.h"
#include "87k_basicDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy87k_basicDlg dialog

CMy87k_basicDlg::CMy87k_basicDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_basicDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_basicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON1, btnOpen);
	DDX_Control(pDX, IDC_BUTTON2, btnClose);
	DDX_Control(pDX, IDC_BUTTON3, btnSend);
	DDX_Control(pDX, IDC_COMBO1, cmbSlot);
}

BEGIN_MESSAGE_MAP(CMy87k_basicDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy87k_basicDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy87k_basicDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy87k_basicDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CMy87k_basicDlg message handlers

BOOL CMy87k_basicDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//set default value
	SetDlgItemText(IDC_EDIT1,L"$00M");
	SetDlgItemText(IDC_COMBO1,L"1");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy87k_basicDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY87K_BASIC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY87K_BASIC_DIALOG));
	}
}
#endif

HANDLE hPort;

void CMy87k_basicDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM1 port and baud rate set 115200
	//COM1 port connect to backplane
	hPort = uart_Open("");
	if(hPort == (HANDLE)(-1)){
		::MessageBox(NULL,L"Open Port error",L"87k_basic",MB_OK);
	}else{
		GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
	}
}

void CMy87k_basicDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here

	//close port
	uart_Close(hPort);
	GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
}

void CMy87k_basicDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	CString strTemp;
	char SendData[20];
	char Response[20]={0};

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,10);
	BYTE slot = _wtoi(temp);
	pac_ChangeSlot(slot);

	//get user input command string
	GetDlgItemText(IDC_EDIT1,strTemp);
	for(int i= 0;i<sizeof(strTemp);i++){
		SendData[i] = strTemp[i];
	}

	//use uart_SendCmd functio to send command, and use 3th parameter get result
	BOOL iret = uart_SendCmdExt(hPort, SendData, sizeof(SendData), Response, sizeof(Response));

	if(!iret){
		::MessageBox(NULL,L"send error",L"87k_basic",MB_OK);
	}else{
		int length = strlen(Response);
		ZeroMemory(temp,20);
		for(int i=0;i<length;i++){
			temp[i] = Response[i];
		}
		SetDlgItemText(IDC_EDIT2,temp);
	}
}
