// 87k_dio_latchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_dio_latch.h"
#include "87k_dio_latchDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy87k_dio_latchDlg dialog

CMy87k_dio_latchDlg::CMy87k_dio_latchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_dio_latchDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_dio_latchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy87k_dio_latchDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy87k_dio_latchDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy87k_dio_latchDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy87k_dio_latchDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CMy87k_dio_latchDlg message handlers

BOOL CMy87k_dio_latchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_COMBO1,L"1");
	SetDlgItemText(IDC_EDIT1,L"8");
	SetDlgItemText(IDC_EDIT2,L"8");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy87k_dio_latchDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY87K_DIO_LATCH_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY87K_DIO_LATCH_DIALOG));
	}
}
#endif


void CMy87k_dio_latchDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];
	DWORD DIValue,DOValue;
	DWORD DIHighLatch,DILowLatch;
	DWORD DOHighLatch,DOLowLatch;

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set DO total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int DOChannel = _wtoi(temp);

	//get user set DI total channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	int DIChannel = _wtoi(temp);

	//use pac_ReadDIO functio to read DI and DO data
	BOOL iret = pac_ReadDIO(hPort,slot,DIChannel,DOChannel,&DIValue,&DOValue);
	if(!iret){
		uart_Close(hPort);
		::MessageBox(NULL,L"Read DIO error",L"87k_dio_latch",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIValue);
		SetDlgItemText(IDC_EDIT3,temp);
		wsprintf(temp,L"%d",DOValue);
		SetDlgItemText(IDC_EDIT6,temp);

		wsprintf(temp,L"0x%lx",DIValue);
		SetDlgItemText(IDC_EDIT14,temp);
		wsprintf(temp,L"0x%lx",DOValue);
		SetDlgItemText(IDC_EDIT15,temp);
	}

	//use pac_ReadDIOLatch functio to read DI and DO  latch data ,5th parameter set 1 indicates High latch
	iret = pac_ReadDIOLatch(hPort,slot,DIChannel,DOChannel,1,&DIHighLatch,&DOHighLatch);
	if(!iret){
		uart_Close(hPort);
		::MessageBox(NULL,L"Read DIO Hight Latcherror",L"87k_dio_latch",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIHighLatch);
		SetDlgItemText(IDC_EDIT4,temp);
		wsprintf(temp,L"%d",DOHighLatch);
		SetDlgItemText(IDC_EDIT7,temp);

		wsprintf(temp,L"0x%lx",DIHighLatch);
		SetDlgItemText(IDC_EDIT10,temp);
		wsprintf(temp,L"0x%lx",DOHighLatch);
		SetDlgItemText(IDC_EDIT12,temp);

	}

	//use pac_ReadDIOLatch functio to read DI and DO  latch data ,5th parameter set 0 indicates low latch
	iret = pac_ReadDIOLatch(hPort,slot,DIChannel,DOChannel,0,&DILowLatch,&DOLowLatch);
	if(!iret){
		uart_Close(hPort);
		::MessageBox(NULL,L"Read DIO Low Latch error",L"87k_dio_latch",MB_OK);
	}else{
		wsprintf(temp,L"%d",DILowLatch);
		SetDlgItemText(IDC_EDIT5,temp);
		wsprintf(temp,L"%d",DOLowLatch);
		SetDlgItemText(IDC_EDIT8,temp);

		wsprintf(temp,L"0x%lx",DILowLatch);
		SetDlgItemText(IDC_EDIT11,temp);
		wsprintf(temp,L"0x%lx",DOLowLatch);
		SetDlgItemText(IDC_EDIT13,temp);
	}

	uart_Close(hPort);

}

void CMy87k_dio_latchDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//use pac_ClearDILatch functio to clear DI and DO Latch data
	pac_ClearDIOLatch(hPort,slot);

	SetDlgItemText(IDC_EDIT4,L"0");
	SetDlgItemText(IDC_EDIT7,L"0");
	SetDlgItemText(IDC_EDIT5,L"0");
	SetDlgItemText(IDC_EDIT8,L"0");
	uart_Close(hPort);
}

void CMy87k_dio_latchDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];
	DWORD DOValue=0;
	CString strTemp;
	char ctemp[20]={0};

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set DO total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int DOChannel = _wtoi(temp);

	//get user set DO data
	GetDlgItemText(IDC_EDIT9,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}

	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	BOOL iret = pac_WriteDO(hPort,slot,DOChannel,DOValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Write DO error",L"87k_dio_latch",MB_OK);
	}
}
