// 87k_doDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_do.h"
#include "87k_doDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy87k_doDlg dialog

CMy87k_doDlg::CMy87k_doDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_doDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_doDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, cmbSlot);
	DDX_Control(pDX, IDC_EDIT1, txtChannel);
	DDX_Control(pDX, IDC_EDIT2, txtDOValue);
	DDX_Control(pDX, IDC_BUTTON1, btnWrite);
	DDX_Control(pDX, IDC_BUTTON2, btnClear);
}

BEGIN_MESSAGE_MAP(CMy87k_doDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy87k_doDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy87k_doDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy87k_doDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMy87k_doDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CMy87k_doDlg message handlers

BOOL CMy87k_doDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	//set default value
	SetDlgItemText(IDC_COMBO1,L"1");
	SetDlgItemText(IDC_EDIT1,L"16");
	SetDlgItemText(IDC_EDIT2,L"0");
	SetDlgItemText(IDC_EDIT3, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy87k_doDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY87K_DO_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY87K_DO_DIALOG));
	}
}
#endif


void CMy87k_doDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];
	DWORD DOValue=0;
	CString strTemp;
	char ctemp[20]={0};

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,10);
	int slot = _wtoi(temp);

	//get user set DO channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int channel = _wtoi(temp);

	//get user set DO value
	GetDlgItemText(IDC_EDIT2,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}

	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	BOOL iret = pac_WriteDO(hPort,slot,channel,DOValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Write DO error",L"87K_do",MB_OK);
	}

}

void CMy87k_doDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];
	GetDlgItemText(IDC_COMBO1,temp,10);
	int slot = _wtoi(temp);

	//get user set DO channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int channel = _wtoi(temp);

	//use pac_WriteDO functio and set DO value be 0 to clear
	BOOL iret = pac_WriteDO(hPort,slot,channel,0);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Clear DO error",L"87K_do",MB_OK);
	}
}

void CMy87k_doDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];
	DWORD DOValue=0;
	CString strTemp;
	char ctemp[20]={0};

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,10);
	int slot = _wtoi(temp);

	//get user set DO channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int channel = _wtoi(temp);

	//get user set DO value
	GetDlgItemText(IDC_EDIT2,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}

	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	BOOL iret = pac_WriteDO_MF(hPort,slot,channel,DOValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Write DO error",L"87K_do",MB_OK);
	}

}

void CMy87k_doDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];
	GetDlgItemText(IDC_COMBO1,temp,10);
	int slot = _wtoi(temp);

	//get user set DO channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int channel = _wtoi(temp);

	//use pac_WriteDO functio and set DO value be 0 to clear
	BOOL iret = pac_WriteDO_MF(hPort,slot,channel,0);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Clear DO error",L"87K_do",MB_OK);
	}
}
