// 8k_dioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_dio.h"
#include "8k_dioDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy8k_dioDlg dialog

CMy8k_dioDlg::CMy8k_dioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_dioDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_dioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy8k_dioDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON3, &CMy8k_dioDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON1, &CMy8k_dioDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy8k_dioDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CMy8k_dioDlg message handlers

BOOL CMy8k_dioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//set default value
	SetDlgItemText(IDC_COMBO1,L"1");
	SetDlgItemText(IDC_EDIT1,L"8");
	SetDlgItemText(IDC_EDIT2,L"8");
	SetDlgItemText(IDC_EDIT3,L"0xff");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy8k_dioDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY8K_DIO_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY8K_DIO_DIALOG));
	}
}
#endif


void CMy8k_dioDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here

	TCHAR temp[20];
	DWORD DIValue,DOValue;
	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int DIChannel = _wtoi(temp);

	GetDlgItemText(IDC_EDIT1,temp,20);
	int DOChannel = _wtoi(temp);

	//use pac_ReadDI functio to read DI data
	BOOL iret = pac_ReadDIO(0,slot,DIChannel,DOChannel,&DIValue,&DOValue);
	wsprintf(temp,L"%d",DIValue);
	SetDlgItemText(IDC_EDIT4,temp);

	wsprintf(temp,L"0x%lx",DIValue);
	SetDlgItemText(IDC_EDIT5,temp);
}

void CMy8k_dioDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM1 port and baud rate set 115200
	//COM1 port connect to backplane
	TCHAR temp[20];
	DWORD DOValue=0;
	CString strTemp;
	char ctemp[20]={0};

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set DO channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	int DOChannel = _wtoi(temp);

	//get user set DO value and change decade to hexadecimal
	GetDlgItemText(IDC_EDIT3,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}
	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	BOOL iret = pac_WriteDO(0,slot,DOChannel,DOValue);
	if(!iret){
		::MessageBox(NULL,L"Write DO error",L"8k_dio",MB_OK);
	}
}

void CMy8k_dioDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here

	//uart_Open function parameter is "", it's open COM1 port and baud rate set 115200
	//COM1 port connect to backplane
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set DO channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	int DOChannel = _wtoi(temp);


	//use pac_WriteDO functio and set DO value be 0 to clear
	BOOL iret = pac_WriteDO(0,slot,DOChannel,0);
	if(!iret){
		::MessageBox(NULL,L"Clear Write DO error",L"8k_dio",MB_OK);
	}
}
