// 7k_aiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_ai.h"
#include "7k_aiDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_aiDlg dialog

CMy7k_aiDlg::CMy7k_aiDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CMy7k_aiDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_aiDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_aiDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
    ON_WM_SIZE()
#endif
    //}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_aiDlg::OnBnClickedButton1)
    ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_aiDlg::OnBnClickedButton2)
    ON_BN_CLICKED(IDC_BUTTON3, &CMy7k_aiDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMy7k_aiDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CMy7k_aiDlg message handlers

BOOL CMy7k_aiDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here

    //set default value
    SetDlgItemText(IDC_COMBO1, L"COM3:");
    SetDlgItemText(IDC_EDIT1, L"01");
    SetDlgItemText(IDC_EDIT2, L"9600");
    SetDlgItemText(IDC_EDIT3, L"1");
    SetDlgItemText(IDC_EDIT4, L"0");
    return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_aiDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    if(AfxIsDRAEnabled())
    {
        DRA::RelayoutDialog(
            AfxGetResourceHandle(),
            this->m_hWnd,
            DRA::GetDisplayMode() != DRA::Portrait ?
            MAKEINTRESOURCE(IDD_MY7K_AI_DIALOG_WIDE) :
            MAKEINTRESOURCE(IDD_MY7K_AI_DIALOG));
    }
}
#endif

HANDLE hPort;

void CMy7k_aiDlg::OnBnClickedButton1()
{
    // TODO: Add your control notification handler code here
    TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];

    //get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT3, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_ai", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON4)->EnableWindow(TRUE);
    }
}

void CMy7k_aiDlg::OnBnClickedButton2()
{
    // TODO: Add your control notification handler code here

    //close com port
    if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_ai", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON4)->EnableWindow(FALSE);
    }
}

void CMy7k_aiDlg::OnBnClickedButton3()
{
    // TODO: Add your control notification handler code here
    TCHAR temp[20];
    DWORD DIValue = 0;
    float fValue = 0.0;
    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user read channel
    GetDlgItemText(IDC_EDIT4, temp, 20);
    int ReadChannel = _wtoi(temp);

    //use pac_ReadAI functio to read AI data
    BOOL iret = pac_ReadAI(hPort, PAC_REMOTE_IO(address), ReadChannel, TotalChannel, &fValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read AI error", L"7k_ai", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%.4f", fValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_aiDlg::OnBnClickedButton4()
{
	// TODO: b[JiBz`{X
	TCHAR temp[20];
    DWORD DIValue = 0;
    float fValue[32] = {0};

	DWORD len = 0;
    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user read channel
    GetDlgItemText(IDC_EDIT4, temp, 20);
    int ReadChannel = _wtoi(temp);

    //use pac_ReadAI functio to read AI data
    BOOL iret = pac_ReadAIAllExt(hPort, PAC_REMOTE_IO(address), fValue, 32, &len);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read AI error", L"7k_ai", MB_OK);
    }
    else
    {
        for(int i = 0; i < 32; i++)
		{
			printf("channel %d, value: %f\n", i, fValue[i]);
		}

		printf("total channel len: %d\n", len);
    }
}
