// 7k_basicDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_basic.h"
#include "7k_basicDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_basicDlg dialog

CMy7k_basicDlg::CMy7k_basicDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CMy7k_basicDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_basicDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_basicDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
    ON_WM_SIZE()
#endif
    //}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_basicDlg::OnBnClickedButton1)
    ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_basicDlg::OnBnClickedButton2)
    ON_BN_CLICKED(IDC_BUTTON3, &CMy7k_basicDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CMy7k_basicDlg message handlers

BOOL CMy7k_basicDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here
    SetDlgItemText(IDC_COMBO1, L"COM3:");
    SetDlgItemText(IDC_EDIT1, L"115200");
    SetDlgItemText(IDC_EDIT2, L"@01");

    return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_basicDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    if(AfxIsDRAEnabled())
    {
        DRA::RelayoutDialog(
            AfxGetResourceHandle(),
            this->m_hWnd,
            DRA::GetDisplayMode() != DRA::Portrait ?
            MAKEINTRESOURCE(IDD_MY7K_BASIC_DIALOG_WIDE) :
            MAKEINTRESOURCE(IDD_MY7K_BASIC_DIALOG));
    }
}
#endif

HANDLE hPort;

void CMy7k_basicDlg::OnBnClickedButton1()
{
    // TODO: Add your control notification handler code here
    TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];

    //get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT1, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_basic", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
    }

}

void CMy7k_basicDlg::OnBnClickedButton2()
{
    // TODO: Add your control notification handler code here

    //close com port
    if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_basic", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
    }
}

void CMy7k_basicDlg::OnBnClickedButton3()
{
    // TODO: Add your control notification handler code here
    TCHAR temp[20];
    CString strTemp;
    char SendData[20] = {0};
    char Response[20] = {0};

    //get user will send command
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        SendData[i] = strTemp[i];
    }

    //use uart_SendCmd function  send command and use 3th parameter get result
    BOOL iret = uart_SendCmd(hPort, SendData, Response);

    if(!iret)
    {
        ::MessageBox(NULL, L"send error", L"7k_basic", MB_OK);
    }
    else
    {
        int length = strlen(Response);
        ZeroMemory(temp, 20);

        for(int i = 0; i < length; i++)
        {
            temp[i] = Response[i];
        }

        SetDlgItemText(IDC_EDIT3, temp);
    }
}
