// 7k_cntDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_cnt.h"
#include "7k_cntDlg.h"
#include "PACSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_cntDlg dialog

CMy7k_cntDlg::CMy7k_cntDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CMy7k_cntDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_cntDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_cntDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
    ON_WM_SIZE()
#endif
    //}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_cntDlg::OnBnClickedButton1)
    ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_cntDlg::OnBnClickedButton2)
    ON_BN_CLICKED(IDC_BUTTON3, &CMy7k_cntDlg::OnBnClickedButton3)
    ON_BN_CLICKED(IDC_BUTTON5, &CMy7k_cntDlg::OnBnClickedButton5)
    ON_BN_CLICKED(IDC_BUTTON4, &CMy7k_cntDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CMy7k_cntDlg message handlers

BOOL CMy7k_cntDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here

    //set default value
    SetDlgItemText(IDC_COMBO1, L"COM3:");
    SetDlgItemText(IDC_EDIT1, L"01");
    SetDlgItemText(IDC_EDIT2, L"9600");
    SetDlgItemText(IDC_EDIT3, L"16");
    SetDlgItemText(IDC_EDIT4, L"10");
    return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_cntDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    if(AfxIsDRAEnabled())
    {
        DRA::RelayoutDialog(
            AfxGetResourceHandle(),
            this->m_hWnd,
            DRA::GetDisplayMode() != DRA::Portrait ?
            MAKEINTRESOURCE(IDD_MY7k_cnt_DIALOG_WIDE) :
            MAKEINTRESOURCE(IDD_MY7k_cnt_DIALOG));
    }
}
#endif

HANDLE hPort;
void CMy7k_cntDlg::OnBnClickedButton1()
{
    // TODO: Add your control notification handler code here
    TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];

    //get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT2, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
    }
}

void CMy7k_cntDlg::OnBnClickedButton2()
{
    // TODO: Add your control notification handler code here

    //close com port
    if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
    }
}

void CMy7k_cntDlg::OnBnClickedButton3()
{
    // TODO: Add your control notification handler code here
    //uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    DWORD DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ReadCNT(hPort, slot, DICNTchannel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%d", DIValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy7k_cntDlg::OnBnClickedButton5()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    int DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ReadCNTOverflow(hPort, slot, DICNTchannel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%d", DIValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy7k_cntDlg::OnBnClickedButton4()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    DWORD DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ClearCNT(hPort, slot, DICNTchannel);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_cnt", MB_OK);
    }
}
