// 7k_di_latchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_di_latch.h"
#include "7k_di_latchDlg.h"
#include "pacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_di_latchDlg dialog

CMy7k_di_latchDlg::CMy7k_di_latchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k_di_latchDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_di_latchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_di_latchDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_di_latchDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_di_latchDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CMy7k_di_latchDlg message handlers

BOOL CMy7k_di_latchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_di_latchDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY7K_DI_LATCH_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY7K_DI_LATCH_DIALOG));
	}
}
#endif

HANDLE hPort;
BOOL iret;
void CMy7k_di_latchDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here

	TCHAR temp[20] = {0};
	DWORD DIValue = 0;
	DWORD HighLatch,LowLatch;
    TCHAR OpenPort[10];
    char port[20];
	int address;
	int BuadRate;
	int Totalchannel;

	/////
	//DWORD getError;
	//wchar_t temptext[255]={0};
	////

    //get com port
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    //get user set address
	GetDlgItemText(IDC_EDIT1, temp, 20);
    address = _wtoi(temp);

	//get buad rate
    GetDlgItemText(IDC_EDIT2, temp, 20);
    BuadRate = _wtoi(temp);								// _wtoi = string to integer

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_di_latch", MB_OK);
    }

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    Totalchannel = _wtoi(temp);


	//use pac_ReadAI functio to read DI data
	iret = pac_ReadDI(hPort, PAC_REMOTE_IO(address),Totalchannel,&DIValue);


	/*getError = pac_GetLastError();
	swprintf(temptext,L"%d",getError);
	::MessageBox(NULL,temptext,L"DDDD",MB_OK);*/


	if(!iret)
	{
		::MessageBox(NULL,L"Read DI error",L"7k_di_latch",MB_OK);
		uart_Close(hPort);
		return;
	}
	else
	{
		wsprintf(temp,L"0x%lx",DIValue);
		SetDlgItemText(IDC_EDIT4,temp);
	}

	//use pac_ReadDILatch functio to read DI Latch data ,5th parameter set 1 indicates High latch
	iret = pac_ReadDILatch(hPort, PAC_REMOTE_IO(address),Totalchannel,1,&HighLatch);
	if(!iret)
	{
		::MessageBox(NULL,L"Read DI High latch error",L"7k_di_latch",MB_OK);
		uart_Close(hPort);
		return;
	}
	else
	{
		wsprintf(temp,L"0x%lx",HighLatch);
		SetDlgItemText(IDC_EDIT5,temp);
	}

	//use pac_ReadDILatch functio to read DI Latch data ,5th parameter set 0 indicates low latch
	iret = pac_ReadDILatch(hPort, PAC_REMOTE_IO(address),Totalchannel,0,&LowLatch);

	//close open port
	if(!iret)
	{
		::MessageBox(NULL,L"Read DI Low latch error",L"7k_di_latch",MB_OK);
		uart_Close(hPort);
		return;
	}
	else
	{
		wsprintf(temp,L"0x%lx",LowLatch);
		SetDlgItemText(IDC_EDIT6,temp);
	}
	uart_Close(hPort);}

void CMy7k_di_latchDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here

	TCHAR temp[20];
    TCHAR OpenPort[10];
    char port[20];

	//get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT2, temp, 20);
    int BuadRate = _wtoi(temp);								// _wtoi = string to integer

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //get user set address
	GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

	//use pac_ClearDILatch functio to clear DI Latch data
	pac_ClearDILatch(hPort,address);
	uart_Close(hPort);
	SetDlgItemText(IDC_EDIT5,L"0");
	SetDlgItemText(IDC_EDIT6,L"0");
}
