// BPTimerDlg.cpp : implementation file
//
// Note:
// It's best to choose I-8055W/I-8056W non-isolated DO module for this program.
// The isolated component on isolated DO channel will affect DO response in high speed output switching (ON --> OFF -->ON). 
//
//

#include "stdafx.h"
#include "BPTimer.h"
#include "BPTimerDlg.h"
#include "PACSDK.h"

// CBPTimerDlg dialog

CBPTimerDlg::CBPTimerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBPTimerDlg::IDD, pParent)
	, m_timer2(_T(""))
	, m_timeroutLow(_T(""))
	, m_timerouthigh(_T(""))
	, m_timer1(_T(""))
{
	m_timer1 = _T("50000"); //50ms
	m_timer2 = _T("10000"); //100 ms
	m_timerouthigh = _T("20000");//20ms
	m_timeroutLow = _T("30000");//30ms

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBPTimerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_slot);
	DDX_Text(pDX, IDC_EDIT4, m_timer2);
	DDX_Text(pDX, IDC_EDIT3, m_timeroutLow);
	DDX_Text(pDX, IDC_EDIT1, m_timerouthigh);
	DDX_Text(pDX, IDC_EDIT2, m_timer1);
}

BEGIN_MESSAGE_MAP(CBPTimerDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CBPTimerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CBPTimerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CBPTimerDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CBPTimerDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CBPTimerDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CBPTimerDlg::OnBnClickedButton6)
	ON_CBN_SELCHANGE(IDC_COMBO1, &CBPTimerDlg::OnCbnSelchangeCombo1)
	ON_CBN_SETFOCUS(IDC_COMBO1, &CBPTimerDlg::OnCbnSetfocusCombo1)
END_MESSAGE_MAP()


// CBPTimerDlg message handlers
int gislot=0;

BOOL CBPTimerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_slot.SetCurSel(1);
	gislot=1;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CBPTimerDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_BPTIMER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_BPTIMER_DIALOG));
	}
}
#endif

int ivalue=0;
int CALLBACK CTIMER1() //Interrupt Function
////Connect DO channel 0 to the  osilloscope  for monitoring the square wave.
{
	int ivalue;
	static int gbtrigger=0;

	if(!gbtrigger) //rising edge type
	{

		gbtrigger=1;		

		ivalue |=1;
		_pac_slot_outp(gislot,0,ivalue);
		//_pac_slot_outp is a specific API function and it is released for private use
		//_pac_slot_outp is a high performance DO write function than pac_WriteDO
	}
	else//falling edge type
	{
		gbtrigger=0;
		ivalue &= (~1);
		_pac_slot_outp(gislot,0,ivalue);
		//_pac_slot_outp is a specific API function and it is released for private use
		//_pac_slot_outp is a high performance DO write function than pac_WriteDO
	}

    return PAC_INTR_DONE;
}
int CALLBACK CTIMER2() //Interrupt Function
////Connect DO channel 1 to the  osilloscope  for monitoring the square wave.
{
	int ivalue;
	static int gbtrigger=0;


	if(!gbtrigger) //rising edge type
	{

		gbtrigger=1;		
		ivalue |= (1<<1);
		_pac_slot_outp(gislot,0,ivalue);
		//_pac_slot_outp is a specific API function and it is released for private use
		//_pac_slot_outp is a high performance DO write function than pac_WriteDO
	}
	else//falling edge type
	{
		gbtrigger=0;
		ivalue &= ~(1<<1);
		_pac_slot_outp(gislot,0,ivalue);

	}

    return PAC_INTR_DONE;
}

int CALLBACK CTIMER3() //Interrupt Function
////Connect DO channel 2 to the  osilloscope  for monitoring the square wave.
{
	int ivalue;
	static int gbtrigger=0;
	

	if(!gbtrigger) //rising edge type
	{

		gbtrigger=1;		
		ivalue |= (1<<2);
		_pac_slot_outp(gislot,0,ivalue);
		//_pac_slot_outp is a specific API function and it is released for private use
		//_pac_slot_outp is a high performance DO write function than pac_WriteDO
	}
	else//falling edge type
	{
		gbtrigger=0;
		ivalue &= ~(1<<2);
		_pac_slot_outp(gislot,0,ivalue);

	}

    return PAC_INTR_DONE;
}
void CBPTimerDlg::OnBnClickedButton1()
{
	TCHAR tcTemp[100]={0};
	unsigned int uitimeoutHigh=0;
	unsigned int uitimeoutLow=0;


	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	//Get bp retrigger
	uitimeoutHigh= _wtoi(tcTemp);

	GetDlgItemText(IDC_EDIT3,tcTemp,100);
	//Get bp retrigger
	uitimeoutLow= _wtoi(tcTemp);
	
	//printf("slot %d, High= %d, Low= %d\r\n",gislot,);
	pac_SetBPTimerOut(uitimeoutHigh,uitimeoutLow,CTIMER3);
	pac_SetBPTimerInterruptPriority(0,100);
}

void CBPTimerDlg::OnBnClickedButton2()
{
	TCHAR tcTemp[100]={0};
	unsigned int uitimeout=0;


	GetDlgItemText(IDC_EDIT2,tcTemp,100);
	//Get bp retrigger
	uitimeout= _wtoi(tcTemp);
//	printf("%u\r\n",uitimeout);

	pac_SetBPTimer(1,uitimeout,CTIMER1); //1us
	pac_SetBPTimerInterruptPriority(1,100);
}

void CBPTimerDlg::OnBnClickedButton3()
{
	TCHAR tcTemp[100]={0};
	unsigned int uitimeout=0;

	GetDlgItemText(IDC_EDIT4,tcTemp,100);
	//Get bp retrigger
	uitimeout= _wtoi(tcTemp);

	pac_SetBPTimer(2,uitimeout,CTIMER2);	
	pac_SetBPTimerInterruptPriority(2,100);
}

void CBPTimerDlg::OnBnClickedButton4()
{
	pac_KillBPTimer(0);
}

void CBPTimerDlg::OnBnClickedButton5()
{
 pac_KillBPTimer(1);	
}

void CBPTimerDlg::OnBnClickedButton6()
{
 pac_KillBPTimer(2);
}

void CBPTimerDlg::OnCbnSelchangeCombo1()
{
	gislot= m_slot.GetCurSel()+1;
//	printf("slot=%d",gislot);
}

void CBPTimerDlg::OnCbnSetfocusCombo1()
{
	// TODO: Add your control notification handler code here
}
