// DeviceInformationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DeviceInformation.h"
#include "DeviceInformationDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CDeviceInformationDlg dialog

CDeviceInformationDlg::CDeviceInformationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceInformationDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDeviceInformationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDeviceInformationDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CDeviceInformationDlg message handlers

BOOL CDeviceInformationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	initDeviceInformation();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CDeviceInformationDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_DEVICEINFORMATION_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_DEVICEINFORMATION_DIALOG));
	}
}
#endif

void CDeviceInformationDlg::initDeviceInformation(){
	char data[80];
	TCHAR temp[80];
	ZeroMemory(data,80);
	ZeroMemory(temp,80);

	//call pac_GetSerialNumber function to get serial number
	pac_GetSerialNumber(data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	wsprintf(temp,L"%c%c-%c%c-%c%c-%c%c-%c%c-%c%c-%c%c-%c%c",
	temp[0],temp[1],temp[2],temp[3],temp[4],temp[5],temp[6],temp[7],temp[8],temp[9],temp[10],temp[11],temp[12],temp[13],temp[14],temp[15],temp[16]);
	SetDlgItemText(IDC_EDIT1,temp);

	ZeroMemory(data,80);
	ZeroMemory(temp,80);

	//call pac_GetCPUVersion function to get CPU Version
	pac_GetCPUVersion(data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT2,temp);

	ZeroMemory(data,80);
	ZeroMemory(temp,80);
	//call pac_GetOSVersion function to get OS Version
	pac_GetOSVersion(data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT3,temp);

	ZeroMemory(data,80);
	ZeroMemory(temp,80);
	//call pac_GetSDKVersion function to get SDK Version
	pac_GetSDKVersion(data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT4,temp);

	ZeroMemory(data,80);
	ZeroMemory(temp,80);
	//call pac_GetMacAddress function to get LAN1 Mac address
	pac_GetMacAddress(1,data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT5,temp);

	ZeroMemory(data,80);
	ZeroMemory(temp,80);
	//call pac_GetMacAddress function to get LAN2 Mac address
	pac_GetMacAddress(2,data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT6,temp);

	ZeroMemory(data,80);
	ZeroMemory(temp,80);
	//call pac_GetBackplaneID function to get backplane id
	pac_GetBackplaneID(data);
	for(int i=0;i<strlen(data);i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT7,temp);

	//call pac_GetBatteryLevel function to get battery state
	if(pac_GetBatteryLevel(1) == 1){
		SetDlgItemText(IDC_EDIT8,L"High");
	}else{
		SetDlgItemText(IDC_EDIT8,L"Low");
	}

	if(pac_GetBatteryLevel(2) == 1){
		SetDlgItemText(IDC_EDIT9,L"High");
	}else{
		SetDlgItemText(IDC_EDIT9,L"Low");
	}
}