// DiagnosticDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Diagnostic.h"
#include "DiagnosticDlg.h"
#include "PACSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CDiagnosticDlg dialog

CDiagnosticDlg::CDiagnosticDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiagnosticDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiagnosticDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC1, Label1);
}

BEGIN_MESSAGE_MAP(CDiagnosticDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CDiagnosticDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CDiagnosticDlg message handlers

BOOL CDiagnosticDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//default call function to read backplan module
	OnBnClickedButton1();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CDiagnosticDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_DIAGNOSTIC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_DIAGNOSTIC_DIALOG));
	}
}
#endif


void CDiagnosticDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
	BOOL exit=FALSE;
	char temp[20]={0};
	char cmd[10]="$00M";

	//get backplan slot number
	int TotalSlot =  pac_GetSlotCount();
	TCHAR name[20]={0};
	int ModuleType=0;

	//read all slot , and get module name
	for(int i=0;i<TotalSlot;i++){
		//if slot i has inset module , will return true
		exit = pac_ModuleExists(0,(i+1));
		GetDlgItem((IDC_STATIC1+i))->ShowWindow(SW_SHOW);
		GetDlgItem((IDC_EDIT1+i))->ShowWindow(SW_SHOW);
		if(exit){
			GetDlgItem((IDC_STATIC1+i))->EnableWindow(TRUE);
			GetDlgItem((IDC_EDIT1+i))->EnableWindow(TRUE);
			ModuleType = pac_GetModuleName( (i+1),temp);

			//check module is 87k moduel or 8k module
			if(ModuleType == 255){
				
				pac_ChangeSlot((i+1));
				ZeroMemory(temp,20);
				//87k module will send command to get module name
				uart_SendCmd(hPort,cmd,temp);

				//result is !xx87017, so read module name from 3th char
				for(int j=3;j<strlen(temp);j++){
					name[j-3] = temp[j];
				}
			}else{
				ZeroMemory(name,20);

				//8k moduel use pac_GetModuleName to get name, so can't send command
				for(int j=0;j<strlen(temp);j++){
					name[j] = temp[j];
				}
			}
			//set module name in TextBox
			SetDlgItemText((IDC_EDIT1+i),name);
		}else{
			//if slot i haven't insert module will disable TextBox and lable
			GetDlgItem((IDC_STATIC1+i))->EnableWindow(FALSE);
			GetDlgItem((IDC_EDIT1+i))->EnableWindow(FALSE);
			SetDlgItemText((IDC_EDIT1+i),L"NULL");
		}
	}
	uart_Close(hPort);
}
