// MemoryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Memory.h"
#include "MemoryDlg.h"
#include "PACSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMemoryDlg dialog

CMemoryDlg::CMemoryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMemoryDlg::IDD, pParent)
	, BackRAM(0)
	, EEPROM(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMemoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RADIO2, EEPRAM);
	DDX_Control(pDX, IDC_RADIO1, SRAM);
}

BEGIN_MESSAGE_MAP(CMemoryDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMemoryDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_RADIO1, &CMemoryDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CMemoryDlg::OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_BUTTON2, &CMemoryDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CMemoryDlg message handlers

BOOL CMemoryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	//set default value
	init();
	SetDlgItemText(IDC_EDIT1,L"0");
	SetDlgItemText(IDC_EDIT2,L"5");
	SetDlgItemText(IDC_EDIT3,L"abcde");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMemoryDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MEMORY_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MEMORY_DIALOG));
	}
}
#endif

void CMemoryDlg::init(){
	TCHAR temp[60];

	//get memory size and show on label
	DWORD BackSize = pac_GetMemorySize(0);
	DWORD EPROMSize = pac_GetMemorySize(1);

	wsprintf(temp,L"Backplane SRAM  of  %d size",BackSize);
	GetDlgItem(IDC_RADIO1)->SetWindowTextW(temp);

	wsprintf(temp,L"EEPROM of %d size",EPROMSize);
	GetDlgItem(IDC_RADIO2)->SetWindowTextW(temp);
}

int MemType =0; //0 SRAM , 1 EEPROM
void CMemoryDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	BYTE data[30];
	CString strTemp;
	TCHAR temp[30];
	int size = 0;

	//get user will write word
	GetDlgItemText(IDC_EDIT3,strTemp);
	ZeroMemory(data,30);
	int length = strTemp.GetAllocLength();
	for(int i=0;i<length;i++){
		data[i] = strTemp[i];
	}

	size = pac_GetMemorySize(MemType);

	if(SRAM.GetCheck() || EEPRAM.GetCheck()){
		//get user will write memory address
		GetDlgItemText(IDC_EDIT1,temp,30);
		int index = _wtoi(temp);
		if(index<0)
			index = 0;
		if(index>size)
			index = size-1;

		if(MemType == 1){
			pac_EnableEEPROM(TRUE);
		}
		pac_WriteMemory(index,data,length,MemType);
		if(MemType == 1){
			pac_EnableEEPROM(FALSE);
		}

	}


}

void CMemoryDlg::OnBnClickedRadio1()
{
	// TODO: Add your control notification handler code here
	if(SRAM.GetCheck()){
		MemType = 0;
		EEPRAM.SetCheck(FALSE);
	}else
		MemType = 1;
}

void CMemoryDlg::OnBnClickedRadio2()
{
	// TODO: Add your control notification handler code here
	if(EEPRAM.GetCheck()){
		MemType = 1;
		SRAM.SetCheck(FALSE);
	}else
		MemType = 0;
}

void CMemoryDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	BYTE data[30];
	TCHAR temp[30];
	int ReadByte=0;
	//get user will read memory size
	int size = pac_GetMemorySize(MemType);

	GetDlgItemText(IDC_EDIT1,temp,30);
	int index = _wtoi(temp);
	if(index<0)
		index = 0;
	if(index>size)
		index = size-1;

	//get read size of memory
	GetDlgItemText(IDC_EDIT2,temp,30);
	ReadByte = _wtoi(temp);

	//get read data in memory address
	ZeroMemory(data,30);
	pac_ReadMemory(index,data,ReadByte,MemType);
	for(int i=0;i<ReadByte;i++){
		temp[i] = data[i];
	}
	SetDlgItemText(IDC_EDIT4,temp);
}
