// RealTimeTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RealTimeTest.h"
#include "RealTimeTestDlg.h"
#include "PACSDK.h"
#include "Winreg.h"
#include "Mmsystem.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CRealTimeTestDlg dialog

CRealTimeTestDlg::CRealTimeTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRealTimeTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRealTimeTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CRealTimeTestDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CRealTimeTestDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CRealTimeTestDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CRealTimeTestDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CRealTimeTestDlg message handlers

BOOL CRealTimeTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//set default value
	SetDlgItemText(IDC_COMBO1,L"1");
	SetDlgItemText(IDC_EDIT1,L"16");
	SetDlgItemText(IDC_EDIT2,L"0xffff");
	SetDlgItemText(IDC_EDIT3,L"10");
	SetDlgItemText(IDC_EDIT4,L"1");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CRealTimeTestDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_REALTIMETEST_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_REALTIMETEST_DIALOG));
	}
}
#endif

DWORD DOValue=0;
bool led=false;
HANDLE hPort;
int slot;
int channel;
UINT timerID;

void CALLBACK CallProc(UINT   uID,   UINT   uMsg,DWORD   dwUser,DWORD   dw1,DWORD   dw2){
	if(led){
		//turn on LED
		pac_WriteDO(hPort,slot,channel,DOValue);
		led = false;
	}else{
		//turn off LED
		pac_WriteDO(hPort,slot,channel,0);
		led = true;
	}
}

void CRealTimeTestDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	HKEY HK = HKEY_LOCAL_MACHINE;
	HKEY hKey;
	BYTE data;
	CString temp;
	TCHAR message[70];
	long result;
	int value=0;

	GetDlgItemText(IDC_EDIT4,temp);
	data = _wtoi(temp);
	int length = temp.GetAllocLength();


	//check register,if register haven't MMTIMER then create key and set value
	result = RegOpenKeyEx(HK,L"System\\MMTIMER",0,0,&hKey);
	if(result != ERROR_SUCCESS){
		if(result == ERROR_FILE_NOT_FOUND){
			result = RegCreateKeyEx(HK,L"System\\MMTIMER",0,REG_OPTION_NON_VOLATILE,0,0,0,&hKey,NULL);
			if(result !=ERROR_SUCCESS){
				wsprintf(message,L"create key error, error code %d",result);
				::MessageBox(NULL,message,L"RealTimeTest",MB_OK);
				return;
			}
		}else{
			wsprintf(message,L"open key error, error code %d",result);
			::MessageBox(NULL,message,L"RealTimeTest",MB_OK);
			return ;
		}
	}
	result = RegSetValueEx(hKey,L"Priority256",NULL,REG_DWORD,&data,sizeof(BYTE));
	if(result != ERROR_SUCCESS){
		::MessageBox(NULL,L"Set Priority256 value error",L"RealTimeTest",MB_OK);
	}
}

void CRealTimeTestDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[30];
	CString strTemp;
	char ctemp[20]={0};
	DOValue=0;

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,30);
	slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,30);
	channel = _wtoi(temp);

	//get user input value(HEX)
	GetDlgItemText(IDC_EDIT2,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}

	//get user inpu interval time value
	GetDlgItemText(IDC_EDIT3,temp,30);
	UINT interval = _wtoi(temp);
	sscanf(ctemp,"%lx",&DOValue);
	timeBeginPeriod(1);
	hPort = uart_Open("");

	timeBeginPeriod(1);
	//call timeSetEvent and input user setting value for create time event
	timerID = timeSetEvent(interval,1, CallProc, 0 ,TIME_PERIODIC);

}

void CRealTimeTestDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here

	//kill user seting time event
	timeKillEvent(timerID);
	timeEndPeriod(1);
	uart_Close(hPort);
}
