// WatchDogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WatchDog.h"
#include "WatchDogDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CWatchDogDlg dialog

CWatchDogDlg::CWatchDogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWatchDogDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWatchDogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, cmbDogMode);
}

BEGIN_MESSAGE_MAP(CWatchDogDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CWatchDogDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CWatchDogDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CWatchDogDlg::OnBnClickedButton3)
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CWatchDogDlg message handlers

BOOL CWatchDogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_COMBO1,L"Hardware WDT");
	SetDlgItemText(IDC_EDIT2,L"10");
	cmbDogMode.SetCurSel(0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CWatchDogDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_WATCHDOG_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_WATCHDOG_DIALOG));
	}
}
#endif



void CWatchDogDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[10];
	GetDlgItemText(IDC_EDIT2,temp,10);
	wdtTime = _wtoi(temp);
	if(wdtTime==0){
		wdtTime=10;
	}
	second = 0;

	int dogMode = cmbDogMode.GetCurSel();

	//use pac_EnableWatchDog enable watch dog
	//pac_EnableWatchDog 1th parameter is watch dog mode. Hardware watch dog is 0, OS watch dog is 1.
	//2th parameter is watch dog time,if you haven't refresh will restart in setting watch dog time.
	pac_EnableWatchDog(dogMode,wdtTime);

	//start timer
	OnStartTimer();

}

void CWatchDogDlg::OnStartTimer(){
	//set 1 timer, interval 1 second,haven't call back function
	SetTimer(1,100,0);
}

void CWatchDogDlg::OnTimer(UINT nIDEvent){
	second++;
	TCHAR temp[30];
	if(nIDEvent ==1){
		//show second in label
		wsprintf(temp,L"%d00",second);
		SetDlgItemText(IDC_EDIT1,temp);
	}

}

void CWatchDogDlg::StopTimer(){
	KillTimer(1);
}

void CWatchDogDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here

	int dogMode = cmbDogMode.GetCurSel();
	//use disable pac_DisableWatchDog watchdog
	pac_DisableWatchDog(dogMode);
	StopTimer();
}

void CWatchDogDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here

	//use pac_RefreshWatchDog refresh watchdog
	int dogMode = cmbDogMode.GetCurSel();
	pac_RefreshWatchDog(dogMode);
	second = 0;
}
