// 87k_aiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_ai.h"
#include "87k_aiDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87k_aiDlg dialog

CMy87k_aiDlg::CMy87k_aiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_aiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_aiDlg)
	m_AIChannels = _T("");
	m_AIValue = _T("");
	m_Channel_Readed = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_aiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_aiDlg)
	DDX_Control(pDX, IDC_COMBOAISlot, m_cmbAISlot);
	DDX_Control(pDX, IDC_BUTTONReadAI, m_btnReadAI);
	DDX_Text(pDX, IDC_EDITAIChannels, m_AIChannels);
	DDX_Text(pDX, IDC_EDITAIValue, m_AIValue);
	DDX_Text(pDX, IDC_EDITCh_Readed, m_Channel_Readed);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_aiDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_aiDlg)
	ON_BN_CLICKED(IDC_BUTTONReadAI, OnBUTTONReadAI)
	ON_BN_CLICKED(IDC_BUTTONReadAI2, OnBUTTONReadAI2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_aiDlg message handlers

BOOL CMy87k_aiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbAISlot.SetCurSel(0);
	m_AIChannels=_T("8");
	m_Channel_Readed=_T("0");
	m_AIValue=_T("0.0");
	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy87k_aiDlg::OnBUTTONReadAI() 
{
	// TODO: Add your control notification handler code here
	short iSlot;
	short iChannel_Readed,iAIChannels;
	float fAIValue;
	char cTmp[15];
	
	//First open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DI module is
	iSlot=m_cmbAISlot.GetCurSel ();
	
	UpdateData(true);
	//Get the channel which is readed
	wcstombs(cTmp,m_Channel_Readed,15);
	iChannel_Readed=atoi(cTmp);

	//Get AI channel value
	wcstombs(cTmp,m_AIChannels,15);
	iAIChannels=atoi(cTmp);

	//Read AI value	
	bool res = pac_ReadAI( hPort, iSlot,iChannel_Readed,iAIChannels,&fAIValue);
	if(!res) {
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
		uart_Close(hPort);
		return;
	}

	//Show AI value
	sprintf(cTmp,"%f",fAIValue);
	m_AIValue=cTmp;
	UpdateData(false);

	//Close com port
	uart_Close(hPort);
}

void CMy87k_aiDlg::OnBUTTONReadAI2() 
{
	// TODO: Add your control notification handler code here
	short iSlot;
	short iChannel_Readed,iAIChannels;
	float fAIValue[32] = {0};
	char cTmp[15];

	DWORD len = 0;
	
	//First open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DI module is
	iSlot=m_cmbAISlot.GetCurSel ();
	
	UpdateData(true);
	//Get the channel which is readed
	wcstombs(cTmp,m_Channel_Readed,15);
	iChannel_Readed=atoi(cTmp);

	//Get AI channel value
	wcstombs(cTmp,m_AIChannels,15);
	iAIChannels=atoi(cTmp);

	//Read AI value	
	bool res = pac_ReadAIAllExt(hPort, iSlot,fAIValue, 32, &len);

	if(!res) {
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
		uart_Close(hPort);
		return;
	}

	//Show AI value
	for(int i = 0; i < 32; i++)
	{
		printf("channel %d, value: %f\n", i, fAIValue[i]);
	}

	printf("total channel len: %d\n", len);

	//Close com port
	uart_Close(hPort);
}
