// 87k_di_latchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_di_latch.h"
#include "87k_di_latchDlg.h"
#include "PACSDK.h"
				
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87k_di_latchDlg dialog

CMy87k_di_latchDlg::CMy87k_di_latchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_di_latchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_di_latchDlg)
	m_DIChannels = _T("");
	m_DIValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_di_latchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_di_latchDlg)
	DDX_Control(pDX, IDC_COMBODISlot, m_cmbDISlot);
	DDX_Control(pDX, IDC_BUTTONReadDI, m_btnReadDI);
	DDX_Text(pDX, IDC_EDITDIChannels, m_DIChannels);
	DDX_Text(pDX, IDC_EDITDIValue, m_DIValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_di_latchDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_di_latchDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_di_latchDlg message handlers

BOOL CMy87k_di_latchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbDISlot.SetCurSel(0);
	m_DIChannels=_T("8");
	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_di_latchDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	DWORD DIValue = 0;
	DWORD HighLatch,LowLatch;
	
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int channel =_wtoi(temp);

	//use pac_ReadAI functio to read DI data
	BOOL iret = pac_ReadDI(hPort,slot,channel,&DIValue);
	if(!iret){
		::MessageBox(NULL,L"Read DI error",L"87k_di_latch",MB_OK);
		uart_Close(hPort);
		return;
	}else{
		wsprintf(temp,L"0x%lx",DIValue);
		SetDlgItemText(IDC_EDIT5,temp);
	}

	//use pac_ReadDILatch functio to read DI Latch data ,5th parameter set 1 indicates High latch
	iret = pac_ReadDILatch(hPort,slot,channel,1,&HighLatch);
	if(!iret){
		::MessageBox(NULL,L"Read DI High latch error",L"87k_di_latch",MB_OK);
		uart_Close(hPort);
		return;
	}else{
		wsprintf(temp,L"0x%lx",HighLatch);
		SetDlgItemText(IDC_EDIT6,temp);
	}

	//use pac_ReadDILatch functio to read DI Latch data ,5th parameter set 0 indicates low latch
	iret = pac_ReadDILatch(hPort,slot,channel,0,&LowLatch);

	//close open port
	if(!iret){
		::MessageBox(NULL,L"Read DI Low latch error",L"87k_di_latch",MB_OK);
		uart_Close(hPort);
		return;
	}else{
		wsprintf(temp,L"0x%lx",LowLatch);
		SetDlgItemText(IDC_EDIT7,temp);
	}
	uart_Close(hPort);
}

void CMy87k_di_latchDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int channel =_wtoi(temp);

	//use pac_ClearDILatch functio to clear DI Latch data
	pac_ClearDILatch(hPort,slot);
	uart_Close(hPort);
	SetDlgItemText(IDC_EDIT6,L"0");
	SetDlgItemText(IDC_EDIT7,L"0");
}
