// 87k_dioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_dio.h"
#include "87k_dioDlg.h"
#include "PACSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//base variables
short iSlot,iDIChannels,iDOChannels;
char cTmp[15];
unsigned long lDIValue,lDOValue;
/////////////////////////////////////////////////////////////////////////////
// CMy87k_dioDlg dialog

CMy87k_dioDlg::CMy87k_dioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_dioDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_dioDlg)
	m_DIChs = _T("");
	m_DIValue = _T("");
	m_DOChs = _T("");
	m_DOValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_dioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_dioDlg)
	DDX_Control(pDX, IDC_BUTTONWriteDO, m_btnWriteDO);
	DDX_Control(pDX, IDC_BUTTONReadDI, m_btnReadDI);
	DDX_Control(pDX, IDC_BUTTONClearDO, m_btnClearDO);
	DDX_Control(pDX, IDC_COMBODIOSlot, m_cmbDIOSlot);
	DDX_Text(pDX, IDC_EDITDIChannels, m_DIChs);
	DDX_Text(pDX, IDC_EDITDIValue, m_DIValue);
	DDX_Text(pDX, IDC_EDITDOChannels, m_DOChs);
	DDX_Text(pDX, IDC_EDITDOValue, m_DOValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_dioDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_dioDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	ON_BN_CLICKED(IDC_BUTTONClearDO, OnBUTTONClearDO)
	ON_BN_CLICKED(IDC_BUTTONWriteDO2, OnBUTTONWriteDO2)
	ON_BN_CLICKED(IDC_BUTTONClearDO2, OnBUTTONClearDO2)
	ON_BN_CLICKED(IDC_BUTTONReadDI2, OnBUTTONReadDI2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_dioDlg message handlers

BOOL CMy87k_dioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbDIOSlot.SetCurSel(0);
	m_DOChs=m_DIChs=_T("8");
	m_DOValue=_T("01");
	UpdateData(false);
	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");


	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_dioDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here

	//First,Open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot.GetCurSel ();

	UpdateData(true);
	//Get DI Channels
	wcstombs(cTmp,m_DIChs,15);
	iDIChannels=atoi(cTmp);

	//Get DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);

	//Read DI,DO values
	bool res = pac_ReadDIO( hPort, iSlot,iDIChannels,iDOChannels,&lDIValue,&lDOValue);
	
	if(!res) {
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
		//Close com port
	    uart_Close(hPort);
		return;
	}
	//Show DI value
	sprintf(cTmp,"%lx",lDIValue);
	m_DIValue=cTmp;
	UpdateData(false);
	
	//Close com port
	uart_Close(hPort);
}

void CMy87k_dioDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here

	//First,Open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot.GetCurSel ();

	UpdateData(true);

	//Get DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);

	//Get DO value
	wcstombs(cTmp,m_DOValue,15);
	sscanf(cTmp,"%lx",&lDOValue);

	//Write DO
	
	bool res=pac_WriteDO(hPort, iSlot,iDOChannels,lDOValue);
	if(!res){
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
	}
	//Close com port
	uart_Close(hPort);
}

void CMy87k_dioDlg::OnBUTTONClearDO() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort;
	hPort = uart_Open("");
	bool res = pac_WriteDO(hPort, iSlot,iDOChannels,0);	
	if(!res) AfxMessageBox(_T("No module or module is wrong or something wrong"));
	m_DOValue=_T("0");
	UpdateData(false);
	uart_Close(hPort);
}

void CMy87k_dioDlg::OnBUTTONWriteDO2() 
{
	// TODO: Add your control notification handler code here

	//First,Open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot.GetCurSel ();

	UpdateData(true);

	//Get DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);

	//Get DO value
	wcstombs(cTmp,m_DOValue,15);
	sscanf(cTmp,"%lx",&lDOValue);

	//Write DO
	
	bool res=pac_WriteDO_MF(hPort, iSlot,iDOChannels,lDOValue);
	if(!res){
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
	}
	//Close com port
	uart_Close(hPort);
	
}

void CMy87k_dioDlg::OnBUTTONClearDO2() 
{
// TODO: Add your control notification handler code here
	HANDLE hPort;
	hPort = uart_Open("");
	bool res = pac_WriteDO_MF(hPort, iSlot,iDOChannels,0);	
	if(!res) AfxMessageBox(_T("No module or module is wrong or something wrong"));
	m_DOValue=_T("0");
	UpdateData(false);
	uart_Close(hPort);	
}

void CMy87k_dioDlg::OnBUTTONReadDI2() 
{
// TODO: Add your control notification handler code here

	//First,Open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot.GetCurSel ();

	UpdateData(true);
	//Get DI Channels
	wcstombs(cTmp,m_DIChs,15);
	iDIChannels=atoi(cTmp);

	//Get DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);

	//Read DI,DO values
	bool res = pac_ReadDIO_MF( hPort, iSlot,iDIChannels,iDOChannels,&lDIValue,&lDOValue);
	
	if(!res) {
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
		//Close com port
	    uart_Close(hPort);
		return;
	}
	//Show DI value
	sprintf(cTmp,"%lx",lDIValue);
	m_DIValue=cTmp;
	UpdateData(false);
	
	//Close com port
	uart_Close(hPort);	
}
