// pac8017HDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pac8017HDemo.h"
#include "pac8017HDemoDlg.h"

#include "pac_i8017HW.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CString ErrorStr[7];




/////////////////////////////////////////////////////////////////////////////
// CPac8017HDemoDlg dialog

CPac8017HDemoDlg::CPac8017HDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac8017HDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac8017HDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac8017HDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac8017HDemoDlg)
	DDX_Control(pDX, IDC_TYPE, m_type);
	DDX_Control(pDX, IDC_SLOT, m_slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac8017HDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPac8017HDemoDlg)
	ON_BN_CLICKED(IDC_Exit, OnExit)
	ON_BN_CLICKED(IDC_AI, OnAi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac8017HDemoDlg message handlers

BOOL CPac8017HDemoDlg::OnInitDialog()
{
	int i;
	CString str,typeStr[6];
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
 /*   
    iChannel: 0~7
    iGain:  0 ==>   +/- 10.0  V
            1 ==>   +/-  5.0  V
            2 ==>   +/-  2.5  V
            3 ==>   +/-  1.25 V
            4 ==>   +/- 20.0  mA
*/
	typeStr[0]="Voltage +/- 10.0 V ";
	typeStr[1]="Voltage +/-  5.0 V ";
	typeStr[2]="Voltage +/-  2.5 V ";
	typeStr[3]="Voltage +/-  1.25 V ";
	typeStr[4]="Voltage +/- 20.0 mA ";

	ErrorStr[0]="NoError";              // 0
	ErrorStr[1]="ID_ERROR";				//-1
	ErrorStr[2]="SLOT_ERROR";			//-2
	ErrorStr[3]="CHANNEL_ERROR";		//-3
	ErrorStr[4]="GAIN_ERROR";			//-4
	ErrorStr[5]="INT_MODE_ERROR";		//-5	
	ErrorStr[6]="NOT_SUPPORT_ERROR";	//-6


	for (i=0 ;i <8 ; i++)
	{
		str.Format(_T("Slot %d"),i);
		m_slot.AddString(str);
	}
	m_slot.SetCurSel(0);



	for(i=0;i<5;i++)
	{
		m_type.AddString (typeStr[i]);
	}
	// TODO: Add extra initialization here


	return TRUE;  // return TRUE  unless you set the focus to a control
}









void CPac8017HDemoDlg::OnAi() 
{
	
	// TODO: Add your control notification handler code here
	int ch;
	short ret;
	CString str;
	
	int totalCh=8;
	int slotIndex; //=0
	short single_differential_jumper=0;
	short DSub_Status=1;

    int gain;
	
	float fVal=0;


	CString SingleEndedStr[2];

	SingleEndedStr[0]="Differential";
	SingleEndedStr[1]="Single Ended";

	CString DSubStr[2];

	DSubStr[0]="Close";
	DSubStr[1]="Open";
	
	UpdateData(false);


	// First step to Initialize the 8017HW
	slotIndex=m_slot.GetCurSel();
	m_slot.SetCurSel(slotIndex);
	ret=pac_i8017HW_Init(slotIndex);	
	if(ret)
	{
		str.Format(_T("Slot[%d]=>pac_i8017HW_Init error %s"),slotIndex,ErrorStr[ret*(-1)]);
		SetDlgItemText(IDC_STATUS,str);
		return;
	}
	else
		SetDlgItemText(IDC_STATUS,_T(" "));
	//	
	ret=pac_i8017HW_GetSingleEndJumper(slotIndex,&single_differential_jumper);
	if(ret)
	{
		str.Format(_T("Slot[%d]=>pac_i8017HW_GetSingleEndJumper error %s"),slotIndex,ErrorStr[ret*(-1)]);
		SetDlgItemText(IDC_STATUS,str);
		return;
	}
	else
		SetDlgItemText(IDC_STATUS,_T(" "));

	SetDlgItemText(IDC_JUMPER,SingleEndedStr[single_differential_jumper]);

	ret=pac_i8017HW_Get_D_Sub_Status(slotIndex,&DSub_Status);
	if(ret)
	{
		str.Format(_T("Slot[%d]=>pac_i8017HW_Get_D_Sub_Status error %s"),slotIndex,ErrorStr[ret*(-1)]);
		SetDlgItemText(IDC_STATUS,str);
		return;
	}
	else
		SetDlgItemText(IDC_STATUS,_T(" "));

	SetDlgItemText(IDC_DSubStatus,DSubStr[DSub_Status]);


    
	gain=m_type.GetCurSel();


	if(single_differential_jumper==1) //Single Ended Mode
	{
		
		totalCh=16;
	}
	else
	{
		totalCh=8;
	}


	for(ch=0;ch<totalCh;ch++)
	{
	
		ret=pac_i8017HW_ReadAI(slotIndex,ch,gain,&fVal);
		if(ret==0)
		{	
			str.Format(_T("%.3f"),fVal);
		}
		else
		{
			str.Format(_T("ReadAI Error = %s"),ErrorStr[ret*(-1)]);
		}	
		SetDlgItemText(IDC_VAL0+ch,str);
		
	}	
}


void CPac8017HDemoDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	exit(0);
}
