// 8k_doDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_do.h"
#include "8k_doDlg.h"
#include "pacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Base variables
int iDO_Slot,iDOTotalCh=0;
CString csTmp;
char cTmp[10];
/////////////////////////////////////////////////////////////////////////////
// CMy8k_doDlg dialog

CMy8k_doDlg::CMy8k_doDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_doDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_doDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_doDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_doDlg)
	DDX_Control(pDX, IDC_EDITWTDTimeout, m_WTDTimeout);
	DDX_Control(pDX, IDC_CHECKWTDOverwrite, m_WTDoverwrite);
	DDX_Control(pDX, IDC_EDITReadDO, m_editReadDO);
	DDX_Control(pDX, IDC_BUTTONWriteDO, m_btnWriteDO);
	DDX_Control(pDX, IDC_BUTTONDOClear, m_btnClearDO);
	DDX_Control(pDX, IDC_EDITDOValue, m_editDOValue);
	DDX_Control(pDX, IDC_EDITDOChannels, m_editDOChannels);
	DDX_Control(pDX, IDC_COMBODOSlot, m_cmbDOSlot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_doDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_doDlg)
	ON_BN_CLICKED(IDC_BUTTONDOClear, OnBUTTONDOClear)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	ON_BN_CLICKED(IDC_BUTTONReadDO, OnBUTTONReadDO)
	ON_BN_CLICKED(IDC_BUTTONSetPowerValue, OnBUTTONSetPowerValue)
	ON_BN_CLICKED(IDC_CHECKWTDOverwrite, OnCHECKWTDOverwrite)
	ON_EN_CHANGE(IDC_EDITWTDTimeout, OnChangeEDITWTDTimeout)
	ON_BN_CLICKED(IDC_BUTTONRefreshWTD, OnBUTTONRefreshWTD)
	ON_BN_CLICKED(IDC_BUTTONSetSafeValue, OnBUTTONSetSafeValue)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_doDlg message handlers

BOOL CMy8k_doDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDOSlot.SetCurSel(0);
	m_editDOChannels.SetWindowText (_T("32"));
	m_editDOValue.SetWindowText (_T("0"));
	m_WTDTimeout.SetWindowText (_T("0xa"));
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy8k_doDlg::OnBUTTONDOClear() 
{
	// TODO: Add your control notification handler code here
	//Clear DO value
	HANDLE hPort;
	hPort = uart_Open("");
	iDO_Slot=m_cmbDOSlot.GetCurSel();
	
	//Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);	

	pac_WriteDO( hPort, iDO_Slot, iDOTotalCh,0);
	uart_Close(hPort);

	m_editDOValue.SetWindowText (_T("0"));
}

void CMy8k_doDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	HANDLE hPort;
	
	//Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	//Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);	
	
	//Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);
	hPort = uart_Open("");
	pac_WriteDO( hPort, iDO_Slot,iDOTotalCh,dwDOData);
	uart_Close(hPort);
}

void CMy8k_doDlg::OnBUTTONReadDO() 
{
	HANDLE hPort;
	DWORD data = 0;
	TCHAR value[20];
    //Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	//Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);
    hPort = uart_Open("");
	//Read DO
    pac_ReadDO(hPort, iDO_Slot, iDOTotalCh, &data);

	_itow(data,value,16);
	m_editReadDO.SetWindowText(value);
	uart_Close(hPort);
}

void CMy8k_doDlg::OnBUTTONSetPowerValue() 
{
	DWORD dwDOData;
	HANDLE hPort;
	//Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	//Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);	
	
	//Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

    
	//pac_WriteModulePowerOnValue(iDO_Slot,dwDOData);
	pac_WriteModulePowerOnValueDO(hPort,iDO_Slot,32,dwDOData);
            
    if(IDYES==MessageBox(TEXT("Power on value will show after reboot.\nDo you want to reboot now?"),TEXT("Note"),MB_YESNO|MB_ICONQUESTION))
		pac_Reboot();
}

void CMy8k_doDlg::OnCHECKWTDOverwrite() 
{
	// TODO: Add your control notification handler code here
	
}

void CMy8k_doDlg::OnChangeEDITWTDTimeout() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CMy8k_doDlg::OnBUTTONRefreshWTD() 
{
			//Get slot where the module is
            HANDLE hPort;
			iDO_Slot=m_cmbDOSlot.GetCurSel();
            pac_RefreshModuleWDT(hPort,iDO_Slot);	
}

void CMy8k_doDlg::OnBUTTONSetSafeValue() 
{
	DWORD WTDOverwrite = 0;
    DWORD WTDTimeout = 0;
    DWORD dwDOData;       
	HANDLE hPort;
	//Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();
    //Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);
	
	pac_WriteModuleSafeValueDO(hPort,iDO_Slot,32, dwDOData);
            
           
	if (m_WTDoverwrite.GetCheck())//enable WTD overwrite after WTD start          
		WTDOverwrite = 1;
    
	//get the WTD overwrite time
	m_WTDTimeout.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&WTDTimeout);
          
	pac_SetModuleWDTConfig(hPort,iDO_Slot, 1, WTDTimeout, WTDOverwrite);
        	
}
