// 8088WDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8088W.h"
#include "8088WDlg.h"
#include "PACSDK.h"
#include "pac_i8088W.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BURSTMODE 0
#define CONTINOUSMODE 1

#define STARTPWM 2

int Slot88=-1;
bool Find88=false;
int PWMMode=CONTINOUSMODE;
int DutyMode=0;

enum Method{StartPWM,SetSynPWM,SetHardTriPWM,StopPWM,StopSynPWM,StopHardTriPWM};
Method ExecuteMethod;
void ErrorMsg(int,CString);
/////////////////////////////////////////////////////////////////////////////
// CMy8088WDlg dialog

CMy8088WDlg::CMy8088WDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8088WDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8088WDlg)
	m_strLibVer = _T("");
	m_strLatticeVer = _T("");
	m_strFind88 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8088WDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8088WDlg)
	DDX_Control(pDX, IDC_cmbSlot88, m_cmbSlot88);
	DDX_Control(pDX, IDC_RADIODutyMode3, m_rdobtnDutyMode3);
	DDX_Control(pDX, IDC_RADIODutyMode2, m_rdobtnDutyMode2);
	DDX_Control(pDX, IDC_RADIODutyMode1, m_rdobtnDutyMode1);
	DDX_Control(pDX, IDC_EDITDutyMsg2, m_editDutyMsg_num);
	DDX_Control(pDX, IDC_EDITDutyMsg1, m_editDutyMsg_Hz);
	DDX_Control(pDX, IDC_EDITDuty_num, m_editDuty_num);
	DDX_Control(pDX, IDC_EDITDuty_Hz, m_editDuty_Hz);
	DDX_Control(pDX, IDC_EDITBurstCnt, m_editBurstCnt);
	DDX_Control(pDX, IDC_cmbPWMMode, m_cmbPWMMode);
	DDX_Text(pDX, IDC_EDITLibVer, m_strLibVer);
	DDX_Text(pDX, IDC_EDITLatticeVer, m_strLatticeVer);
	DDX_Text(pDX, IDC_EDITFind88, m_strFind88);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8088WDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8088WDlg)
	ON_CBN_SELCHANGE(IDC_cmbPWMMode, OnSelchangecmbPWMMode)
	ON_BN_CLICKED(IDC_RADIODutyMode1, OnRADIODutyMode1)
	ON_BN_CLICKED(IDC_RADIODutyMode2, OnRADIODutyMode2)
	ON_BN_CLICKED(IDC_RADIODutyMode3, OnRADIODutyMode3)
	ON_BN_CLICKED(IDC_RADIO1, OnRdoStartPWM)
	ON_BN_CLICKED(IDC_RADIO3, OnrdoSetHardTriPWM)
	ON_BN_CLICKED(IDC_RADIO6, OnrdoStopPWM)
	ON_BN_CLICKED(IDC_RADIO8, OnrdoStopSynPWM)
	ON_BN_CLICKED(IDC_RADIO9, OnrdoStopHardTriPWM)
	ON_BN_CLICKED(IDC_RADIO2, OnrdoSetSynPWM)
	ON_BN_CLICKED(IDC_btnExecute, OnbtnExecute)
	ON_CBN_SELCHANGE(IDC_cmbSlot88, OnSelchangecmbSlot88)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8088WDlg message handlers

BOOL CMy8088WDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	short LatticeVer,LibVer;
	char cTemp[50];
	CString strTmp;

	//Show lattice version
	LatticeVer=pac_i8088W_GetFirmwareVersion(Slot88);
	sprintf(cTemp,"Firmware Version=%04lx",LatticeVer);
	m_strLatticeVer=cTemp;

	//Show library version
	LibVer=pac_i8088W_GetLibVersion();
	sprintf(cTemp,"Library Version=%04x",LibVer);
	m_strLibVer=cTemp;

	//Find 8088
	TCHAR MsgText[40];
	if(Find88){
		swprintf(MsgText,_T("I-8088W card in %d slot"),Slot88);
		m_strFind88=MsgText;
		m_cmbSlot88.SetCurSel(Slot88-1);
	}
	else {
		swprintf(MsgText,_T("I-8088W card isn't found in all slot"));
		m_strFind88=MsgText;
	}

	//Default setting
	m_cmbPWMMode.SetCurSel(1);
	m_editBurstCnt.SetWindowText(_T("0"));
	m_editDutyMsg_Hz.EnableWindow(false);
	m_editDutyMsg_num.EnableWindow(false);
	m_editDuty_Hz.EnableWindow(false);
	m_editDuty_num.EnableWindow(false);

	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy8088WDlg::OnSelchangecmbPWMMode() 
{
	// TODO: Add your control notification handler code here
	PWMMode=m_cmbPWMMode.GetCurSel();
	if(PWMMode==BURSTMODE){
		m_editBurstCnt.EnableWindow(true);
	}
	else m_editBurstCnt.EnableWindow(false);
}

void CMy8088WDlg::OnRADIODutyMode1() 
{
	// TODO: Add your control notification handler code here
	DutyMode=0;
	m_editDutyMsg_Hz.EnableWindow(true);
	m_editDutyMsg_num.EnableWindow(true);
	m_editDuty_Hz.EnableWindow(true);
	m_editDuty_num.EnableWindow(true);

	m_editDutyMsg_Hz.SetWindowText(_T("Input Hz (1~450000)"));
	m_editDutyMsg_num.SetWindowText(_T("Input duty (1~99)"));

	m_rdobtnDutyMode2.SetCheck(BST_UNCHECKED);
	m_rdobtnDutyMode3.SetCheck(BST_UNCHECKED);
}

void CMy8088WDlg::OnRADIODutyMode2() 
{
	// TODO: Add your control notification handler code here
	DutyMode=1;
	m_editDutyMsg_Hz.EnableWindow(true);
	m_editDutyMsg_num.EnableWindow(true);
	m_editDuty_Hz.EnableWindow(true);
	m_editDuty_num.EnableWindow(true);

	m_editDutyMsg_Hz.SetWindowText(_T("Input x10 Hz 1~4500000"));
	m_editDutyMsg_num.SetWindowText(_T("Input x10 duty 1~999"));

	m_rdobtnDutyMode1.SetCheck(BST_UNCHECKED);
	m_rdobtnDutyMode3.SetCheck(BST_UNCHECKED);
}

void CMy8088WDlg::OnRADIODutyMode3() 
{
	// TODO: Add your control notification handler code here
	DutyMode=2;
	m_editDutyMsg_Hz.EnableWindow(true);
	m_editDutyMsg_num.EnableWindow(true);
	m_editDuty_Hz.EnableWindow(true);
	m_editDuty_num.EnableWindow(true);

	m_editDutyMsg_Hz.SetWindowText(_T("Input x.1 Hz 0.1~450000.0"));
	m_editDutyMsg_num.SetWindowText(_T("Input x.1 duty 0.1~99.9"));

	m_rdobtnDutyMode1.SetCheck(BST_UNCHECKED);
	m_rdobtnDutyMode2.SetCheck(BST_UNCHECKED);
}

void CMy8088WDlg::OnRdoStartPWM() 
{
	// TODO: Add your control notification handler code here
	ExecuteMethod=StartPWM;
}

void CMy8088WDlg::OnrdoSetHardTriPWM() 
{
	// TODO: Add your control notification handler code here
	ExecuteMethod=SetHardTriPWM;
}

void CMy8088WDlg::OnrdoStopPWM() 
{
	// TODO: Add your control notification handler code here
	ExecuteMethod=StopPWM;
}

void CMy8088WDlg::OnrdoStopSynPWM() 
{
	// TODO: Add your control notification handler code here
	ExecuteMethod=StopSynPWM;
}

void CMy8088WDlg::OnrdoStopHardTriPWM() 
{
	// TODO: Add your control notification handler code here
	ExecuteMethod=StopHardTriPWM;
}

void CMy8088WDlg::OnrdoSetSynPWM() 
{
	// TODO: Add your control notification handler code here
	ExecuteMethod=SetSynPWM;
}

void CMy8088WDlg::OnbtnExecute() 
{
	// TODO: Add your control notification handler code here
	int ret;
	if(Find88==false){
		MessageBox(_T("Can't find i-8088W"));
		return;
	} 

	char temp[20];
	CString cstr;
	int Burstcnt;
	int ch;
	//Setting Setp1
	if(PWMMode==BURSTMODE){
		for(ch=0;ch<8;ch++){
			m_editBurstCnt.GetWindowText(cstr);
			wcstombs(temp,cstr,20);
			Burstcnt=atoi(temp);
			ret=pac_i8088W_SetPWMCountMode(Slot88,ch,0);
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			ret=pac_i8088W_SetBurstCount(Slot88,ch,Burstcnt);
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
		}
	}
	else{
		//Continous mode
		for(ch=0;ch<8;ch++){
			ret=pac_i8088W_SetPWMCountMode(Slot88,ch,1);
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			ret=pac_i8088W_SetBurstCount(Slot88,ch,1);
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
		}
	}
	
	//Setting Setp2
	if(DutyMode==0 || DutyMode==1){
		unsigned long hz;
		unsigned int duty;
		m_editDuty_Hz.GetWindowText(cstr);
		wcstombs(temp,cstr,20);
		hz=atol(temp);

		m_editDuty_num.GetWindowText(cstr);
		wcstombs(temp,cstr,20);
		duty=atoi(temp);
		for(ch=0;ch<8;ch++){
			if(DutyMode==0) {
				ret=pac_i8088W_SetPWMDuty(Slot88,ch,hz,duty);
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
			if(DutyMode==1) {
				ret=pac_i8088W_SetPWMDuty_Deci(Slot88,ch,hz,duty);
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
		}
	}
	else if(DutyMode==2){
		float hz;
		float duty;
		m_editDuty_Hz.GetWindowText(cstr);
		wcstombs(temp,cstr,20);
		hz=atof(temp);

		m_editDuty_num.GetWindowText(cstr);
		wcstombs(temp,cstr,20);
		duty=atof(temp);
	
		for(ch=0;ch<8;ch++){
			ret=pac_i8088W_SetPWMDuty_Float(Slot88,ch,hz,duty);
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
		}
	}


	//Setting Setp3
	switch(ExecuteMethod){
		case StartPWM:
			for(ch=0;ch<8;ch++){     				      				
				ret=pac_i8088W_PWM_Start(Slot88,ch); 
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
			break;
		case SetSynPWM:
			for(ch=0;ch<8;ch++)
        	{
				ret=pac_i8088W_SetSyncChannel(Slot88,ch,1);	  
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
			ret=pac_i8088W_Sync_Start(Slot88); 
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			break;
		case SetHardTriPWM:
			for(ch=0;ch<8;ch++)
			{
				ret=pac_i8088W_SetHardwareTrigChannel(Slot88,ch,1);	
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
			break;
		case StopPWM:
			for(ch=0;ch<8;ch++)
			{   
				ret=pac_i8088W_PWM_Stop(Slot88,ch); 
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
			break;
		case StopSynPWM:
			ret=pac_i8088W_Sync_Stop(Slot88);	
			ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			break;
		case StopHardTriPWM:
			//printf("StopHardTriPWM");
			for(ch=0;ch<8;ch++)
			{
				ret=pac_i8088W_SetHardwareTrigChannel(Slot88,ch,0);	
				ErrorMsg(ret,_T("pac_i8088W_SetPWMCountMode"));
			}
			break;
	}
}

void CMy8088WDlg::OnSelchangecmbSlot88() 
{
	// TODO: Add your control notification handler code here
	unsigned short ModuelName;
	short ret;
	
	Slot88=m_cmbSlot88.GetCurSel()+1;
	ret=ret=pac_i8088W_Init(Slot88);
	if(ret==0){
		Find88=true;
		
	}
	else
	{
		Slot88=-1;
		Find88=false;
	}

	TCHAR MsgText[40];
	if(Find88){
		swprintf(MsgText,_T("I-8088W card in %d slot"),Slot88);
		m_strFind88=MsgText;
	}
	else {
		swprintf(MsgText,_T("I-8088W card isn't found in all slot"));
		m_strFind88=MsgText;
	}
	UpdateData(false);
}

void ErrorMsg(int ret,CString str)
{
	char ctemp[50];
	CString cstr;
	
	if(ret){
		
		sprintf(ctemp,"Error code %d",ret);
		cstr=ctemp;
		cstr=str+cstr;
	AfxMessageBox(cstr);
		
	}
}
