// pac_8093WDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pac_8093WDemo.h"
#include "pac_8093WDemoDlg.h"
#include "pac_i8093W.h"

int slotIndex=-1;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPac_8093WDemoDlg dialog

CPac_8093WDemoDlg::CPac_8093WDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac_8093WDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac_8093WDemoDlg)
	m_preset0 = 0;
	m_preset1 = 0;
	m_preset2 = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac_8093WDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac_8093WDemoDlg)
	DDX_Control(pDX, IDC_EnLatch_2, m_enLatch2);
	DDX_Control(pDX, IDC_EnLatch_1, m_enLatch1);
	DDX_Control(pDX, IDC_EnLatch_0, m_enLatch0);
	DDX_Control(pDX, IDC_MODE2, m_mode2);
	DDX_Control(pDX, IDC_MODE1, m_mode1);
	DDX_Control(pDX, IDC_MODE0, m_mode0);
	DDX_Control(pDX, IDC_SLOT, m_slot);
	DDX_Control(pDX, IDC_XOR2, m_xor2);
	DDX_Control(pDX, IDC_XOR1, m_xor1);
	DDX_Control(pDX, IDC_XOR0, m_xor0);
	DDX_Text(pDX, IDC_PRESET_0, m_preset0);
	DDX_Text(pDX, IDC_PRESET_1, m_preset1);
	DDX_Text(pDX, IDC_PRESET_2, m_preset2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac_8093WDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPac_8093WDemoDlg)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IIDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_RESET0, OnReset0)
	ON_BN_CLICKED(IDC_RESET1, OnReset1)
	ON_BN_CLICKED(IDC_RESET2, OnReset2)
	ON_BN_CLICKED(IDC_XOR0, OnXor0)
	ON_BN_CLICKED(IDC_XOR1, OnXor1)
	ON_BN_CLICKED(IDC_XOR2, OnXor2)
	ON_CBN_SELCHANGE(IDC_SLOT, OnSelchangeSlot)
	ON_CBN_SELCHANGE(IDC_MODE0, OnSelchangeMode0)
	ON_CBN_SELCHANGE(IDC_MODE1, OnSelchangeMode1)
	ON_CBN_SELCHANGE(IDC_MODE2, OnSelchangeMode2)
	ON_BN_CLICKED(IDC_SetPreset_0, OnSetPreset0)
	ON_BN_CLICKED(IDC_SetPreset_1, OnSetPreset1)
	ON_BN_CLICKED(IDC_SetPreset_2, OnSetPreset2)
	ON_BN_CLICKED(IDC_EnLatch_0, OnEnLatch0)
	ON_BN_CLICKED(IDC_EnLatch_1, OnEnLatch1)
	ON_BN_CLICKED(IDC_EnLatch_2, OnEnLatch2)
	ON_BN_CLICKED(IDC_Clear_0, OnClear0)
	ON_BN_CLICKED(IDC_Clear_1, OnClear1)
	ON_BN_CLICKED(IDC_Clear_2, OnClear2)
	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac_8093WDemoDlg message handlers

BOOL CPac_8093WDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CString str;
	int i;
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	for (i=0 ;i <8 ; i++)
	{
		str.Format(_T("Slot %d"),i);
		m_slot.AddString(str);
	}
	m_slot.SetCurSel(0);

	//printf("demo 8093W\n");
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen


	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPac_8093WDemoDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	SetTimer(500, 2, NULL);


		
}

void CPac_8093WDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
	long val32=0;
	int index=0, ifLatched=0, ifEnabled=0;
	float freq=0.0;
	CString str;
	int ch;
	for(ch=0;ch<3;ch++)
	{
		pac_i8093W_Read32BitEncoder(slotIndex,ch,&val32);
		str.Format(_T("%010lu[%08lX]h"),val32,val32);
		SetDlgItemText(IDC_VAL0+ch,str);
		pac_i8093W_GetIndex(slotIndex,ch,&index);
		str.Format(_T("%d"),index);
		SetDlgItemText(IDC_Z00+ch,str);
		pac_i8093W_ReadFreq(slotIndex,ch,&freq);
		str.Format(_T("%5.3f"),freq);
		SetDlgItemText(IDC_Freq_0+ch,str);

		pac_i8093W_GetIndexLatchStatus(slotIndex,ch, & ifLatched, &ifEnabled);
		
		if(ifLatched)
			SetDlgItemText(IDC_IndexLatch_0 + ch, _T("1"));
		else
			SetDlgItemText(IDC_IndexLatch_0 + ch, _T("0"));

		if(ifEnabled)
			SetDlgItemText(IDC_EnFlag_0 + ch, _T("1"));
		else
			SetDlgItemText(IDC_EnFlag_0 + ch, _T("0"));
	}
}

void CPac_8093WDemoDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	KillTimer(10);
}

void CPac_8093WDemoDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	KillTimer(10);
	exit(0);
}

void CPac_8093WDemoDlg::OnReset0() 
{
	// TODO: Add your control notification handler code here
	pac_i8093W_ResetEncoder(slotIndex,0);
}

void CPac_8093WDemoDlg::OnReset1() 
{
	// TODO: Add your control notification handler code here
	pac_i8093W_ResetEncoder(slotIndex,1);
}

void CPac_8093WDemoDlg::OnReset2() 
{
	// TODO: Add your control notification handler code here
	pac_i8093W_ResetEncoder(slotIndex,2);
}

void CPac_8093WDemoDlg::OnXor0() 
{
	// TODO: Add your control notification handler code here
	int xor;
	pac_i8093W_SetXOR(slotIndex,0,m_xor0.GetCheck());
	pac_i8093W_GetXOR(slotIndex,0, &xor);
	m_xor0.SetCheck(xor);	
}

void CPac_8093WDemoDlg::OnXor1() 
{
	// TODO: Add your control notification handler code here
	int xor;
	pac_i8093W_SetXOR(slotIndex,1,m_xor1.GetCheck());
	pac_i8093W_GetXOR(slotIndex,1, &xor);
	m_xor1.SetCheck(xor);	
}

void CPac_8093WDemoDlg::OnXor2() 
{
	// TODO: Add your control notification handler code here
	int xor;
	pac_i8093W_SetXOR(slotIndex,2,m_xor2.GetCheck());
	pac_i8093W_GetXOR(slotIndex,2, &xor);
	m_xor2.SetCheck(xor);	
}



void CPac_8093WDemoDlg::OnSelchangeSlot() 
{
	// TODO: Add your control notification handler code here
	CString str,dateStr;

	char libDate[32];
	int ch;
	int res=-1;
	int findio=0;

	int ret=pac_i8093W_Init(m_slot.GetCurSel());

//	printf("ret %d  s=%d \n", ret, m_slot.GetCurSel());
	if(ret==0)
	{
		slotIndex=m_slot.GetCurSel();	
		str.Format(_T("Find 8093W at slot %d"),slotIndex);
		SetDlgItemText(IDC_STATUS,str);

		//  8093W ᪽]w CW/CCW mode
		for(ch=0;ch<3;ch++)
		{
			res=pac_i8093W_SetMode(slotIndex,ch,1);
			res=pac_i8093W_SetXOR(slotIndex,ch,0);
		}
		m_mode0.SetCurSel(0);
		m_mode1.SetCurSel(0);
		m_mode2.SetCurSel(0);

		
		
		pac_i8093W_GetLibDate(libDate);
		dateStr=libDate;
		str.Format(_T("8093W Built:%s Ver:%04X"),dateStr,pac_i8093W_GetLibVersion());
		SetWindowText(str);

		
		str.Format(_T("%04X"),pac_i8093W_GetFirmwareVersion(slotIndex));
		SetDlgItemText(IDC_FIRM,str);


		SetTimer(10, 100, NULL);
		findio=1;
	}
	if(findio==0)
	{
		str.Format(_T("Not found 8093W at slot"));
		SetDlgItemText(IDC_STATUS,str);
	}	
}

void CPac_8093WDemoDlg::OnSelchangeMode0() 
{
	// TODO: Add your control notification handler code here
	int mode=0;
	pac_i8093W_SetMode(slotIndex,0,m_mode0.GetCurSel()+1);
	pac_i8093W_GetMode(slotIndex,0,&mode);
	if(mode>0)
		m_mode0.SetCurSel(mode-1);		
}

void CPac_8093WDemoDlg::OnSelchangeMode1() 
{
	// TODO: Add your control notification handler code here
	int mode=0;
	pac_i8093W_SetMode(slotIndex,1,m_mode1.GetCurSel()+1);
	pac_i8093W_GetMode(slotIndex,1,&mode);
	if(mode>0)
		m_mode1.SetCurSel(mode-1);		
}

void CPac_8093WDemoDlg::OnSelchangeMode2() 
{
	// TODO: Add your control notification handler code here
	int mode=0;
	pac_i8093W_SetMode(slotIndex,2,m_mode2.GetCurSel()+1);
	pac_i8093W_GetMode(slotIndex,2,&mode);
	if(mode>0)
		m_mode2.SetCurSel(mode-1);		
}

void CPac_8093WDemoDlg::OnSetPreset0() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	pac_i8093W_SetPresetValue(slotIndex,0,m_preset0);
	
}

void CPac_8093WDemoDlg::OnSetPreset1() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	pac_i8093W_SetPresetValue(slotIndex,1,m_preset1);
}

void CPac_8093WDemoDlg::OnSetPreset2() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	pac_i8093W_SetPresetValue(slotIndex,2,m_preset2);
}

void CPac_8093WDemoDlg::OnEnLatch0() 
{
	// TODO: Add your control notification handler code here
	
	if(m_enLatch0.GetCheck())
		pac_i8093W_SetIndexLatchStatus(slotIndex,0,1);
	else
		pac_i8093W_SetIndexLatchStatus(slotIndex,0,0);
}

void CPac_8093WDemoDlg::OnEnLatch1() 
{
	// TODO: Add your control notification handler code here
	if(m_enLatch1.GetCheck())
		pac_i8093W_SetIndexLatchStatus(slotIndex,1,1);
	else
		pac_i8093W_SetIndexLatchStatus(slotIndex,1,0);
}

void CPac_8093WDemoDlg::OnEnLatch2() 
{
	// TODO: Add your control notification handler code here
	if(m_enLatch2.GetCheck())
		pac_i8093W_SetIndexLatchStatus(slotIndex,2,1);
	else
		pac_i8093W_SetIndexLatchStatus(slotIndex,2,0);	
}

void CPac_8093WDemoDlg::OnClear0() 
{
	// TODO: Add your control notification handler code here
	pac_i8093W_ClearLatchedIndex(slotIndex,0);
}

void CPac_8093WDemoDlg::OnClear1() 
{
	// TODO: Add your control notification handler code here
	pac_i8093W_ClearLatchedIndex(slotIndex,1);
}

void CPac_8093WDemoDlg::OnClear2() 
{
	// TODO: Add your control notification handler code here
	pac_i8093W_ClearLatchedIndex(slotIndex,2);
}

