// pac_8172ReadAIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pac_8172ReadAI.h"
#include "pac_8172ReadAIDlg.h"
#include "pac_i8172W.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

short slotIndex,port,group,jumper,bitMode;

/////////////////////////////////////////////////////////////////////////////
// CPac_8172ReadAIDlg dialog

CPac_8172ReadAIDlg::CPac_8172ReadAIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac_8172ReadAIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac_8172ReadAIDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac_8172ReadAIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac_8172ReadAIDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac_8172ReadAIDlg, CDialog)
	//{{AFX_MSG_MAP(CPac_8172ReadAIDlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_AIHex, OnAIHex)
	ON_CBN_SELCHANGE(IDC_SLOT, OnSelchangeSlot)
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_CBN_SELCHANGE(IDC_GROUP, OnSelchangeGroup)
	ON_CBN_SELCHANGE(IDC_JUMPER, OnSelchangeJumper)
	ON_CBN_SELCHANGE(IDC_MODE, OnSelchangeMode)
	ON_BN_CLICKED(IDC_AICh, OnAICh)
	ON_BN_CLICKED(IDC_AIAll, OnAIAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac_8172ReadAIDlg message handlers

BOOL CPac_8172ReadAIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CComboBox *cbo;

	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	int i;
	for(i=0;i<16;i++)
	{
		cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_0 + i);
		cbo->SetCurSel(1); // type code = 0x8 +-10 V
	}
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPac_8172ReadAIDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	exit(0);
}

void CPac_8172ReadAIDlg::OnAIHex() 
{
	// TODO: Add your control notification handler code here
	short ret,ch, flag=-1 ,checkArr[16],i, typeCode[16];
	short iVal,iArr[16];
	float aiFloat[16], fVal=0;
	int maxCh=8;
	int cboIndex;
	CComboBox *cbo;
	CString str;

	

	if(bitMode==16)
	{
		maxCh=1;
	}
	else
	{
		if(jumper==0)		
			maxCh=8;
		else
			maxCh=16;
	}
	for(i=0;i<maxCh;i++)
	{
		iArr[i]=0;
		checkArr[i]=0;
		cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_0 + i);
		cboIndex = cbo->GetCurSel();
		if(cboIndex==7) //0x1a
			typeCode[i] = 0x1a;
		else
			typeCode[i]= cboIndex +7;
	}
	for(;;)
	{
		ret = pac_i8172W_ReadAIHex( slotIndex,port, group, bitMode, &ch , &iVal);
		//ret= ReadAIHex(group , bitMode,&ch, &iVal); 
		if(ret>=0)
		{
			flag=1;
			iArr[ch]=iVal;
			checkArr[ch]++;			
		}	
		for(i=0;i<maxCh;i++)
		{
			if(checkArr[i]==0)
			{
				flag=-1;
				break;
			}
		}
		if(flag==1)
		{
			
			for(i=0;i<maxCh;i++)
			{
				
				pac_i8172W_AIHexToFloat(iArr[i],  typeCode[i],  bitMode, &fVal);	
				aiFloat[i]= fVal;
				str.Format(_T("%+6.3f"), aiFloat[i] );
				SetDlgItemText(IDC_AI_0 +i, str);
			}
			return ;
			
		}
	}
	
}

void CPac_8172ReadAIDlg::OnSelchangeSlot() 
{
	// TODO: Add your control notification handler code here
	int ret = -1;
	CComboBox *cbo;
	CString str;

	cbo  = (CComboBox*) GetDlgItem(IDC_SLOT);

	ret=pac_i8172W_Init(cbo->GetCurSel());
	if(ret==0)
	{
		slotIndex=cbo->GetCurSel();	
	}
	else
	{
		str.Format(_T("Does not find I-8172W at slot %d"),cbo->GetCurSel());
		MessageBox( str, TEXT("Error"),MB_OK);
	}
}

void CPac_8172ReadAIDlg::OnSelchangePort() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_PORT);
	port=cbo->GetCurSel() ;
	
}

void CPac_8172ReadAIDlg::OnSelchangeGroup() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_GROUP);
	group=cbo->GetCurSel() + 8;
}

void CPac_8172ReadAIDlg::OnSelchangeJumper() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_JUMPER);
	jumper=cbo->GetCurSel() ;	
}

void CPac_8172ReadAIDlg::OnSelchangeMode() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_MODE);
	if(cbo->GetCurSel()==0)
		bitMode = 12;
	else
		bitMode = 16;
}

void CPac_8172ReadAIDlg::OnAICh() 
{
	// TODO: Add your control notification handler code here
	short ret,ch, i, typeCode[16];
	float fVal;
	float aiFloat[16];
	int maxCh=8;
	int cboIndex;
	CComboBox *cbo;
	CString str;

	

	if(bitMode==16)
	{
		maxCh=1;
	}
	else
	{
		if(jumper==0)		
			maxCh=8;
		else
			maxCh=16;
	}
	for(i=0;i<maxCh;i++)
	{	
		cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_0 + i);
		cboIndex = cbo->GetCurSel();
		if(cboIndex==7) //0x1a
			typeCode[i] = 0x1a;
		else
			typeCode[i]= cboIndex +7;
	}
	for(ch=0;ch<maxCh;ch++)
	{
		ret = pac_i8172W_ReadAI_Ch( slotIndex,port, group, bitMode, typeCode[ch] , ch , &fVal);
		if(ret>=0)
		{		
			aiFloat[ch]=fVal;
			str.Format(_T("%+6.3f"), aiFloat[ch] );
			SetDlgItemText(IDC_AI_0 +ch, str);
		}
	}	
}

void CPac_8172ReadAIDlg::OnAIAll() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	short ret,ch, i, typeCode[16];
	float fVal;
	float aiFloat[16];
	int maxCh=8;
	int cboIndex;
	CComboBox *cbo;
	CString str;

	

	if(bitMode==16)
	{
		maxCh=1;
	}
	else
	{
		if(jumper==0)		
			maxCh=8;
		else
			maxCh=16;
	}
	for(i=0;i<maxCh;i++)
	{	
		cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_0 + i);
		cboIndex = cbo->GetCurSel();
		if(cboIndex==7) //0x1a
			typeCode[i] = 0x1a;
		else
			typeCode[i]= cboIndex +7;
	}
	ret = pac_i8172W_ReadAI_All( slotIndex,port, group, bitMode,maxCh, typeCode, aiFloat);
	if(ret >0)
	{
		for(ch=0;ch<maxCh;ch++)
		{		
			str.Format(_T("%+6.3f"), aiFloat[ch] );
			SetDlgItemText(IDC_AI_0 +ch, str);
			
		}	
	}
}
