// pac_i8024WDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pac8024Demo.h"
#include "pac8024DemoDlg.h"


#include <math.h>
#include "pac_i8024W.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static int slotIndex; //=0
static int chIndex;
static int typeCode;

static  int exitFlag=0;


unsigned long testLoop=0;

/////////////////////////////////////////////////////////////////////////////
// CPac8024DemoDlg dialog

CPac8024DemoDlg::CPac8024DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac8024DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac8024DemoDlg)
	m_range = _T("");
	m_ao = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac8024DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac8024DemoDlg)
	DDX_Control(pDX, IDC_CH, m_ch);
	DDX_Control(pDX, IDC_TYPECODE, m_type);
	DDX_Control(pDX, IDC_SLOT, m_slot);
	DDX_Text(pDX, IDC_Range, m_range);
	DDX_Text(pDX, IDC_AO, m_ao);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac8024DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPac8024DemoDlg)
	ON_CBN_SELCHANGE(IDC_CH, OnSelchangeCh)
	ON_CBN_SELCHANGE(IDC_TYPECODE, OnSelchangeTypecode)
	ON_CBN_SELCHANGE(IDC_SLOT, OnSelchangeSlot)
	ON_BN_CLICKED(IDC_OUT, OnOut)
	ON_BN_CLICKED(IDC_Exit, OnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac8024DemoDlg message handlers

BOOL CPac8024DemoDlg::OnInitDialog()
{
	int i;
	CString str,str1,typeStr[6];
	char libDate[32];
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	typeStr[0]="Voltage +/- 10.0 V (float format)";
	typeStr[1]="Current 0 ~ 20 mA (float format)";
	typeStr[2]="Voltage +/- 10.0 V (2's format)";
	typeStr[3]="Current 0 ~ 20 mA (2's format)";

	for (i=0 ;i <8 ; i++)
	{
		str.Format(_T("Slot %d"),i);
		m_slot.AddString(str);
	}

	for(i=0;i<4;i++)
	{
		str.Format(_T("CH: %d"),i);
		m_ch.AddString(str);
	}

	for(i=0;i<4;i++)
	{
		m_type.AddString (typeStr[i]);
	}
	// TODO: Add extra initialization here
	pac_i8024W_GetLibDate(libDate);
	str1=libDate;
	str.Format(_T("8024W Demo: Lib Version: %04X Lib Date: %s"),pac_i8024W_GetLibVersion(),str1);
	SetWindowText(str);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPac8024DemoDlg::OnSelchangeCh() 
{
	// TODO: Add your control notification handler code here
	chIndex=m_ch.GetCurSel();
	
}

void CPac8024DemoDlg::OnSelchangeTypecode() 
{
	// TODO: Add your control notification handler code here
	CString rangeStr[6];

	rangeStr[0]="Output Voltage(+/- 10.0)(unit: V)";
	
	rangeStr[1]="Output Current(0.0 ~ 20.0)(unit: mA)";
	

	rangeStr[2]="Output Voltage(-32768~32767)(unit: none)";


	rangeStr[3]="Output Current(0~32768)(unit: none)";



	typeCode=m_type.GetCurSel();
	SetDlgItemText(IDC_Range,rangeStr[typeCode]);	

}

void CPac8024DemoDlg::OnSelchangeSlot() 
{
	// TODO: Add your control notification handler code here

	UpdateData(true);
	CString str;
	slotIndex=m_slot.GetCurSel();
	m_slot.SetCurSel(slotIndex);
	short ret= pac_i8024W_Initial(slotIndex);
	if(ret==0)
	{
		str.Format(_T("Find i-8024W at slot %d"),slotIndex);
	
	}
	else
	{
		str.Format(_T("No i-8024W at slot %d"),slotIndex);
		
	}
	SetDlgItemText(IDC_ID,str);


	
}



void CPac8024DemoDlg::OnOut() 
{
	// TODO: Add your control notification handler code here
	float fValue=0.0;
	int iValue=0;

		
		UpdateData(true);
		fValue=m_ao;
		iValue=(long)m_ao;
        switch(typeCode)
        {
            case 0:
				pac_i8024W_VoltageOut(slotIndex,chIndex,fValue); 
                break;                          
            case 1:
                pac_i8024W_CurrentOut(slotIndex,chIndex,fValue);
                break;                
            case 2:                                                           
                pac_i8024W_VoltageOut_Hex(slotIndex,chIndex,iValue);					
                break;    
            case 3:
                pac_i8024W_CurrentOut_Hex(slotIndex,chIndex,iValue);
                break;                  
       
        }
		

}

void CPac8024DemoDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	exit(0);
}
