// i8048Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "i8048.h"
#include "i8048Dlg.h"
#include "pacsdk.h"
#include "pac_i8048W.h"

	
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CI8048Dlg dialog
int gislot;
int giPreviousslot=-1;

CI8048Dlg::CI8048Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CI8048Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CI8048Dlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CI8048Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CI8048Dlg)
	DDX_Control(pDX, IDC_COMBO3, m_Channel);
	DDX_Control(pDX, IDC_COMBO2, m_TriggerType);
	DDX_Control(pDX, IDC_COMBO1, m_Slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CI8048Dlg, CDialog)
	//{{AFX_MSG_MAP(CI8048Dlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CI8048Dlg message handlers

BOOL CI8048Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	gislot=2;
	m_Slot.SetCurSel(2);
	m_Channel.SetCurSel(0);
	m_TriggerType.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

DWORD iSecond=0;
unsigned int gbtriggerType=0;
DWORD itt=0;
DWORD rec[8],fec[8];
unsigned int giuChannel=0;	

int CALLBACK RE0() //Interrupt Function
{	
	if(pac_i8048W_Read_RisingReg(gislot,giuChannel)) //Read Rising Interrupt Status
	{
		rec[giuChannel]++;
		//Add user's ISR code for channel1. 
	}
	if(pac_i8048W_Read_FallingReg(gislot,giuChannel)) //Read Rising Interrupt Status
	{
		fec[giuChannel]++;
		//Add user's ISR code for channel1. 
	}
	itt++;
	pac_i8048W_UnFreezeINT(gislot,giuChannel);// clear interrupt status of i-8048w channel

    return PAC_INTR_DONE; // clear interrupt status of CPU
}

void CI8048Dlg::OnButton1() //Init i8048
{
	int i8048trgtype=0;
	int ipriority=80;
	int ibpretriggert=10;
	TCHAR tcTemp[100]={0};
	DWORD dwErrCode;
	TCHAR tchmessage[64];


	GetDlgItemText(IDC_COMBO1,tcTemp,100);
	//Get Slot number
	gislot= _wtoi(tcTemp);

	GetDlgItemText(IDC_COMBO2,tcTemp,100);
	//Get trigger type
	i8048trgtype= _wtoi(tcTemp);	

//	GetDlgItemText(IDC_EDIT3,tcTemp,100);
	//Get thread priority
//	ipriority= _wtoi(tcTemp);
	
//	GetDlgItemText(IDC_EDIT2,tcTemp,100);
	//Get bp retrigger
//	ibpretriggert= _wtoi(tcTemp);
	
	GetDlgItemText(IDC_COMBO3,tcTemp,100);
	//Get i-8048w trigger channel
	giuChannel= _wtoi(tcTemp);
	
	pac_EnableRetrigger(10); //backplane retrigger unit
  /*
    The re-trigger level is used for the backplane interrupt of WinPAC.
    The CPU lost to receive the interrupt signal triggered by i8048W, and
    this re-trigger mechanism will make the backplane processer to re-send 
    the interrupt signal to CPU again.    
        
    It's recommended to set the re-trigger level to 10
    (unit is 10 microsecond, 10*10 =100 microsecond)         
  */

	itt=0;
	rec[giuChannel]=0;
	fec[giuChannel]=0;

	if(giPreviousslot>=0)
		pac_i8048W_UnInstallISR(giPreviousslot);

	if(!pac_i8048W_Init(gislot))
	{
		if(!i8048trgtype)
		{
			pac_i8048W_Set_RisingReg(gislot,giuChannel,1); 
			pac_i8048W_Set_FallingReg(gislot,giuChannel,0);
		}
		else
		{
			pac_i8048W_Set_FallingReg(gislot,giuChannel,1);
			pac_i8048W_Set_RisingReg(gislot,giuChannel,0);
		}
		pac_i8048W_InstallISR(gislot,RE0,ipriority);
		giPreviousslot=gislot;
    /*
        The default priority level of the interrupt service thread,Interrupt_Fun function 
        for i8048W is 97
        Many higher priority levels (247 through zero) are assigned to real-time applications, drivers, and system processes. .
        
        Range 	Description
          0 through 96 	Reserved for real-time above drivers.
         97 through 152 	Used by the default Windows CE-based device drivers.
        153 through 247 	Reserved for real-time below drivers.
      
        It's recommended to set the priority level between 97 and 152 for i8048w IST         
        Please refer to http://msdn.microsoft.com/en-us/library/aa450596.aspx for mode details.
    */
		
		if((dwErrCode=pac_GetLastError())!=0)
		{
			swprintf(tchmessage,TEXT("LastError 0x%x\r\n"), dwErrCode);
			AfxMessageBox(tchmessage);
		}
		else
			SetTimer(1,200,NULL);
	}
	else
	{
		swprintf(tchmessage,TEXT("pac_i8048W_Init failed\r\n"));
		AfxMessageBox(tchmessage);
	}    
}


void CI8048Dlg::OnButton4() //Get Count
{
	
}

void CI8048Dlg::OnButton3() //Clear Count
{
	itt=0;
    iSecond=0;
	rec[giuChannel]=0;
	fec[giuChannel]=0;
}

void CI8048Dlg::OnTimer(UINT nIDEvent) 
{
    WCHAR buf[100];
    BYTE DI=0;
    iSecond++;
    DI=pac_i8048W_DI_ALL(gislot);
	swprintf(buf, L"Ch%d = %d",giuChannel, rec[giuChannel]);
   	SetDlgItemText(IDC_EDIT1, buf);

	swprintf(buf, L"Ch%d = %d",giuChannel, fec[giuChannel]);
   	SetDlgItemText(IDC_EDIT4, buf);
	CDialog::OnTimer(nIDEvent);
}

BOOL CI8048Dlg::DestroyWindow() 
{
	pac_EnableSlotInterrupt(gislot, false);	
	return CDialog::DestroyWindow();
}

void CI8048Dlg::OnClose() 
{
	pac_i8048W_UnInstallISR(gislot);
	
	CDialog::OnClose();
}
