// pac_i8050WDemoDlg.cpp : implementation file
//
/*
   Demo for I-8050W

   Version 1.0.0.0 [30,Sep,2009] by Vic
    
   I-8050W is a 16-channel universal Digital I/O module.
   It doesn't need to do any setting for DI function.
   Only DO function has to be set(Use pac_i8050W_UDIO_WriteConfig_16()).
   
   Warning:(English)														
     A channel may be destroyed if it is subjected to an input 			
	  signal(Vcc) while it is configured to be an output channel.			
	  Please remove the external signal which connects to DI,				
	  before changing the channel status from DI mode to DO mode			
																			
	Warning:(Traditional-Chinese)                                           
  ĵi:()                                                                 
		8050W@ӳqD]wDIBqDTJ(Vcc)ApGɱNqD	
	    A]wDOAhoӳqDi|la								    
		qDADIאּDOeAХNDI~Ju					
*/


#include "stdafx.h"
#include "pac_i8050WDemo.h"
#include "pac_i8050WDemoDlg.h"
#include "pac_i8050W.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void pac_i8050W_UDIO_WriteDOBit16(byte slot,int channel,int bitvalue);
void DO_Bit(byte slot,int ch,int bitvalue);
//Parameters
int Slot=0;
bool timerOn=false;
bool DOOn[16];

/////////////////////////////////////////////////////////////////////////////
// CPac_i8050WDemoDlg dialog

CPac_i8050WDemoDlg::CPac_i8050WDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac_i8050WDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac_i8050WDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac_i8050WDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac_i8050WDemoDlg)
	DDX_Control(pDX, IDC_CHECK32, m_DO15Config);
	DDX_Control(pDX, IDC_CHECK31, m_DO14Config);
	DDX_Control(pDX, IDC_CHECK30, m_DO13Config);
	DDX_Control(pDX, IDC_CHECK29, m_DO12Config);
	DDX_Control(pDX, IDC_CHECK28, m_DO11Config);
	DDX_Control(pDX, IDC_CHECK27, m_DO10Config);
	DDX_Control(pDX, IDC_CHECK26, m_DO9Config);
	DDX_Control(pDX, IDC_CHECK25, m_DO8Config);
	DDX_Control(pDX, IDC_CHECK24, m_DO7Config);
	DDX_Control(pDX, IDC_CHECK23, m_DO6Config);
	DDX_Control(pDX, IDC_CHECK22, m_DO5Config);
	DDX_Control(pDX, IDC_CHECK21, m_DO4Config);
	DDX_Control(pDX, IDC_CHECK20, m_DO3Config);
	DDX_Control(pDX, IDC_CHECK19, m_DO2Config);
	DDX_Control(pDX, IDC_CHECK18, m_DO1Config);
	DDX_Control(pDX, IDC_CHECK17, m_DO0Config);
	DDX_Control(pDX, IDC_BMPoff, m_DIOff);
	DDX_Control(pDX, IDC_BMPon, m_DIOn);
	DDX_Control(pDX, IDC_BMPDI9, m_DI9);
	DDX_Control(pDX, IDC_BMPDI8, m_DI8);
	DDX_Control(pDX, IDC_BMPDI7, m_DI7);
	DDX_Control(pDX, IDC_BMPDI6, m_DI6);
	DDX_Control(pDX, IDC_BMPDI5, m_DI5);
	DDX_Control(pDX, IDC_BMPDI4, m_DI4);
	DDX_Control(pDX, IDC_BMPDI3, m_DI3);
	DDX_Control(pDX, IDC_BMPDI15, m_DI15);
	DDX_Control(pDX, IDC_BMPDI14, m_DI14);
	DDX_Control(pDX, IDC_BMPDI13, m_DI13);
	DDX_Control(pDX, IDC_BMPDI12, m_DI12);
	DDX_Control(pDX, IDC_BMPDI11, m_DI11);
	DDX_Control(pDX, IDC_BMPDI10, m_DI10);
	DDX_Control(pDX, IDC_BMPDI2, m_DI2);
	DDX_Control(pDX, IDC_BMPDI1, m_DI1);
	DDX_Control(pDX, IDC_BMPDI0, m_DI0);
	DDX_Control(pDX, IDC_CHECK16, m_DO15);
	DDX_Control(pDX, IDC_CHECK15, m_DO14);
	DDX_Control(pDX, IDC_CHECK14, m_DO13);
	DDX_Control(pDX, IDC_CHECK13, m_DO12);
	DDX_Control(pDX, IDC_CHECK12, m_DO11);
	DDX_Control(pDX, IDC_CHECK11, m_DO10);
	DDX_Control(pDX, IDC_CHECK10, m_DO9);
	DDX_Control(pDX, IDC_CHECK9, m_DO8);
	DDX_Control(pDX, IDC_CHECK8, m_DO7);
	DDX_Control(pDX, IDC_CHECK7, m_DO6);
	DDX_Control(pDX, IDC_CHECK6, m_DO5);
	DDX_Control(pDX, IDC_CHECK5, m_DO4);
	DDX_Control(pDX, IDC_CHECK4, m_DO3);
	DDX_Control(pDX, IDC_CHECK3, m_DO2);
	DDX_Control(pDX, IDC_CHECK2, m_DO1);
	DDX_Control(pDX, IDC_CHECK1, m_DO0);
	DDX_Control(pDX, IDC_COMBO1, m_cmbSlot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac_i8050WDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPac_i8050WDemoDlg)
	ON_BN_CLICKED(IDC_BUTTON2, OnbtnBasicInfor)
	ON_CBN_EDITCHANGE(IDC_COMBO1, OnEditchangeCmbSlot)
	ON_BN_CLICKED(IDC_CHECK1, OnchkDO0)
	ON_BN_CLICKED(IDC_CHECK2, OnchkDO1)
	ON_BN_CLICKED(IDC_CHECK3, OnchkDO2)
	ON_BN_CLICKED(IDC_CHECK4, OnchkDO3)
	ON_BN_CLICKED(IDC_CHECK5, OnchkDO4)
	ON_BN_CLICKED(IDC_CHECK6, OnchkDO5)
	ON_BN_CLICKED(IDC_CHECK7, OnchkDO6)
	ON_BN_CLICKED(IDC_CHECK8, OnchkDO7)
	ON_BN_CLICKED(IDC_CHECK10, OnchkDO9)
	ON_BN_CLICKED(IDC_CHECK11, OnchkDO10)
	ON_BN_CLICKED(IDC_CHECK12, OnchkDO11)
	ON_BN_CLICKED(IDC_CHECK13, OnchkDO12)
	ON_BN_CLICKED(IDC_CHECK14, OnchkDO13)
	ON_BN_CLICKED(IDC_CHECK15, OnchkDO14)
	ON_BN_CLICKED(IDC_CHECK16, OnchkDO15)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK17, OnDO0Config)
	ON_BN_CLICKED(IDC_CHECK18, OnDO1Config)
	ON_BN_CLICKED(IDC_CHECK19, OnDO2Config)
	ON_BN_CLICKED(IDC_CHECK20, OnDO3Config)
	ON_BN_CLICKED(IDC_CHECK21, OnDO4Config)
	ON_BN_CLICKED(IDC_CHECK22, OnDO5Config)
	ON_BN_CLICKED(IDC_CHECK23, OnDO6Config)
	ON_BN_CLICKED(IDC_CHECK24, OnDO7Config)
	ON_BN_CLICKED(IDC_CHECK25, OnDO8Config)
	ON_BN_CLICKED(IDC_CHECK26, OnDO9Config)
	ON_BN_CLICKED(IDC_CHECK27, OnDO10Config)
	ON_BN_CLICKED(IDC_CHECK28, OnDO11Config)
	ON_BN_CLICKED(IDC_CHECK29, OnDO12Config)
	ON_BN_CLICKED(IDC_CHECK30, OnDO13Config)
	ON_BN_CLICKED(IDC_CHECK31, OnDO14Config)
	ON_BN_CLICKED(IDC_CHECK32, OnDO15Config)
	ON_BN_CLICKED(IDC_BUTTON3, OnbtnSelectAll_DOConfig)
	ON_BN_CLICKED(IDC_BUTTON4, OnCleartAll_DOConfig)
	ON_BN_CLICKED(IDC_BUTTON5, OnbtnSelectAll_DOWrite)
	ON_BN_CLICKED(IDC_BUTTON6, OnbtnClearAll_DOWrite)
	ON_BN_CLICKED(IDC_CHECK9, OnchkDO8)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac_i8050WDemoDlg message handlers

BOOL CPac_i8050WDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
    m_cmbSlot.SetCurSel(0);
	UpdateData(false);
	for(int i=0;i<16;i++) DOOn[i]=false; 
	SetTimer(100,100,NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CPac_i8050WDemoDlg::OnbtnBasicInfor() 
{
	// TODO: Add your control notification handler code here
	char buf[100],libdate[20];
	CString cstr;

	memset(buf,0,50);
	WORD wFirmwareVer= pac_i8050W_GetFirmwareVersion(Slot);
	WORD wLibVer= pac_i8050W_GetLibVersion();
	pac_i8050W_GetLibDate(libdate);
	sprintf(buf,"Firmware(lattice) version: %04x\nLibrary version: %04x\nLibrary date:%s",wFirmwareVer,wLibVer,libdate);
    cstr=buf;
	SetDlgItemText(IDC_STATIC1, cstr);  	
}

void CPac_i8050WDemoDlg::OnEditchangeCmbSlot() 
{
	// TODO: Add your control notification handler code here
	Slot=m_cmbSlot.GetCurSel(); 
}

void CPac_i8050WDemoDlg::OnchkDO0() 
{
	// TODO: Add your control notification handler code here
	if(m_DO0.GetCheck()){
		DO_Bit(Slot,0,1);
		DOOn[0]=true;		
	}
	else{
		DO_Bit(Slot,0,0);
		DOOn[0]=false;
	}
}

void pac_i8050W_UDIO_WriteDOBit16(byte slot,int channel,int bitvalue)
{
	WORD wValue=pac_i8050W_UDIO_ReadDO16(slot);

	if(channel>=0 && channel<16)
	{
		if(bitvalue==1)
		{					
			pac_i8050W_UDIO_WriteDO16(slot,wValue|(0x0001<<channel));
		}
		else if(bitvalue==0)
		{
			//value1=(~(0x0001<<channel));
			//value=wValue&value1;
			pac_i8050W_UDIO_WriteDO16(slot,wValue&(~(0x0001<<channel)));
			//pac_i8050W_UDIO_WriteDO16(Slot,value);
		}
	}
	
}

void DO_Bit(byte slot,int ch,int bitvalue)
{
	if(ch>=0 && ch<16)
	{
		if(bitvalue==1){		
			pac_i8050W_UDIO_WriteDOBit16(slot,ch,1);
		}
		else if(bitvalue==0){		
		    pac_i8050W_UDIO_WriteDOBit16(slot,ch,0);
		}
	}
}

void CPac_i8050WDemoDlg::OnchkDO1() 
{
	// TODO: Add your control notification handler code here
	if(m_DO1.GetCheck()){
		DO_Bit(Slot,1,1);
		DOOn[1]=true;
	}
	else{
		DO_Bit(Slot,1,0);
		DOOn[1]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO2() 
{
	// TODO: Add your control notification handler code here
	if(m_DO2.GetCheck()){
		DO_Bit(Slot,2,1);
		DOOn[2]=true;
	}
	else{
		DO_Bit(Slot,2,0);
		DOOn[2]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO3() 
{
	// TODO: Add your control notification handler code here
	if(m_DO3.GetCheck()){
		DO_Bit(Slot,3,1);
		DOOn[3]=true;
	}
	else{
		DO_Bit(Slot,3,0);
		DOOn[3]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO4() 
{
	// TODO: Add your control notification handler code here
	if(m_DO4.GetCheck()){
		DO_Bit(Slot,4,1);
		DOOn[4]=true;
	}
	else{
		DO_Bit(Slot,4,0);
		DOOn[4]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO5() 
{
	// TODO: Add your control notification handler code here
	if(m_DO5.GetCheck()){
		DO_Bit(Slot,5,1);
		DOOn[5]=true;
	}
	else{
		DO_Bit(Slot,5,0);
		DOOn[5]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO6() 
{
	// TODO: Add your control notification handler code here
	if(m_DO6.GetCheck()){
		DO_Bit(Slot,6,1);
		DOOn[6]=true;
	}
	else{
		DO_Bit(Slot,6,0);
		DOOn[6]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO7() 
{
	// TODO: Add your control notification handler code here
	if(m_DO7.GetCheck()){
		DO_Bit(Slot,7,1);
		DOOn[7]=true;
	}
	else{
		DO_Bit(Slot,7,0);
		DOOn[7]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO9() 
{
	// TODO: Add your control notification handler code here
	if(m_DO9.GetCheck()){
		DO_Bit(Slot,9,1);
		DOOn[9]=true;
	}
	else{
		DO_Bit(Slot,9,0);
		DOOn[9]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO10() 
{
	// TODO: Add your control notification handler code here
	if(m_DO10.GetCheck()){
		DO_Bit(Slot,10,1);
		DOOn[10]=true;
	}
	else{
		DO_Bit(Slot,10,0);
		DOOn[10]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO11() 
{
	// TODO: Add your control notification handler code here
	if(m_DO11.GetCheck()){
		DO_Bit(Slot,11,1);
		DOOn[11]=true;
	}
	else{
		DO_Bit(Slot,11,0);
		DOOn[11]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO12() 
{
	// TODO: Add your control notification handler code here
	if(m_DO12.GetCheck()){
		DO_Bit(Slot,12,1);
		DOOn[12]=true;
	}
	else{
		DO_Bit(Slot,12,0);
		DOOn[12]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO13() 
{
	// TODO: Add your control notification handler code here
	if(m_DO13.GetCheck()){
		DO_Bit(Slot,13,1);
		DOOn[13]=true;
	}
	else{
		DO_Bit(Slot,13,0);
		DOOn[13]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO14() 
{
	// TODO: Add your control notification handler code here
	if(m_DO14.GetCheck()){
		DO_Bit(Slot,14,1);
		DOOn[14]=true;
	}
	else{
		DO_Bit(Slot,14,0);
		DOOn[14]=false;
	}
}

void CPac_i8050WDemoDlg::OnchkDO15() 
{
	// TODO: Add your control notification handler code here
	if(m_DO15.GetCheck()){
		DO_Bit(Slot,15,1);
		DOOn[15]=true;		
	}
	else{
		DO_Bit(Slot,15,0);
		DOOn[15]=false;
	}
}

void CPac_i8050WDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==100)
	{	
		if(!DOOn[0]){
			if(pac_i8050W_UDIO_DI16(Slot)&0x0001){
				m_DI0.SetBitmap(m_DIOn.GetBitmap ()); 				
			}	
			else m_DI0.SetBitmap(m_DIOff.GetBitmap ());
		}
      
      if(!DOOn[1]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0002){
   			m_DI1.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI1.SetBitmap(m_DIOff.GetBitmap ());
		}
  
      if(!DOOn[2]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0004){
   			m_DI2.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI2.SetBitmap(m_DIOff.GetBitmap ());
      }

      if(!DOOn[3]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0008){
   			m_DI3.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI3.SetBitmap(m_DIOff.GetBitmap ());
      }

      if(!DOOn[4]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0010){
   			m_DI4.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI4.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[5]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0020){
   			m_DI5.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI5.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[6]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0040){
   			m_DI6.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI6.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[7]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0080){
   			m_DI7.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI7.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[8]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0100){
   			m_DI8.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI8.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[9]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0200){
   			m_DI9.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI9.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[10]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0400){
   			m_DI10.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI10.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[11]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x0800){
   			m_DI11.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI11.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[12]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x1000){
   			m_DI12.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI12.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[13]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x2000){
   			m_DI13.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI13.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[14]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x4000){
   			m_DI14.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI14.SetBitmap(m_DIOff.GetBitmap ());
		}

      if(!DOOn[15]){
   		if(pac_i8050W_UDIO_DI16(Slot)&0x8000){
   			m_DI15.SetBitmap(m_DIOn.GetBitmap ()); 
   		}	
   		else m_DI15.SetBitmap(m_DIOff.GetBitmap ());
		}
	}
	CDialog::OnTimer(nIDEvent);
}

void DO_Config(byte slot,int ch,int bitvalue)
{
	if(ch>=0 && ch<16)
	{
		WORD value;
		if(bitvalue==1){
			value=pac_i8050W_UDIO_ReadConfig_16(slot);
			value=value|(1<<ch);
			pac_i8050W_UDIO_WriteConfig_16(slot,value);			
		}
		else if(bitvalue==0){
			value=pac_i8050W_UDIO_ReadConfig_16(slot);
		    value&=~(1<<ch);
		    pac_i8050W_UDIO_WriteConfig_16(slot,value);		    
		}
	}
}

void CPac_i8050WDemoDlg::OnDO0Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO0Config.GetCheck()){
		DO_Config(Slot,0,1);
		m_DO0.EnableWindow(true);		
		m_DI0.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,0,0);
		m_DO0.EnableWindow(false);	
		m_DI0.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO1Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO1Config.GetCheck()){
		DO_Config(Slot,1,1);
		m_DO1.EnableWindow(true);		
		m_DI1.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,1,0);	
		m_DO1.EnableWindow(false);	
		m_DI1.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO2Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO2Config.GetCheck()){
		DO_Config(Slot,2,1);
		m_DO2.EnableWindow(true);		
		m_DI2.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,2,0);
		m_DO2.EnableWindow(false);	
		m_DI2.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO3Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO3Config.GetCheck()){
		DO_Config(Slot,3,1);
		m_DO3.EnableWindow(true);		
		m_DI3.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,3,0);
		m_DO3.EnableWindow(false);	
		m_DI3.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO4Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO4Config.GetCheck()){
		DO_Config(Slot,4,1);
		m_DO4.EnableWindow(true);		
		m_DI4.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,4,0);
		m_DO4.EnableWindow(false);	
		m_DI4.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO5Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO5Config.GetCheck()){
		DO_Config(Slot,5,1);
		m_DO5.EnableWindow(true);		
		m_DI5.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,5,0);
		m_DO5.EnableWindow(false);	
		m_DI5.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO6Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO6Config.GetCheck()){
		DO_Config(Slot,6,1);
		m_DO6.EnableWindow(true);		
		m_DI6.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,6,0);
		m_DO6.EnableWindow(false);	
		m_DI6.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO7Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO7Config.GetCheck()){
		DO_Config(Slot,7,1);
		m_DO7.EnableWindow(true);		
		m_DI7.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,7,0);
		m_DO7.EnableWindow(false);	
		m_DI7.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO8Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO8Config.GetCheck()){
		DO_Config(Slot,8,1);
		m_DO8.EnableWindow(true);		
		m_DI8.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,8,0);
		m_DO8.EnableWindow(false);	
		m_DI8.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO9Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO9Config.GetCheck()){
		DO_Config(Slot,9,1);
		m_DO9.EnableWindow(true);		
		m_DI9.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,9,0);
		m_DO9.EnableWindow(false);	
		m_DI9.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO10Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO10Config.GetCheck()){
		DO_Config(Slot,10,1);
		m_DO10.EnableWindow(true);		
		m_DI10.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,10,0);
		m_DO10.EnableWindow(false);	
		m_DI10.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO11Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO11Config.GetCheck()){
		DO_Config(Slot,11,1);
		m_DO11.EnableWindow(true);		
		m_DI11.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,11,0);
		m_DO11.EnableWindow(false);	
		m_DI11.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO12Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO12Config.GetCheck()){
		DO_Config(Slot,12,1);
		m_DO12.EnableWindow(true);		
		m_DI12.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,12,0);
		m_DO12.EnableWindow(false);	
		m_DI12.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO13Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO13Config.GetCheck()){
		DO_Config(Slot,13,1);
		m_DO13.EnableWindow(true);		
		m_DI13.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,13,0);
		m_DO13.EnableWindow(false);	
		m_DI13.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO14Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO14Config.GetCheck()){
		DO_Config(Slot,14,1);
		m_DO14.EnableWindow(true);		
		m_DI14.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,14,0);
		m_DO14.EnableWindow(false);	
		m_DI14.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnDO15Config() 
{
	// TODO: Add your control notification handler code here
	if(m_DO15Config.GetCheck()){
		DO_Config(Slot,15,1);
		m_DO15.EnableWindow(true);		
		m_DI15.ShowWindow (SW_HIDE);
	}	
	else{
		DO_Config(Slot,15,0);
		m_DO15.EnableWindow(false);	
		m_DI15.ShowWindow (SW_SHOW);
	}
}

void CPac_i8050WDemoDlg::OnbtnSelectAll_DOConfig() 
{
	// TODO: Add your control notification handler code here
	m_DO0Config.SetCheck(true);
	m_DO1Config.SetCheck(true);
	m_DO2Config.SetCheck(true);
	m_DO3Config.SetCheck(true);
	m_DO4Config.SetCheck(true);
	m_DO5Config.SetCheck(true);
	m_DO6Config.SetCheck(true);
	m_DO7Config.SetCheck(true);
	m_DO8Config.SetCheck(true);
	m_DO9Config.SetCheck(true);
	m_DO10Config.SetCheck(true);
	m_DO11Config.SetCheck(true);
	m_DO12Config.SetCheck(true);
	m_DO13Config.SetCheck(true);
	m_DO14Config.SetCheck(true);
	m_DO15Config.SetCheck(true);	
	OnDO0Config();
	OnDO1Config();
	OnDO2Config();
	OnDO3Config();
	OnDO4Config();
	OnDO5Config();
	OnDO6Config();
	OnDO7Config();
	OnDO8Config();
	OnDO9Config();
	OnDO10Config();
	OnDO11Config();
	OnDO12Config();
	OnDO13Config();
	OnDO14Config();
	OnDO15Config();
}

void CPac_i8050WDemoDlg::OnCleartAll_DOConfig() 
{
	// TODO: Add your control notification handler code here
	m_DO0Config.SetCheck(false);
	m_DO1Config.SetCheck(false);
	m_DO2Config.SetCheck(false);
	m_DO3Config.SetCheck(false);
	m_DO4Config.SetCheck(false);
	m_DO5Config.SetCheck(false);
	m_DO6Config.SetCheck(false);
	m_DO7Config.SetCheck(false);
	m_DO8Config.SetCheck(false);
	m_DO9Config.SetCheck(false);
	m_DO10Config.SetCheck(false);
	m_DO11Config.SetCheck(false);
	m_DO12Config.SetCheck(false);
	m_DO13Config.SetCheck(false);
	m_DO14Config.SetCheck(false);
	m_DO15Config.SetCheck(false);	

	OnDO0Config();
	OnDO1Config();
	OnDO2Config();
	OnDO3Config();
	OnDO4Config();
	OnDO5Config();
	OnDO6Config();
	OnDO7Config();
	OnDO8Config();
	OnDO9Config();
	OnDO10Config();
	OnDO11Config();
	OnDO12Config();
	OnDO13Config();
	OnDO14Config();
	OnDO15Config();
}

void CPac_i8050WDemoDlg::OnbtnSelectAll_DOWrite() 
{
	// TODO: Add your control notification handler code here
	m_DO0.SetCheck(true);
	m_DO1.SetCheck(true);
	m_DO2.SetCheck(true);
	m_DO3.SetCheck(true);
	m_DO4.SetCheck(true);
	m_DO5.SetCheck(true);
	m_DO6.SetCheck(true);
	m_DO7.SetCheck(true);
	m_DO8.SetCheck(true);
	m_DO9.SetCheck(true);
	m_DO10.SetCheck(true);
	m_DO11.SetCheck(true);
	m_DO12.SetCheck(true);
	m_DO13.SetCheck(true);
	m_DO14.SetCheck(true);
	m_DO15.SetCheck(true);

	OnchkDO0();
	OnchkDO1();
	OnchkDO2();
	OnchkDO3();
	OnchkDO4();
	OnchkDO5();
	OnchkDO6();
	OnchkDO7();
	OnchkDO8();
	OnchkDO9();
	OnchkDO10();
	OnchkDO11();
	OnchkDO12();
	OnchkDO13();
	OnchkDO14();
	OnchkDO15();
}

void CPac_i8050WDemoDlg::OnbtnClearAll_DOWrite() 
{
	// TODO: Add your control notification handler code here
	m_DO0.SetCheck(false);
	m_DO1.SetCheck(false);
	m_DO2.SetCheck(false);
	m_DO3.SetCheck(false);
	m_DO4.SetCheck(false);
	m_DO5.SetCheck(false);
	m_DO6.SetCheck(false);
	m_DO7.SetCheck(false);
	m_DO8.SetCheck(false);
	m_DO9.SetCheck(false);
	m_DO10.SetCheck(false);
	m_DO11.SetCheck(false);
	m_DO12.SetCheck(false);
	m_DO13.SetCheck(false);
	m_DO14.SetCheck(false);
	m_DO15.SetCheck(false);

	OnchkDO0();
	OnchkDO1();
	OnchkDO2();
	OnchkDO3();
	OnchkDO4();
	OnchkDO5();
	OnchkDO6();
	OnchkDO7();
	OnchkDO8();
	OnchkDO9();
	OnchkDO10();
	OnchkDO11();
	OnchkDO12();
	OnchkDO13();
	OnchkDO14();
	OnchkDO15();
}

void CPac_i8050WDemoDlg::OnchkDO8() 
{
	// TODO: Add your control notification handler code here
	if(m_DO8.GetCheck()){
		DO_Bit(Slot,8,1);
		DOOn[8]=true;
	}
	else{
		DO_Bit(Slot,8,0);
		DOOn[8]=false;
	}
}
