// 7k87k_aiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k87k_ai.h"
#include "7k87k_aiDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
unsigned char cPort;

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_aiDlg dialog

CMy7k87k_aiDlg::CMy7k87k_aiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k87k_aiDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k87k_aiDlg)
	m_strAddr = _T("");
	m_dwBaud = 0;
	m_iAIChs = 0;
	m_iRWhichCh = 0;
	m_fAIValue = 0.0f;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k87k_aiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k87k_aiDlg)
	DDX_Control(pDX, IDC_COMBOCom, m_cmbCom);
	DDX_Text(pDX, IDC_EDITAddr, m_strAddr);
	DDX_Text(pDX, IDC_EDITBaud, m_dwBaud);
	DDX_Text(pDX, IDC_EDITAIChs, m_iAIChs);
	DDX_Text(pDX, IDC_EDITRWhichCh, m_iRWhichCh);
	DDX_Text(pDX, IDC_EDITAIValue, m_fAIValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k87k_aiDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k87k_aiDlg)
	ON_BN_CLICKED(IDC_BUTTONReadAI, OnBUTTONReadAI)
	ON_BN_CLICKED(IDC_BUTTONReadAI2, OnBUTTONReadAI2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_aiDlg message handlers

BOOL CMy7k87k_aiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default values
	m_cmbCom.SetCurSel(2);
	m_strAddr=_T("01");
	m_dwBaud=115200;
	m_iAIChs=8;
	m_iRWhichCh=0;
	m_fAIValue=0;
	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy7k87k_aiDlg::OnBUTTONReadAI() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];
	char ConnectionString[32];

	UpdateData(true);
	int cPort=m_cmbCom.GetCurSel();
	
	//Get module address
	wcstombs(cTmp, m_strAddr, 10);
	sscanf(cTmp,"%x",&iAddr);


	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);
	
	//Read AI value from remote module
	HANDLE hPort = uart_Open(ConnectionString);

	if(hPort==(HANDLE)0xffffffff){
		AfxMessageBox(_T("Open Com Error"));
		uart_Close(hPort);
		return;
	}

	bool ret = pac_ReadAI( hPort, PAC_REMOTE_IO(iAddr), m_iRWhichCh, m_iAIChs, &m_fAIValue);	

	if(!ret){
		AfxMessageBox(_T("DI read error or something wrong"));
	}else{
		UpdateData(false);
	}
	uart_Close(hPort);
}

void CMy7k87k_aiDlg::OnBUTTONReadAI2() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];
	char ConnectionString[32];

	float fAIValue[32] = {0};
	DWORD len = 0;

	UpdateData(true);
	int cPort=m_cmbCom.GetCurSel();
	
	//Get module address
	wcstombs(cTmp, m_strAddr, 10);
	sscanf(cTmp,"%x",&iAddr);


	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);
	
	//Read AI value from remote module
	HANDLE hPort = uart_Open(ConnectionString);

	if(hPort==(HANDLE)0xffffffff){
		AfxMessageBox(_T("Open Com Error"));
		uart_Close(hPort);
		return;
	}

	bool ret = pac_ReadAIAllExt(hPort, PAC_REMOTE_IO(iAddr), fAIValue, 32, &len);	

	if(!ret)
	{
		AfxMessageBox(_T("DI read error or something wrong"));
	}
	else
	{
		for(int i = 0; i < 32; i++)
		{
			printf("channel %d, value: %f\n", i, fAIValue[i]);
		}

		printf("total channel len: %d\n", len);
	}

	uart_Close(hPort);
}
