// 7k87k_dioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k87k_dio.h"
#include "7k87k_dioDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
unsigned char cPort;
/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_dioDlg dialog

CMy7k87k_dioDlg::CMy7k87k_dioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k87k_dioDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k87k_dioDlg)
	m_strAddr = _T("");
	m_dwBaud = 0;
	m_iDIChs = 0;
	m_iDOChs = 0;
	m_strDIValue = _T("");
	m_strDOValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k87k_dioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k87k_dioDlg)
	DDX_Control(pDX, IDC_COMBOCom, m_cmbCom);
	DDX_Text(pDX, IDC_EDITAddr, m_strAddr);
	DDX_Text(pDX, IDC_EDITBaud, m_dwBaud);
	DDX_Text(pDX, IDC_EDITDIChs, m_iDIChs);
	DDX_Text(pDX, IDC_EDITDOChs, m_iDOChs);
	DDX_Text(pDX, IDC_EDITDIValue, m_strDIValue);
	DDX_Text(pDX, IDC_EDITDOValue, m_strDOValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k87k_dioDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k87k_dioDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	ON_BN_CLICKED(IDC_BUTTONReadDI2, OnBUTTONReadDI2)
	ON_BN_CLICKED(IDC_BUTTONWriteDO2, OnBUTTONWriteDO2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_dioDlg message handlers

BOOL CMy7k87k_dioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbCom.SetCurSel(2);
	m_strAddr=_T("01");
	m_dwBaud=115200;
	m_iDIChs=8;
	m_iDOChs=8;
	m_strDOValue=_T("0");
	m_strDIValue=_T("0");
	UpdateData(false);
	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");


	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy7k87k_dioDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[20];
	unsigned long DI_Value,DO_Value;
	char ConnectionString[32];

	int cPort=m_cmbCom.GetCurSel();

	//Get module address
	wcstombs(cTmp,m_strAddr,10);
	sscanf(cTmp,"%X",&iAddr);
	UpdateData(true);
	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);

	//Read DI value from remote module
	HANDLE hPort = uart_Open(ConnectionString);
	if(! hPort) AfxMessageBox(_T("Open Com Error"));

	bool ret = pac_ReadDIO( hPort, PAC_REMOTE_IO(iAddr),m_iDIChs, m_iDOChs, &DI_Value, &DO_Value);

	if(!ret){
		AfxMessageBox(_T("DI read error or something wrong"));
		return;
	}
	uart_Close(hPort);

	//Shwo DI value
	sprintf(cTmp,"%x",DI_Value);
	m_strDIValue=cTmp;
	UpdateData(false);
}

void CMy7k87k_dioDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];
	unsigned long lDO_Value=0;
	char ConnectionString[32];

	int cPort=m_cmbCom.GetCurSel();
	UpdateData(true);
	//Get module address
	wcstombs(cTmp,m_strAddr,10);
	sscanf(cTmp,"%x",&iAddr);

	
	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);
	
	//Get DO value
	wcstombs(cTmp,m_strDOValue,10);
	sscanf(cTmp,"%lx",&lDO_Value);

	//Write DO value to remote module
	HANDLE hPort = uart_Open(ConnectionString);
	if(! hPort) AfxMessageBox(_T("Open Com Error"));

	bool ret = pac_WriteDO(hPort, PAC_REMOTE_IO(iAddr), m_iDOChs, lDO_Value);
	
	uart_Close(hPort);

}

void CMy7k87k_dioDlg::OnBUTTONReadDI2() 
{
// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[20];
	unsigned long DI_Value,DO_Value;
	char ConnectionString[32];

	int cPort=m_cmbCom.GetCurSel();

	//Get module address
	wcstombs(cTmp,m_strAddr,10);
	sscanf(cTmp,"%X",&iAddr);
	UpdateData(true);
	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);

	//Read DI value from remote module
	HANDLE hPort = uart_Open(ConnectionString);
	if(! hPort) AfxMessageBox(_T("Open Com Error"));

	bool ret = pac_ReadDIO_MF( hPort, PAC_REMOTE_IO(iAddr),m_iDIChs, m_iDOChs, &DI_Value, &DO_Value);

	if(!ret){
		AfxMessageBox(_T("DI read error or something wrong"));
		return;
	}
	uart_Close(hPort);

	//Shwo DI value
	sprintf(cTmp,"%x",DI_Value);
	m_strDIValue=cTmp;
	UpdateData(false);	
}

void CMy7k87k_dioDlg::OnBUTTONWriteDO2() 
{
// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];
	unsigned long lDO_Value=0;
	char ConnectionString[32];

	int cPort=m_cmbCom.GetCurSel();
	UpdateData(true);
	//Get module address
	wcstombs(cTmp,m_strAddr,10);
	sscanf(cTmp,"%x",&iAddr);

	
	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);
	
	//Get DO value
	wcstombs(cTmp,m_strDOValue,10);
	sscanf(cTmp,"%lx",&lDO_Value);

	//Write DO value to remote module
	HANDLE hPort = uart_Open(ConnectionString);
	if(! hPort) AfxMessageBox(_T("Open Com Error"));

	bool ret = pac_WriteDO_MF(hPort, PAC_REMOTE_IO(iAddr), m_iDOChs, lDO_Value);
	
	uart_Close(hPort);	
}
