// 7k_pwmDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_pwm.h"
#include "7k_pwmDlg.h"

#include "PACSDK.h"
#include "PACSDK_PWM.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy7k_pwmDlg dialog

CMy7k_pwmDlg::CMy7k_pwmDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k_pwmDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k_pwmDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_pwmDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k_pwmDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k_pwmDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k_pwmDlg)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	ON_EN_CHANGE(IDC_EDIT43, OnChangeEdit43)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k_pwmDlg message handlers

const int hzArr[] = {IDC_EDIT1, IDC_EDIT2, IDC_EDIT3, IDC_EDIT4, IDC_EDIT5, IDC_EDIT6, IDC_EDIT7, IDC_EDIT8 };
const int dutyArr[] = { IDC_EDIT9, IDC_EDIT10, IDC_EDIT11, IDC_EDIT12, IDC_EDIT13, IDC_EDIT14, IDC_EDIT15, IDC_EDIT16 };
const int modeArr[] = { IDC_COMBO1, IDC_COMBO2, IDC_COMBO3, IDC_COMBO4, IDC_COMBO5, IDC_COMBO6, IDC_COMBO7, IDC_COMBO8 };
const int cntArr[] = { IDC_EDIT17, IDC_EDIT18, IDC_EDIT19, IDC_EDIT20, IDC_EDIT21, IDC_EDIT22, IDC_EDIT23, IDC_EDIT24 };
const int cbxArr[] = { IDC_CHECK1, IDC_CHECK2, IDC_CHECK3, IDC_CHECK4, IDC_CHECK5, IDC_CHECK6, IDC_CHECK7, IDC_CHECK8 };

BOOL CMy7k_pwmDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void GetPWMConfig(int chIndex);

HANDLE hPort  ;
int slotIndex = 7;
byte pwmStartBit[8];
bool activated = true;

void CMy7k_pwmDlg::ConfigPWMSettings(int index)
{
    TCHAR temp[20];
    int chIndex = index;   
    bool ret = false ;

    GetDlgItemText( hzArr[chIndex], temp, 20);
    ret = pac_SetPWMFrequency(hPort, slotIndex, chIndex, _wtoi(temp));

    if (!ret)
    {
        uint ec = pac_GetLastError();
        //MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
    }
    else
    {
        float fVal = 0;
        GetDlgItemText(dutyArr[chIndex], temp, 20);
        
        swscanf(temp,   _T( "%f "),   &fVal); 
        ret = pac_SetPWMDuty(hPort, slotIndex, chIndex, fVal);

        GetDlgItemText(cntArr[chIndex], temp, 20);
        ret = pac_SetPWMPulseCount(hPort, slotIndex, chIndex, _wtoi(temp));

        //GetDlgItemText(modeArr[chIndex], temp, 20);
        
        ret = pac_SetPWMMode(hPort, slotIndex, chIndex, ((CComboBox *)GetDlgItem(modeArr[chIndex]))->GetCurSel());

        GetPWMConfig(chIndex);
    }
}

void CMy7k_pwmDlg::GetPWMConfig(int chIndex)
{
    //TextBox[] hzArr = new TextBox[] { txtHz0, txtHz1, txtHz2, txtHz3, txtHz4, txtHz5, txtHz6, txtHz7 }; //
    //TextBox[] dutyArr = new TextBox[] { txtDuty0, txtDuty1, txtDuty2, txtDuty3, txtDuty4, txtDuty5, txtDuty6, txtDuty7 };
    //ComboBox[] modeArr = new ComboBox[] { cboMode0, cboMode1, cboMode2, cboMode3, cboMode4, cboMode5, cboMode6, cboMode7 };
    //TextBox[] cntArr = new TextBox[] { txtCnt0, txtCnt1, txtCnt2, txtCnt3, txtCnt4, txtCnt5, txtCnt6, txtCnt7 };
    TCHAR temp[20];
    unsigned long freq = 0;
    bool ret = false;

    ret = pac_GetPWMFrequency(hPort, slotIndex, chIndex, &freq);


    if (!ret)
    {
        uint ec = pac_GetLastError();
        //MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
    }
    else
    {
        //hzArr[chIndex].Text = freq.ToString();
        wsprintf(temp,L"%u",freq);
        SetDlgItemText(hzArr[chIndex], temp);

        float duty = 0;
        ret = pac_GetPWMDuty(hPort, slotIndex, chIndex, &duty);
        //dutyArr[chIndex].Text = String.Format("{0:00.0}", duty);
        wsprintf(temp,L"%f",duty);
        SetDlgItemText(dutyArr[chIndex], temp);

        long cnt = 0;
        ret = pac_GetPWMPulseCount(hPort, slotIndex, chIndex, &cnt);
        //cntArr[chIndex].Text = cnt.ToString();
        wsprintf(temp,L"%d",cnt);
        SetDlgItemText(cntArr[chIndex], temp);

        long mode = 0;
        ret = pac_GetPWMMode(hPort, slotIndex, chIndex, &mode);
        //modeArr[chIndex].SelectedIndex = mode;
        //wsprintf(temp,L"%d",cnt);
        //SetDlgItemText(modeArr[chIndex], );
        ((CComboBox *)GetDlgItem(modeArr[chIndex]))->SetCurSel(mode);
    }
}

void CMy7k_pwmDlg::EnablePWM(int index)
{
    if (activated)
    {
        int chIndex = index; //
        bool ret = false;

        //CheckBox enBox = (CheckBox)sender;
        int status = 0;
        CButton* bPowerOffObj=(CButton*)GetDlgItem(cbxArr[index]);

        if(bPowerOffObj->GetCheck() == BST_CHECKED)
        {
            // ???????
            pwmStartBit[chIndex] = 1;           
        }
        else
        {
            pwmStartBit[chIndex] = 0;          
        }

        for (int i = 0; i < 8; i++)
            status += (pwmStartBit[i] << i);

        ret = pac_SetPWMStart(hPort, slotIndex, status);

        if (!ret)
        {
            uint ec = pac_GetLastError();
            //MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
        }
    }
}

void CMy7k_pwmDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];
    //get user set address
    GetDlgItemText(IDC_EDIT41, OpenPort, 10);

    //get user set BuadRate
    GetDlgItemText(IDC_EDIT42, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    if (hPort == NULL)
    {
        uint ec = pac_GetLastError();
        //MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
    }
    else
    {
        //this.Text = pacPWM.LibVersion().ToString();
    }
}

void CMy7k_pwmDlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_di", MB_OK);
    }
}


void CMy7k_pwmDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(0);
}

void CMy7k_pwmDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(1);
}

void CMy7k_pwmDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(2);
}

void CMy7k_pwmDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(3);
}

void CMy7k_pwmDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(4);
}

void CMy7k_pwmDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(5);
}

void CMy7k_pwmDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(6);
}

void CMy7k_pwmDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	ConfigPWMSettings(7);
}

void CMy7k_pwmDlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(0);
}

void CMy7k_pwmDlg::OnCheck2() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(1);
}

void CMy7k_pwmDlg::OnCheck3() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(2);
}

void CMy7k_pwmDlg::OnCheck4() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(3);
}

void CMy7k_pwmDlg::OnCheck5() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(4);
}

void CMy7k_pwmDlg::OnCheck6() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(5);
}

void CMy7k_pwmDlg::OnCheck7() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(6);
}

void CMy7k_pwmDlg::OnCheck8() 
{
	// TODO: Add your control notification handler code here
	EnablePWM(7);
}

void CMy7k_pwmDlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	 bool ret = pac_SavePWMConfig(hPort, slotIndex);

    if (!ret)
    {
        uint ec = pac_GetLastError();
        //MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
    }
}

int lbDI[] = { IDC_EDIT33, IDC_EDIT34, IDC_EDIT35, IDC_EDIT36, IDC_EDIT37, IDC_EDIT38, IDC_EDIT39, IDC_EDIT40 };
int lbPWM[] = { IDC_EDIT25, IDC_EDIT26, IDC_EDIT27, IDC_EDIT28, IDC_EDIT29, IDC_EDIT30, IDC_EDIT31, IDC_EDIT32 };
int enPWM[] = { IDC_CHECK1, IDC_CHECK2, IDC_CHECK3, IDC_CHECK4, IDC_CHECK5, IDC_CHECK6, IDC_CHECK7, IDC_CHECK8 };

void CMy7k_pwmDlg::OnButton12() 
{
	// TODO: Add your control notification handler code here
	 TCHAR temp[20];
    GetDlgItemText(IDC_EDIT43, temp, 20);
    slotIndex = _wtoi(temp);

    byte pwmBit[8];
    byte diBit[8];
    bool ret = false;

    ret = pac_GetPWMDIOStatus(hPort, slotIndex, pwmBit, diBit);

    if (!ret)
    {
        uint ec = pac_GetLastError();
        //MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
    }
    else
    {
        for (int i = 0; i < 8; i++)
        {
            if (pwmBit[i] == 1)
            {
                //lbPWM[i].Text = "ON";//
                SetDlgItemText(lbPWM[i], L"ON");
                //lbPWM[i].BackColor = Color.Red;
                pwmStartBit[i] = 1;
                activated = false;
                //enPWM[i].Checked = true;
                ((CButton*)GetDlgItem(enPWM[i]))->SetCheck(true);
                activated = true;
            }
            else
            {
                //lbPWM[i].Text = "OFF";//
                SetDlgItemText(lbPWM[i], L"OFF");
                //lbPWM[i].BackColor = Color.Gray;
                activated = false;
                //enPWM[i].Checked = false;
                ((CButton*)GetDlgItem(enPWM[i]))->SetCheck(false);
                activated = true;
            }

            if (diBit[i] == 1)
            {
                //lbDI[i].Text = "ON";//
                SetDlgItemText(lbDI[i], L"ON");
                //lbDI[i].BackColor = Color.Green;
            }
            else
            {
                //lbDI[i].Text = "OFF";//
                SetDlgItemText(lbDI[i], L"OFF");
                //lbDI[i].BackColor = Color.Gray;
            }
        }
    }
}

void CMy7k_pwmDlg::OnChangeEdit43() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
    GetDlgItemText(IDC_EDIT43, temp, 20);
    slotIndex = _wtoi(temp);
}
