// WinpacSDK.cpp : Defines the entry point for the DLL application.
//
#include "stdafx.h"
#include "PACSDK.h"
#include "Pkfuncs.h"
#include "OALINTR.H"
#include "PACERROR.H"
//#include "private_winpac.h"

#define TIMER_COUNT 3		
#define SYSINTR_ID(ndx) (SYSINTR_BP_TIMER_0 + ndx)

static int WINAPI _timer_thread_0(void);
static int WINAPI _timer_thread_1(void);
static int WINAPI _timer_thread_2(void);

int (WINAPI *_timer_thread_func[])() = { 
	_timer_thread_0, //timeout
	_timer_thread_1,
	_timer_thread_2,
};
	

PAC_TIMEROUT_CALLBACK_FUNC timerout_callback_func[TIMER_COUNT];
VOID  *gPAC270BPTimerIntrEvent[TIMER_COUNT];
VOID  *gPAC270BPTimerIntrThread[TIMER_COUNT];

static void interrupt_done(int type)
{
	switch(type)
	{
	case TIMEROUT:
		_pac_outp(0x9000 + 2*0x07, 1 << 2);
//		*_pac_map(0x9000 + (0x07 *2 )) = (1 << 2); //clear timerout
		break;
	case TIMER1:
		_pac_outp(0x9000 + 2*0x07, 1 << 0);
//		*_pac_map(0x9000 + (0x07 *2 )) = (1 << 0); //Clear timer1
		break;		
	case TIMER2:
		_pac_outp(0x9000 + 2*0x07, 1 << 1);
//		*_pac_map(0x9000 + (0x07 *2 )) = (1 << 1); //Clear timer2
		break;
	}	

	_pac_outp(0x9006, 0xFF);//EOI of back-plane
}
static bool pac_BPTimerInterruptInitialize( int type )
{
	gPAC270BPTimerIntrEvent[type] = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (!(InterruptInitialize(SYSINTR_ID(type), gPAC270BPTimerIntrEvent[type], NULL, 0))) {
		   return false;       
	}
	return true;
}


static bool pac_UnregisterBPTimerInterrupt( int type )
{
	DWORD pdwExitCode;
	if ( ! timerout_callback_func[type] ) {
		pac_SetLastError(PAC_ERR_BPTIMER_NOT_REGISTERED);
		return false;
	}
	printf("close");

	CloseHandle(gPAC270BPTimerIntrEvent[type] );
	GetExitCodeThread(gPAC270BPTimerIntrThread[type],&pdwExitCode);
	TerminateThread(gPAC270BPTimerIntrThread[type], pdwExitCode);
	timerout_callback_func[type] = NULL;			
	gPAC270BPTimerIntrEvent[type] = NULL;			
	gPAC270BPTimerIntrThread[type] = NULL;			
	return true;
}

/*static*/ bool pac_SetBPTimerInterruptPriority(int type, int nPriority)
{
    return 0 != CeSetThreadPriority(gPAC270BPTimerIntrThread[type], nPriority);
}

static bool pac_TimerOutInterrupt(int type,PAC_TIMEROUT_CALLBACK_FUNC f)
{

	timerout_callback_func[type] = f;

		printf("i0\r\n");
	if (!pac_BPTimerInterruptInitialize(type)) 
		return false;
	
	printf("i1\r\n");

	gPAC270BPTimerIntrThread[type] = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) _timer_thread_func[type], NULL, 0, NULL);
  if ( gPAC270BPTimerIntrThread[type] == NULL )  
	 return false;

	printf("i2\r\n");
   pac_SetBPTimerInterruptPriority(type, 0 ) ;//THREAD_PRIORITY_HIGHEST);
	return true;
}


/*WINPAC_API HANDLE pac_GetBPTimerInterruptEvent(int type)
{
	return gPAC270BPTimerIntrEvent[type];
}

WINPAC_API void pac_SetBPTimerInterruptEvent(int type, HANDLE hEvent)
{
	gPAC270BPTimerIntrEvent[type] = hEvent;
}

WINPAC_API DWORD pac_GetSlotInterruptID(BYTE slot)
{
	return SYSINTR_ID(slot);
}*/


static void pac_BPTimer_InterruptDone(int type)
{
	interrupt_done(type);
}

void pac_KillBPTimer_(int type)
{
  switch(type) 
	{		
			case TIMEROUT:	//0: timerout	
				*_pac_map(0x9000 + 2*0x05) &= ~(1 << 2); 

				_pac_outp(0x9000 + 2*0x10, 0); //1us
				_pac_outp(0x9000 + 2*0x11, 0); //1us
  
				_pac_outp(0x9000 + 2*0x12, 0); //1us
				_pac_outp(0x9000 + 2*0x13, 0); //1us 
				break;
				
			case TIMER1:	//0: timer1	
				_pac_outp(0x9000 + 2*0x1c, 0);
				_pac_outp(0x9000 + 2*0x1d, 0); 
				break;				

			case TIMER2:	//1:timer2 	
				_pac_outp(0x9000 + 2*0x1e, 0);
				_pac_outp(0x9000 + 2*0x1f, 0);
				break;		

	}
	interrupt_done(type);
	pac_UnregisterBPTimerInterrupt(type);
}

bool pac_SetBPTimerOut_(unsigned int uHighElapse,unsigned int uLOwElapse, PAC_TIMEROUT_CALLBACK_FUNC f)
{
  *_pac_map(0x9000 + 2*0x05) |= (1 << 2); //enable timeout interrupt

  _pac_outp(0x9000 + 2*0x10, uHighElapse & 0xff); //1us
	_pac_outp(0x9000 + 2*0x11, (uHighElapse >> 8) & 0xff);
  
  _pac_outp(0x9000 + 2*0x12, uLOwElapse & 0xff); //1us
	_pac_outp(0x9000 + 2*0x13, (uLOwElapse >> 8) & 0xff); 
  
  return pac_TimerOutInterrupt(TIMEROUT,f);       
}
bool pac_SetBPTimer_(int type,unsigned int uElapse, PAC_TIMEROUT_CALLBACK_FUNC f)
{	
  switch(type) 
	{
/*			case TIMEROUT:	//0: timerout	s
				*_pac_map(0x9000 + 2*0x05) |= (1 << 2); 
				break;*/

			case TIMER1:	//0: timer1	 //1us
				_pac_outp(0x9000 + 2*0x1c, uElapse & 0xff);
				_pac_outp(0x9000 + 2*0x1d, (uElapse >> 8) & 0xff); 
				break;				

			case TIMER2:	//1:timer2 	//10us
				_pac_outp(0x9000 + 2*0x1e, uElapse & 0xff);
				_pac_outp(0x9000 + 2*0x1f, (uElapse >> 8) & 0xff);
				break;
				
			default:
			 return false;
	}
	return pac_TimerOutInterrupt(type,f);
}

#if 0
static DWORD pac_GetBPTimerTimeTick_ms_(void)
{
  unsigned long ulTimeCount=0;  
  
  ulTimeCount=(unsigned long)(_pac_inp(0x9000 + 2*0x17)<<24); //bit31~24
  ulTimeCount+=(unsigned long)(_pac_inp(0x9000 + 2*0x16)<<16); //bit23~16
  ulTimeCount+=(unsigned long)(_pac_inp(0x9000 + 2*0x15)<<8); //bit15~8
  ulTimeCount+=(unsigned long)(_pac_inp(0x9000 + 2*0x14)); //bit7~0
  
  return ulTimeCount;       //unit 1ms
}

static WORD pac_GetBPTimerTimeTick_us_(void)
{
  return(_pac_inp(0x9000 + 2*0x20)); //unit 4us
}

#endif

#define DECL_BPTIMER_THREAD_FUNC(id) \
static int WINAPI _timer_thread_##id(void) \
{ \
	DWORD dwWaitReturn; \
	bool bExit = false; \
    while(! bExit) \
	{ \
	    dwWaitReturn = WaitForSingleObject(gPAC270BPTimerIntrEvent[id], INFINITE); \
		int ret = (timerout_callback_func[id])(); \
		switch(ret) { \
		case PAC_INTR_FAIL: \
			break; \
		case PAC_INTR_DONE: \
		    interrupt_done(id); \
			break; \
		case PAC_INTR_EXIT: \
			bExit = true; \
			break; \
		} \
	} \
    interrupt_done(id); \
	ExitThread(0); \
    return 0; \
}

DECL_BPTIMER_THREAD_FUNC(0);
DECL_BPTIMER_THREAD_FUNC(1);
DECL_BPTIMER_THREAD_FUNC(2);

