// MultiRTDlg.cpp : implementation file
//
/*******************ICPDAS Real-Time demo*****************/
/* 
	Use Multimedia Timer for Real-Time.
	Multimedia Timer functions: 
	(1).timeBeginPeriod
	(2).timeEndPeriod 
	(3).timeKillEvent
	(4).timeSetEvent,
	(5).TimeProc 

	The maximum number of Multiple Multimedia Timer is 15.

    Test way: 
	     Before use this timer, It must to set priority once. After setting priority, run WinPAC utility to save registry and then reboot 	                
		 Use QueryPerformance timer to measure the time interval between two interrupts

	What is real-time?
	     Please refer to msdn of microsoft.
*/
/*******************ICPDAS Real-Time demo*****************/

#include "stdafx.h"
#include "MultiRT.h"
#include "MultiRTDlg.h"
#include "Pkfuncs.h"
#include "Mmsystem.h"
#include "pacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LARGE_INTEGER nFreq;
#define MAX_TIMER_NUM	10

void CALLBACK _time_thread_0( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_1( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_2( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_3( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_4( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_5( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_6( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);
void CALLBACK _time_thread_7( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2);


void (*TimeProc[])(UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2) = { 
	_time_thread_0,
	_time_thread_1,
	_time_thread_2,
	_time_thread_3,
	_time_thread_4,
	_time_thread_5,
	_time_thread_6,
	_time_thread_7,
};

HANDLE hAPI_Thread;
CString csTmp;
char cTmp[10];

UINT uiTimerID[MAX_TIMER_NUM];
LARGE_INTEGER TimerTick[MAX_TIMER_NUM];
DWORD MaxTimerTick[MAX_TIMER_NUM]={0};
DWORD MinTimerTick[MAX_TIMER_NUM]={0xFFFFFFFF};
DWORD AvgTimerTick[MAX_TIMER_NUM]={0};
DWORD TimerISTNum[MAX_TIMER_NUM]={0};

/////////////////////////////////////////////////////////////////////////////
// CMultiRTDlg dialog

CMultiRTDlg::CMultiRTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMultiRTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMultiRTDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMultiRTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMultiRTDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMultiRTDlg, CDialog)
	//{{AFX_MSG_MAP(CMultiRTDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON20, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON21, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON22, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON23, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON24, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON25, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON26, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON27, OnButtonClick)
	ON_BN_CLICKED(IDC_BUTTON30, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON31, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON32, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON33, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON34, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON35, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON36, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON37, OnButtonStop)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMultiRTDlg message handlers

BOOL CMultiRTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	SetDlgItemInt(IDC_EDIT1,100,FALSE);
	//for(int i=0;i<8;i++)
	//	GetDlgItem(IDC_BUTTON30+uindex)->EnableWindow(False);
	SetDlgItemInt(IDC_EDIT10,2,FALSE);
	SetDlgItemInt(IDC_EDIT11,5,FALSE);
	SetDlgItemInt(IDC_EDIT12,10,FALSE);
	SetDlgItemInt(IDC_EDIT13,20,FALSE);
	SetDlgItemInt(IDC_EDIT14,50,FALSE);
	SetDlgItemInt(IDC_EDIT15,100,FALSE);
	SetDlgItemInt(IDC_EDIT16,500,FALSE);
	SetDlgItemInt(IDC_EDIT17,1000,FALSE);

	SetTimer(1,1000,NULL);
	QueryPerformanceFrequency(&nFreq);
	timeBeginPeriod(1); 	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void GetMinTick(UINT uID,DWORD dwtick)
{	
	if(dwtick<MinTimerTick[uID])
		MinTimerTick[uID]=dwtick;
}
void GetMaxTick(UINT uID,DWORD dwtick)
{
	if(dwtick>MaxTimerTick[uID])
		MaxTimerTick[uID]=dwtick;
}
void GetAvgTick(UINT uID,DWORD dwtick)
{
	if(TimerISTNum[uID]>=8000)
	{
		AvgTimerTick[uID]=0;
		TimerISTNum[uID]=1;
	}
	else
		TimerISTNum[uID]++;

	AvgTimerTick[uID]+=dwtick;	
}

void CALLBACK _time_thread_0 (UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;


	QueryPerformanceCounter(&nEndTime);		
	
	double ddiff=(double)(nEndTime.QuadPart-TimerTick[0].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[0])
	{
		GetMinTick(0,(DWORD)ddiff);	
		GetMaxTick(0,(DWORD)ddiff);
	}
	GetAvgTick(0,(DWORD)ddiff);		

	QueryPerformanceCounter(&TimerTick[0]);		
}
void CALLBACK _time_thread_1 (UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	QueryPerformanceCounter(&nEndTime);		

	double ddiff=(double)(nEndTime.QuadPart-TimerTick[1].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[1])
	{
		GetMinTick(1,(DWORD)ddiff);	
		GetMaxTick(1,(DWORD)ddiff);
	}
	GetAvgTick(1,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[1]);		
}
void CALLBACK _time_thread_2( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	QueryPerformanceCounter(&nEndTime);		

	double ddiff=(double)(nEndTime.QuadPart-TimerTick[2].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[2])
	{	
		GetMinTick(2,(DWORD)ddiff);	
		GetMaxTick(2,(DWORD)ddiff);
	}
	GetAvgTick(2,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[2]);		
}
void CALLBACK _time_thread_3( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	QueryPerformanceCounter(&nEndTime);		


	double ddiff=(double)(nEndTime.QuadPart-TimerTick[3].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[3])
	{	
		GetMinTick(3,(DWORD)ddiff);	
		GetMaxTick(3,(DWORD)ddiff);
	}
	GetAvgTick(3,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[3]);		
}
void CALLBACK _time_thread_4( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	//printf("id=%d\n",uID);
	QueryPerformanceCounter(&nEndTime);		

	double ddiff=(double)(nEndTime.QuadPart-TimerTick[4].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[4])
	{	
		GetMinTick(4,(DWORD)ddiff);	
		GetMaxTick(4,(DWORD)ddiff);
	}
	GetAvgTick(4,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[4]);		
}
void CALLBACK _time_thread_5( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	//printf("id=%d\n",uID);
	QueryPerformanceCounter(&nEndTime);		


	double ddiff=(double)(nEndTime.QuadPart-TimerTick[5].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[5])
	{	
		GetMinTick(5,(DWORD)ddiff);	
		GetMaxTick(5,(DWORD)ddiff);
	}
	GetAvgTick(5,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[5]);		
}
void CALLBACK _time_thread_6( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	QueryPerformanceCounter(&nEndTime);		
	//printf("id=%d\n",uID);

	double ddiff=(double)(nEndTime.QuadPart-TimerTick[6].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[6])
	{	
		GetMinTick(6,(DWORD)ddiff);	
		GetMaxTick(6,(DWORD)ddiff);
	}
	GetAvgTick(6,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[6]);		
}
void CALLBACK _time_thread_7( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	LARGE_INTEGER nEndTime;

	QueryPerformanceCounter(&nEndTime);	
	//printf("id=%d\n",uID);

	double ddiff=(double)(nEndTime.QuadPart-TimerTick[7].QuadPart)*1000*1000/(double)nFreq.QuadPart;
	if(AvgTimerTick[7])
	{	
		GetMinTick(7,(DWORD)ddiff);	
		GetMaxTick(7,(DWORD)ddiff);
	}
	GetAvgTick(7,(DWORD)ddiff);

	QueryPerformanceCounter(&TimerTick[7]);		
}

void CMultiRTDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
    /*
		//ICPAS: Set timeSetEvent priority
	*/

	bool ret;
    //ICPAS:Check if key exists
    if(!pac_RegKeyExist(_T("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\")))
	{
		//ICPAS:Create Key
		ret=pac_RegCreateKey(_T("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\"));
		if(!ret) printf("Create registry key fail.(\"HKEY_LOCAL_MACHINE\\System\\MMTIMER\\\")\n");
	}    	

	//ICPAS:Set priority value
	UINT uiPriority=GetDlgItemInt(IDC_EDIT1,NULL,FALSE);
	UpdateData(true); 
	ret=pac_RegSetDWORD(_T("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\Priority256"),uiPriority);
	if(!ret) printf("Set priority value fail.(pac_RegSetDWORD() function fail)\n");
			
}

void CMultiRTDlg::OnTimer(UINT nIDEvent) 
{
	for(int i=0;i<8;i++)
	{
		if(uiTimerID[i])
		{
		//	printf("MAX %d=%f\r\n",i,MaxTimerTick[i]);
		//	printf("MIN %d=%f\r\n",i,MinTimerTick[i]);		
			SetDlgItemInt(IDC_EDIT30+i,(UINT)MaxTimerTick[i],FALSE);
			SetDlgItemInt(IDC_EDIT40+i,(UINT)MinTimerTick[i],FALSE);
			if(TimerISTNum[i])
			{
				double daveg=(double)(AvgTimerTick[i]/TimerISTNum[i]);
				SetDlgItemInt(IDC_EDIT20+i,(UINT)daveg,FALSE);			
			}
		}
	}
	UpdateData(false); 
	CDialog::OnTimer(nIDEvent);
}

void CMultiRTDlg::OnClose() 
{
	timeEndPeriod(1);
	KillTimer(1);	
	
	CDialog::OnClose();
}

void CMultiRTDlg::OnButtonClick() 
{
	UINT uInterval=0;
	// TODO: Add your control notification handler code here

	//ICPAS: Get total channels of DO
    const MSG* msg = GetCurrentMessage();
	
	WORD uID=LOWORD(msg->wParam);
	UINT uindex=uID-IDC_BUTTON20;
	GetDlgItem(IDC_BUTTON20+uindex)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON30+uindex)->EnableWindow(TRUE);
	//printf("S Index=%d\r\n",uindex);
	uInterval=GetDlgItemInt(IDC_EDIT10+uindex,NULL,FALSE);
	//printf("uInterval=%d\r\n",uInterval);
	//ICPAS: use timeSetEvent() to do real-time operation.
	TimerISTNum[uindex]=0;
	AvgTimerTick[uindex]=0;
	MinTimerTick[uindex]=uInterval*1000+800; //microseconds		
	uiTimerID[uindex]=timeSetEvent(uInterval,1,(LPTIMECALLBACK)TimeProc[uindex],0,TIME_PERIODIC);	
	QueryPerformanceCounter(&TimerTick[uindex]);
}

void CMultiRTDlg::OnButtonStop() 
{
    const MSG* msg = GetCurrentMessage();
	
	WORD uID=LOWORD(msg->wParam);
	UINT uindex=uID-IDC_BUTTON30;	
	GetDlgItem(IDC_BUTTON30+uindex)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON20+uindex)->EnableWindow(TRUE);
	timeKillEvent(uiTimerID[uindex]);     	
	uiTimerID[uindex]=0;
}


