// RealTimeTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RealTimeTest.h"
#include "RealTimeTestDlg.h"
#include "winpacsdk.h"
#include "Pkfuncs.h"
#include "Mmsystem.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

bool bAPI_IS_RUN=false,bDOEnable=false;
HANDLE hAPI_Thread,hPort;
int iDO_Slot,iDOTotalCh=0;
uint DOInterval;
CString csTmp;
char cTmp[10];
DWORD dwDOData;
/*******************ICPDAS Real-Time demo*****************/
/* 
	Use Multimedia Timer for Real-Time.
	Multimedia Timer functions: 
	(1).timeBeginPeriod
	(2).timeEndPeriod 
	(3).timeKillEvent
	(4).timeSetEvent,
	(5).TimeProc 

    Test way: 
	     Use any 8K DO module to output square wave to test real time. Change the timer priority to
	     enchance the real-time capability. Use oscillograph to see the square wave.             

	What is real-time?
	     Please refer to msdn of microsoft.
*/
/*******************ICPDAS Real-Time demo*****************/

/////////////////////////////////////////////////////////////////////////////
// CRealTimeTestDlg dialog

CRealTimeTestDlg::CRealTimeTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRealTimeTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRealTimeTestDlg)
	m_iThreadPriority = 0;
	m_DOInterval = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRealTimeTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRealTimeTestDlg)
	DDX_Control(pDX, IDC_COMBO1, m_cmbDOSlot);
	DDX_Control(pDX, IDC_EDIT1, m_editDOChannels);
	DDX_Control(pDX, IDC_EDIT2, m_editDOValue);
	DDX_Text(pDX, IDC_EDIT3, m_iThreadPriority);
	DDX_Text(pDX, IDC_EDIT5, m_DOInterval);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRealTimeTestDlg, CDialog)
	//{{AFX_MSG_MAP(CRealTimeTestDlg)
	ON_BN_CLICKED(IDC_BUTTON3, OnbtntimeSetEvent)
	ON_BN_CLICKED(IDC_BUTTON4, OnbtntimeKillEvent)
	ON_BN_CLICKED(IDC_BUTTON1, OnbtnPriority)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRealTimeTestDlg message handlers

BOOL CRealTimeTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CALLBACK TimeProc( UINT uID,UINT uMsg,DWORD dwUser,DWORD dw1,DWORD dw2)
{
	//ICPAS: output square wave
	if(bDOEnable)
	{
		pac_WriteDO( hPort, iDO_Slot,iDOTotalCh,dwDOData);
		bDOEnable=false;
	}
	else
	{
		pac_WriteDO( hPort, iDO_Slot,iDOTotalCh,0);
		bDOEnable=true;
	}
}

UINT uiTimerID;
void CRealTimeTestDlg::OnbtntimeSetEvent() 
{
	// TODO: Add your control notification handler code here
	//ICPAS: Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	//ICPAS: Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);	
	
	//ICPAS: Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	//ICPAS: Open COM0
	hPort = uart_Open("");		
	
	UpdateData(true); 
	
	//ICPAS: Enable timer. use timeSetEvent() to do real-time operation.
	timeBeginPeriod(1); 
	//ICPAS: use timeSetEvent() to do real-time operation.
	uiTimerID=timeSetEvent(m_DOInterval,1,(LPTIMECALLBACK)&TimeProc,(DWORD)this,TIME_PERIODIC);
}

void CRealTimeTestDlg::OnbtntimeKillEvent() 
{
	// TODO: Add your control notification handler code here
	//ICPAS: Disable timer
	timeKillEvent(uiTimerID); 
	timeEndPeriod(1);     
	uart_Close(hPort);
}

void CRealTimeTestDlg::OnbtnPriority() 
{
	// TODO: Add your control notification handler code here
    /*
		//ICPAS: Set timeSetEvent priority
	*/

	bool ret;
    //ICPAS:Check if key exists
    if(!pac_RegKeyExist(_T("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\")))
	{
		//ICPAS:Create Key
		ret=pac_RegCreateKey(_T("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\"));
		if(!ret) printf("Create registry key fail.(\"HKEY_LOCAL_MACHINE\\System\\MMTIMER\\\")\n");
	}    	

	//ICPAS:Set priority value
	UpdateData(true); 
	ret=pac_RegSetDWORD(_T("HKEY_LOCAL_MACHINE\\System\\MMTIMER\\Priority256"),m_iThreadPriority);
	if(!ret) printf("Set priority value fail.(pac_RegSetDWORD() function fail)\n");
		
 }
