// SystemInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SystemInfo.h"
#include "SystemInfoDlg.h"
#include "winpacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSystemInfoDlg dialog

CSystemInfoDlg::CSystemInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSystemInfoDlg)
	m_rotaryID = 0;
	m_serialNumber = _T("");
	m_osVersion = _T("");
	m_ebootVersion = _T("");
	m_sdkVersion = _T("");
	m_lan1mac = _T("");
	m_lan2mac = _T("");
	m_RotaryID = 0;
	m_CPU = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSystemInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSystemInfoDlg)
	DDX_Text(pDX, IDC_EDIT1, m_rotaryID);
	DDX_Text(pDX, IDC_EDIT3, m_serialNumber);
	DDX_Text(pDX, IDC_EDIT4, m_osVersion);
	DDX_Text(pDX, IDC_EDIT6, m_ebootVersion);
	DDX_Text(pDX, IDC_EDIT7, m_sdkVersion);
	DDX_Text(pDX, IDC_EDIT8, m_lan1mac);
	DDX_Text(pDX, IDC_EDIT9, m_lan2mac);
	DDX_Text(pDX, IDC_EDIT5, m_CPU);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSystemInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CSystemInfoDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnGetRotaryID)
	ON_BN_CLICKED(IDC_BUTTON3, OnGetNetID)
	ON_BN_CLICKED(IDC_BUTTON2, OnGetSerialNumber)
	ON_BN_CLICKED(IDC_BUTTON4, OnGetOSVersion)
	ON_BN_CLICKED(IDC_BUTTON5, OnGetFirmwareVersion)
	ON_BN_CLICKED(IDC_BUTTON6, OnGetEbootVersion)
	ON_BN_CLICKED(IDC_BUTTON7, OnSDKVersion)
	ON_BN_CLICKED(IDC_BUTTON8, OnGetLan1MacAddress)
	ON_BN_CLICKED(IDC_BUTTON9, OnGetLan2MacAddress)
	ON_BN_CLICKED(IDC_LEDON, OnLedon)
	ON_BN_CLICKED(IDC_LEDOFF, OnLedoff)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSystemInfoDlg message handlers

BOOL CSystemInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// Get Rotary ID
void CSystemInfoDlg::OnGetRotaryID() 
{
	m_rotaryID = pac_GetRotaryID();
	UpdateData(false);	
}

/////////////////////////////////////////////////////////////////////////////
// Get Net ID
void CSystemInfoDlg::OnGetNetID() 
{
	m_RotaryID = pac_GetRotaryID();		
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
// Get Serial Number
void CSystemInfoDlg::OnGetSerialNumber() 
{
	char buf[32];
	TCHAR SerialNumber[32];
	pac_GetSerialNumber(buf);
	pac_AnsiToWideString(buf, SerialNumber);
	m_serialNumber = SerialNumber;
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
// Get OS Version
void CSystemInfoDlg::OnGetOSVersion() 
{
	char buf[32];
	TCHAR OSVersion[32];
	pac_GetOSVersion(buf);
	pac_AnsiToWideString(buf, OSVersion);
	m_osVersion = OSVersion;
	UpdateData(false);	
}

/////////////////////////////////////////////////////////////////////////////
// Get Firmware Version
void CSystemInfoDlg::OnGetFirmwareVersion() 
{
	char buf[32];
	TCHAR CPUVERSION[32];
	pac_GetCPUVersion(buf);
	pac_AnsiToWideString(buf, CPUVERSION);
	m_CPU = CPUVERSION;
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
// Get Eboot Version
void CSystemInfoDlg::OnGetEbootVersion() 
{
	char buf[32];
	TCHAR EbootVersion[32];
	pac_GetEbootVersion(buf);
	pac_AnsiToWideString(buf, EbootVersion);
	m_ebootVersion = EbootVersion;
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
// Get SDK Version
void CSystemInfoDlg::OnSDKVersion() 
{
	char buf[32];
	TCHAR SDKVersion[32];
	pac_GetSDKVersion(buf);
	pac_AnsiToWideString(buf, SDKVersion);
	m_sdkVersion = SDKVersion;
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
// Get the Mac Address of LAN 1
void CSystemInfoDlg::OnGetLan1MacAddress() 
{
	char buf[12];
	TCHAR MacAddr[12];
	pac_GetMacAddress(1, buf);
	pac_AnsiToWideString(buf, MacAddr);
	m_lan1mac = MacAddr;
	UpdateData(false);
}

/////////////////////////////////////////////////////////////////////////////
// Get the Mac Address of LAN 2
void CSystemInfoDlg::OnGetLan2MacAddress() 
{
	char buf[12];
	TCHAR MacAddr[12];
	pac_GetMacAddress(2, buf);
	pac_AnsiToWideString(buf, MacAddr);
	m_lan2mac = MacAddr;
	UpdateData(false);
}

void CSystemInfoDlg::OnLedon() 
{
	// TODO: Add your control notification handler code here
	pac_EnableLED(TRUE);	
}

void CSystemInfoDlg::OnLedoff() 
{
	// TODO: Add your control notification handler code here
	pac_EnableLED(FALSE);
}
