// SIPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SIP.h"
#include "SIPDlg.h"
#include "Sipapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CLSID g_curCLSID;

static int iLargeIndex;
static int iSmallIndex;
static int iCount = 0;

IMENUMINFO g_IMInfo[5];

int SipEnumIMProc(IMENUMINFO *pIMInfo)
{
	if(iCount>=5) //5: g_IMInfo array size
		return 1;

    memcpy((char*)(&g_IMInfo[iCount].clsid),(char*)(&pIMInfo->clsid),sizeof(CLSID));
    wcscpy(g_IMInfo[iCount].szName,pIMInfo->szName);
	//wprintf(L"%d = %s\r\n",iCount,pIMInfo->szName);
    if (!wcscmp(pIMInfo->szName,_T("LargeKB")))
    {
        iLargeIndex = iCount;
    }

    if (!wcscmp(pIMInfo->szName,_T("Keyboard")))
    {
        iSmallIndex = iCount;
    }
    iCount++;
    return 1;
}
/////////////////////////////////////////////////////////////////////////////
// CSIPDlg dialog

CSIPDlg::CSIPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSIPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSIPDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSIPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSIPDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSIPDlg, CDialog)
	//{{AFX_MSG_MAP(CSIPDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSIPDlg message handlers

BOOL CSIPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	    // Init the COM relative library.
    CoInitializeEx(0, COINIT_MULTITHREADED);
	SipEnumIM(SipEnumIMProc); 
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CSIPDlg::OnButton1() 
{
    SipSetCurrentIM(&g_IMInfo[iSmallIndex].clsid); //Set SIP as LargeKB
	SipShowIM(SIPF_ON); //Show Software Input panel
	
}

void CSIPDlg::OnButton2() 
{
	SipShowIM(SIPF_OFF); //Hide Software Input panel	
}

void CSIPDlg::OnButton4() 
{
	SipShowIM(SIPF_OFF); //Hide Software Input panel	
}

void CSIPDlg::OnButton3() 
{
    SipSetCurrentIM(&g_IMInfo[iLargeIndex].clsid); //Set SIP as LargeKB
	SipShowIM(SIPF_ON); //Show Software Input panel	
}

void CSIPDlg::OnClose() 
{
	CoUninitialize();	
	CDialog::OnClose();
}
