using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using Wincon;

namespace Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	/// 

	public struct i8091CardType
	{
		public int    slot;
		public byte   DDA,AD;
		public ushort  LSP,HSP;
		public byte   xmode,ymode;
		public byte   xdir,ydir;
		public byte   xson,yson;
		public byte   NCmode;
	}

	public class fmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelStop;
		private System.Windows.Forms.Label labelXY;
		private System.Windows.Forms.Label labelInfo;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.Button btnLimitY;
		private System.Windows.Forms.Button btnLimitX;
		private System.Windows.Forms.Button btnIsYStop;
		private System.Windows.Forms.Button btnIsXStop;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Button btnArc02;
		private System.Windows.Forms.Button btnCircle02;
		private System.Windows.Forms.Button btnIntpLine02;
		private System.Windows.Forms.Button btnIntpLine;
		private System.Windows.Forms.Button btnIntpPulse;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Button btnSlowDown;
		private System.Windows.Forms.Button btnSlowStop;
		private System.Windows.Forms.Button btnStopAll;
		private System.Windows.Forms.Button btnStopY;
		private System.Windows.Forms.Button btnStopX;
		private System.Windows.Forms.Label labelSingle;
		private System.Windows.Forms.Label labelSet;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Button btnCspMove;
		private System.Windows.Forms.Button btnHspMove;
		private System.Windows.Forms.Button btnLspMove;
		private System.Windows.Forms.Button btnHspPulseMove;
		private System.Windows.Forms.Button btnLspPulseMove;
		private System.Windows.Forms.Button btnHspOrg;
		private System.Windows.Forms.Button btnLspOrg;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Button btnSetNc;
		private System.Windows.Forms.Button btnSetServoOn;
		private System.Windows.Forms.Button btnSetMode;
		private System.Windows.Forms.Button btnSetDefdir;
		private System.Windows.Forms.Button btnSetVar;
		private System.Windows.Forms.Button btnResetSystem;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBoxYson;
		private System.Windows.Forms.Label labelYson;
		private System.Windows.Forms.TextBox textBoxXson;
		private System.Windows.Forms.Label labelXson;
		private System.Windows.Forms.TextBox textBoxNC;
		private System.Windows.Forms.Label labelNcmode;
		private System.Windows.Forms.TextBox textBoxYdir;
		private System.Windows.Forms.Label labelYdir;
		private System.Windows.Forms.TextBox textBoxXdir;
		private System.Windows.Forms.Label labelXdir;
		private System.Windows.Forms.TextBox textBoxYmode;
		private System.Windows.Forms.Label labelYmode;
		private System.Windows.Forms.TextBox textBoxXmode;
		private System.Windows.Forms.Label labelXmode;
		private System.Windows.Forms.Button btnInitial;
		private System.Windows.Forms.ComboBox comboBoxSlot;
		private System.Windows.Forms.TextBox textBoxHSP;
		private System.Windows.Forms.Label labelHSP;
		private System.Windows.Forms.TextBox textBoxLSP;
		private System.Windows.Forms.Label labelLSP;
		private System.Windows.Forms.TextBox textBoxAD;
		private System.Windows.Forms.Label labelAD;
		private System.Windows.Forms.TextBox textBoxDDA;
		private System.Windows.Forms.Label labelDDA;
		private System.Windows.Forms.Label labelCmd;
		private System.Windows.Forms.TextBox textBoxCmd;
		private System.Windows.Forms.Label labelReslutMsg;
		private System.Windows.Forms.ListBox listBoxMsg;
		private System.Windows.Forms.Label labelCard;
		private System.Windows.Forms.Button btnExit;
	
		//-----------------------------------------------------------
		public static i8091CardType card1;  
		//public static byte CARD1=1;   //REGISTRATION 0~19
		//public static int slot=1;
		public static byte cmdNo;
		//public static bool dialogEndEvent=false;
		//public static bool dialogEndResult=false;
		public static byte axis=1;
		public static byte dir=0;
		public static int pulse=0;
		public static ushort speed=0;
		public static short xpulse=0,ypulse=0;
		public static int x=0,y=0,R=0;
		public static byte slot91=1;
		public static bool find91=false;
		public static bool btnOK=false;

		//-------------------------------------------------
		//-------button Command----------------------------
		public const byte i8091_Reset_System=1;
		public const byte i8091_Set_Var=2;
		public const byte i8091_Set_Defdir=3;
		public const byte i8091_Set_Mode=4;
		public const byte i8091_Set_Servo_On=5;
		public const byte i8091_Set_Nc=6;
		public const byte i8091_Stop_X=7;
		public const byte i8091_Stop_Y=8;
		public const byte i8091_Stop_All=9;
		public const byte i8091_Is_X_Stop=10;
		public const byte i8091_Is_Y_Stop=11;
		public const byte i8091_Limit_X=12;
		public const byte i8091_Limit_Y=13;
		public const byte i8091_Lsp_Pulse_Move=14;
		public const byte i8091_Hsp_Pulse_Move=15;
		public const byte i8091_Lsp_Move=16;
		public const byte i8091_Hsp_Move=17;
		public const byte i8091_Csp_Move=18;
		public const byte i8091_Lsp_Org=19;
		public const byte i8091_Hsp_Org=20;
		public const byte i8091_Slow_Down=21;
		public const byte i8091_Slow_Stop=22;
		public const byte i8091_Intp_Pulse=23;
		public const byte i8091_Intp_Line=24;
		public const byte i8091_Intp_Line02=25;
		public const byte i8091_Intp_Circle02=26;
		public const byte i8091_Intp_Arc02=27;
		//------------------------------------------------------------
		public const byte NORMAL=0;
		public const byte REVERSE=1;
		public const byte ON=1;
		public const byte OFF=0;
		public const byte CW_CCW=0;
		public const byte PULSE_DIR=1;
		public const byte READY=0;
		public const byte X_axis=1;
		public const byte Y_axis=2;
		public const byte CW=0;
		public const byte CCW=1;

		//----------------------------------------------------------


		public fmMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.labelStop = new System.Windows.Forms.Label();
			this.labelXY = new System.Windows.Forms.Label();
			this.labelInfo = new System.Windows.Forms.Label();
			this.panel5 = new System.Windows.Forms.Panel();
			this.btnLimitY = new System.Windows.Forms.Button();
			this.btnLimitX = new System.Windows.Forms.Button();
			this.btnIsYStop = new System.Windows.Forms.Button();
			this.btnIsXStop = new System.Windows.Forms.Button();
			this.panel4 = new System.Windows.Forms.Panel();
			this.btnArc02 = new System.Windows.Forms.Button();
			this.btnCircle02 = new System.Windows.Forms.Button();
			this.btnIntpLine02 = new System.Windows.Forms.Button();
			this.btnIntpLine = new System.Windows.Forms.Button();
			this.btnIntpPulse = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.btnSlowDown = new System.Windows.Forms.Button();
			this.btnSlowStop = new System.Windows.Forms.Button();
			this.btnStopAll = new System.Windows.Forms.Button();
			this.btnStopY = new System.Windows.Forms.Button();
			this.btnStopX = new System.Windows.Forms.Button();
			this.labelSingle = new System.Windows.Forms.Label();
			this.labelSet = new System.Windows.Forms.Label();
			this.panel3 = new System.Windows.Forms.Panel();
			this.btnCspMove = new System.Windows.Forms.Button();
			this.btnHspMove = new System.Windows.Forms.Button();
			this.btnLspMove = new System.Windows.Forms.Button();
			this.btnHspPulseMove = new System.Windows.Forms.Button();
			this.btnLspPulseMove = new System.Windows.Forms.Button();
			this.btnHspOrg = new System.Windows.Forms.Button();
			this.btnLspOrg = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.btnSetNc = new System.Windows.Forms.Button();
			this.btnSetServoOn = new System.Windows.Forms.Button();
			this.btnSetMode = new System.Windows.Forms.Button();
			this.btnSetDefdir = new System.Windows.Forms.Button();
			this.btnSetVar = new System.Windows.Forms.Button();
			this.btnResetSystem = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.textBoxYson = new System.Windows.Forms.TextBox();
			this.labelYson = new System.Windows.Forms.Label();
			this.textBoxXson = new System.Windows.Forms.TextBox();
			this.labelXson = new System.Windows.Forms.Label();
			this.textBoxNC = new System.Windows.Forms.TextBox();
			this.labelNcmode = new System.Windows.Forms.Label();
			this.textBoxYdir = new System.Windows.Forms.TextBox();
			this.labelYdir = new System.Windows.Forms.Label();
			this.textBoxXdir = new System.Windows.Forms.TextBox();
			this.labelXdir = new System.Windows.Forms.Label();
			this.textBoxYmode = new System.Windows.Forms.TextBox();
			this.labelYmode = new System.Windows.Forms.Label();
			this.textBoxXmode = new System.Windows.Forms.TextBox();
			this.labelXmode = new System.Windows.Forms.Label();
			this.btnInitial = new System.Windows.Forms.Button();
			this.comboBoxSlot = new System.Windows.Forms.ComboBox();
			this.textBoxHSP = new System.Windows.Forms.TextBox();
			this.labelHSP = new System.Windows.Forms.Label();
			this.textBoxLSP = new System.Windows.Forms.TextBox();
			this.labelLSP = new System.Windows.Forms.Label();
			this.textBoxAD = new System.Windows.Forms.TextBox();
			this.labelAD = new System.Windows.Forms.Label();
			this.textBoxDDA = new System.Windows.Forms.TextBox();
			this.labelDDA = new System.Windows.Forms.Label();
			this.labelCmd = new System.Windows.Forms.Label();
			this.textBoxCmd = new System.Windows.Forms.TextBox();
			this.labelReslutMsg = new System.Windows.Forms.Label();
			this.listBoxMsg = new System.Windows.Forms.ListBox();
			this.btnExit = new System.Windows.Forms.Button();
			this.labelCard = new System.Windows.Forms.Label();
			// 
			// labelStop
			// 
			this.labelStop.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelStop.Location = new System.Drawing.Point(192, 240);
			this.labelStop.Size = new System.Drawing.Size(128, 20);
			this.labelStop.Text = "Stop / Slow";
			// 
			// labelXY
			// 
			this.labelXY.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelXY.Location = new System.Drawing.Point(344, 240);
			this.labelXY.Size = new System.Drawing.Size(128, 20);
			this.labelXY.Text = "X and Y Axis Move";
			// 
			// labelInfo
			// 
			this.labelInfo.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelInfo.Location = new System.Drawing.Point(496, 240);
			this.labelInfo.Size = new System.Drawing.Size(88, 20);
			this.labelInfo.Text = "Information";
			// 
			// panel5
			// 
			this.panel5.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.panel5.Controls.Add(this.btnLimitY);
			this.panel5.Controls.Add(this.btnLimitX);
			this.panel5.Controls.Add(this.btnIsYStop);
			this.panel5.Controls.Add(this.btnIsXStop);
			this.panel5.Enabled = false;
			this.panel5.Location = new System.Drawing.Point(488, 264);
			this.panel5.Size = new System.Drawing.Size(144, 112);
			// 
			// btnLimitY
			// 
			this.btnLimitY.Location = new System.Drawing.Point(8, 80);
			this.btnLimitY.Size = new System.Drawing.Size(128, 20);
			this.btnLimitY.Text = "i8091 Limit Y";
			this.btnLimitY.Click += new System.EventHandler(this.btnLimitY_Click);
			// 
			// btnLimitX
			// 
			this.btnLimitX.Location = new System.Drawing.Point(8, 56);
			this.btnLimitX.Size = new System.Drawing.Size(128, 20);
			this.btnLimitX.Text = "i8091 Limit X";
			this.btnLimitX.Click += new System.EventHandler(this.btnLimitX_Click);
			// 
			// btnIsYStop
			// 
			this.btnIsYStop.Location = new System.Drawing.Point(8, 32);
			this.btnIsYStop.Size = new System.Drawing.Size(128, 20);
			this.btnIsYStop.Text = "i8091 Is Y Stop";
			this.btnIsYStop.Click += new System.EventHandler(this.btnIsYStop_Click);
			// 
			// btnIsXStop
			// 
			this.btnIsXStop.Location = new System.Drawing.Point(8, 8);
			this.btnIsXStop.Size = new System.Drawing.Size(128, 20);
			this.btnIsXStop.Text = "i8091 Is X Stop";
			this.btnIsXStop.Click += new System.EventHandler(this.btnIsXStop_Click);
			// 
			// panel4
			// 
			this.panel4.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.panel4.Controls.Add(this.btnArc02);
			this.panel4.Controls.Add(this.btnCircle02);
			this.panel4.Controls.Add(this.btnIntpLine02);
			this.panel4.Controls.Add(this.btnIntpLine);
			this.panel4.Controls.Add(this.btnIntpPulse);
			this.panel4.Enabled = false;
			this.panel4.Location = new System.Drawing.Point(336, 264);
			this.panel4.Size = new System.Drawing.Size(144, 136);
			// 
			// btnArc02
			// 
			this.btnArc02.Location = new System.Drawing.Point(8, 104);
			this.btnArc02.Size = new System.Drawing.Size(128, 20);
			this.btnArc02.Text = "i8091 Arc02";
			this.btnArc02.Click += new System.EventHandler(this.btnArc02_Click);
			// 
			// btnCircle02
			// 
			this.btnCircle02.Location = new System.Drawing.Point(8, 80);
			this.btnCircle02.Size = new System.Drawing.Size(128, 20);
			this.btnCircle02.Text = "i8091 Circle02";
			this.btnCircle02.Click += new System.EventHandler(this.btnCircle02_Click);
			// 
			// btnIntpLine02
			// 
			this.btnIntpLine02.Location = new System.Drawing.Point(8, 56);
			this.btnIntpLine02.Size = new System.Drawing.Size(128, 20);
			this.btnIntpLine02.Text = "i8091 Intp Line02";
			this.btnIntpLine02.Click += new System.EventHandler(this.btnIntpLine02_Click);
			// 
			// btnIntpLine
			// 
			this.btnIntpLine.Location = new System.Drawing.Point(8, 32);
			this.btnIntpLine.Size = new System.Drawing.Size(128, 20);
			this.btnIntpLine.Text = "i8091 Intp Line";
			this.btnIntpLine.Click += new System.EventHandler(this.btnIntpLine_Click);
			// 
			// btnIntpPulse
			// 
			this.btnIntpPulse.Location = new System.Drawing.Point(8, 8);
			this.btnIntpPulse.Size = new System.Drawing.Size(128, 20);
			this.btnIntpPulse.Text = "i8091 Intp Pulse";
			this.btnIntpPulse.Click += new System.EventHandler(this.btnIntpPulse_Click);
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.panel2.Controls.Add(this.btnSlowDown);
			this.panel2.Controls.Add(this.btnSlowStop);
			this.panel2.Controls.Add(this.btnStopAll);
			this.panel2.Controls.Add(this.btnStopY);
			this.panel2.Controls.Add(this.btnStopX);
			this.panel2.Enabled = false;
			this.panel2.Location = new System.Drawing.Point(184, 264);
			this.panel2.Size = new System.Drawing.Size(144, 136);
			// 
			// btnSlowDown
			// 
			this.btnSlowDown.Location = new System.Drawing.Point(8, 104);
			this.btnSlowDown.Size = new System.Drawing.Size(128, 20);
			this.btnSlowDown.Text = "i8091 Slow Down";
			this.btnSlowDown.Click += new System.EventHandler(this.btnSlowDown_Click);
			// 
			// btnSlowStop
			// 
			this.btnSlowStop.Location = new System.Drawing.Point(8, 80);
			this.btnSlowStop.Size = new System.Drawing.Size(128, 20);
			this.btnSlowStop.Text = "i8091 Slow Stop";
			this.btnSlowStop.Click += new System.EventHandler(this.btnSlowStop_Click);
			// 
			// btnStopAll
			// 
			this.btnStopAll.Location = new System.Drawing.Point(8, 56);
			this.btnStopAll.Size = new System.Drawing.Size(128, 20);
			this.btnStopAll.Text = "i8091 Stop All";
			this.btnStopAll.Click += new System.EventHandler(this.btnStopAll_Click);
			// 
			// btnStopY
			// 
			this.btnStopY.Location = new System.Drawing.Point(8, 32);
			this.btnStopY.Size = new System.Drawing.Size(128, 20);
			this.btnStopY.Text = "i8091 Stop Y";
			this.btnStopY.Click += new System.EventHandler(this.btnStopY_Click);
			// 
			// btnStopX
			// 
			this.btnStopX.Location = new System.Drawing.Point(8, 8);
			this.btnStopX.Size = new System.Drawing.Size(128, 20);
			this.btnStopX.Text = "i8091 Stop X";
			this.btnStopX.Click += new System.EventHandler(this.btnStopX_Click);
			// 
			// labelSingle
			// 
			this.labelSingle.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelSingle.Location = new System.Drawing.Point(344, 16);
			this.labelSingle.Size = new System.Drawing.Size(128, 20);
			this.labelSingle.Text = "Single Axis Move";
			// 
			// labelSet
			// 
			this.labelSet.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelSet.Location = new System.Drawing.Point(496, 16);
			this.labelSet.Size = new System.Drawing.Size(80, 20);
			this.labelSet.Text = "Set";
			// 
			// panel3
			// 
			this.panel3.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.panel3.Controls.Add(this.btnCspMove);
			this.panel3.Controls.Add(this.btnHspMove);
			this.panel3.Controls.Add(this.btnLspMove);
			this.panel3.Controls.Add(this.btnHspPulseMove);
			this.panel3.Controls.Add(this.btnLspPulseMove);
			this.panel3.Controls.Add(this.btnHspOrg);
			this.panel3.Controls.Add(this.btnLspOrg);
			this.panel3.Enabled = false;
			this.panel3.Location = new System.Drawing.Point(336, 40);
			this.panel3.Size = new System.Drawing.Size(144, 184);
			// 
			// btnCspMove
			// 
			this.btnCspMove.Location = new System.Drawing.Point(8, 152);
			this.btnCspMove.Size = new System.Drawing.Size(128, 20);
			this.btnCspMove.Text = "i8091 Csp Move";
			this.btnCspMove.Click += new System.EventHandler(this.btnCspMove_Click);
			// 
			// btnHspMove
			// 
			this.btnHspMove.Location = new System.Drawing.Point(8, 128);
			this.btnHspMove.Size = new System.Drawing.Size(128, 20);
			this.btnHspMove.Text = "i8091 Hsp Move";
			this.btnHspMove.Click += new System.EventHandler(this.btnHspMove_Click);
			// 
			// btnLspMove
			// 
			this.btnLspMove.Location = new System.Drawing.Point(8, 104);
			this.btnLspMove.Size = new System.Drawing.Size(128, 20);
			this.btnLspMove.Text = "i8091 Lsp Move";
			this.btnLspMove.Click += new System.EventHandler(this.btnLspMove_Click);
			// 
			// btnHspPulseMove
			// 
			this.btnHspPulseMove.Font = new System.Drawing.Font("PMingLiU", 8.25F, System.Drawing.FontStyle.Bold);
			this.btnHspPulseMove.Location = new System.Drawing.Point(8, 80);
			this.btnHspPulseMove.Size = new System.Drawing.Size(128, 20);
			this.btnHspPulseMove.Text = "i8091 Hsp Pulse Move";
			this.btnHspPulseMove.Click += new System.EventHandler(this.btnHspPulseMove_Click);
			// 
			// btnLspPulseMove
			// 
			this.btnLspPulseMove.Font = new System.Drawing.Font("PMingLiU", 8.25F, System.Drawing.FontStyle.Bold);
			this.btnLspPulseMove.Location = new System.Drawing.Point(8, 56);
			this.btnLspPulseMove.Size = new System.Drawing.Size(128, 20);
			this.btnLspPulseMove.Text = "i8091 Lsp Pulse Move";
			this.btnLspPulseMove.Click += new System.EventHandler(this.btnLspPulseMove_Click);
			// 
			// btnHspOrg
			// 
			this.btnHspOrg.Location = new System.Drawing.Point(8, 32);
			this.btnHspOrg.Size = new System.Drawing.Size(128, 20);
			this.btnHspOrg.Text = "i8091 Hsp Org";
			this.btnHspOrg.Click += new System.EventHandler(this.btnHspOrg_Click);
			// 
			// btnLspOrg
			// 
			this.btnLspOrg.Location = new System.Drawing.Point(8, 8);
			this.btnLspOrg.Size = new System.Drawing.Size(128, 20);
			this.btnLspOrg.Text = "i8091 Lsp Org";
			this.btnLspOrg.Click += new System.EventHandler(this.btnLspOrg_Click);
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.panel1.Controls.Add(this.btnSetNc);
			this.panel1.Controls.Add(this.btnSetServoOn);
			this.panel1.Controls.Add(this.btnSetMode);
			this.panel1.Controls.Add(this.btnSetDefdir);
			this.panel1.Controls.Add(this.btnSetVar);
			this.panel1.Controls.Add(this.btnResetSystem);
			this.panel1.Enabled = false;
			this.panel1.Location = new System.Drawing.Point(488, 40);
			this.panel1.Size = new System.Drawing.Size(144, 184);
			// 
			// btnSetNc
			// 
			this.btnSetNc.Location = new System.Drawing.Point(8, 128);
			this.btnSetNc.Size = new System.Drawing.Size(128, 20);
			this.btnSetNc.Text = "i8091 Set NC";
			this.btnSetNc.Click += new System.EventHandler(this.btnSetNc_Click);
			// 
			// btnSetServoOn
			// 
			this.btnSetServoOn.Location = new System.Drawing.Point(8, 104);
			this.btnSetServoOn.Size = new System.Drawing.Size(128, 20);
			this.btnSetServoOn.Text = "i8091 Set Servo ON";
			this.btnSetServoOn.Click += new System.EventHandler(this.btnSetServoOn_Click);
			// 
			// btnSetMode
			// 
			this.btnSetMode.Location = new System.Drawing.Point(8, 80);
			this.btnSetMode.Size = new System.Drawing.Size(128, 20);
			this.btnSetMode.Text = "i8091 Set Mode";
			this.btnSetMode.Click += new System.EventHandler(this.btnSetMode_Click);
			// 
			// btnSetDefdir
			// 
			this.btnSetDefdir.Location = new System.Drawing.Point(8, 56);
			this.btnSetDefdir.Size = new System.Drawing.Size(128, 20);
			this.btnSetDefdir.Text = "i8091 Set Def Dir";
			this.btnSetDefdir.Click += new System.EventHandler(this.btnSetDefdir_Click);
			// 
			// btnSetVar
			// 
			this.btnSetVar.Location = new System.Drawing.Point(8, 32);
			this.btnSetVar.Size = new System.Drawing.Size(128, 20);
			this.btnSetVar.Text = "i8091 Set Var";
			this.btnSetVar.Click += new System.EventHandler(this.btnSetVar_Click);
			// 
			// btnResetSystem
			// 
			this.btnResetSystem.Location = new System.Drawing.Point(8, 8);
			this.btnResetSystem.Size = new System.Drawing.Size(128, 20);
			this.btnResetSystem.Text = "i8091 Reset System";
			this.btnResetSystem.Click += new System.EventHandler(this.btnResetSystem_Click);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("PMingLiU", 9.75F, System.Drawing.FontStyle.Bold);
			this.label1.Location = new System.Drawing.Point(32, 40);
			this.label1.Size = new System.Drawing.Size(48, 20);
			this.label1.Text = "Slot";
			// 
			// textBoxYson
			// 
			this.textBoxYson.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxYson.Location = new System.Drawing.Point(256, 200);
			this.textBoxYson.MaxLength = 5;
			this.textBoxYson.ReadOnly = true;
			this.textBoxYson.Size = new System.Drawing.Size(72, 22);
			this.textBoxYson.Text = "";
			// 
			// labelYson
			// 
			this.labelYson.Location = new System.Drawing.Point(184, 200);
			this.labelYson.Size = new System.Drawing.Size(72, 20);
			this.labelYson.Text = "Y Servo On";
			// 
			// textBoxXson
			// 
			this.textBoxXson.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxXson.Location = new System.Drawing.Point(256, 176);
			this.textBoxXson.MaxLength = 5;
			this.textBoxXson.ReadOnly = true;
			this.textBoxXson.Size = new System.Drawing.Size(72, 22);
			this.textBoxXson.Text = "";
			// 
			// labelXson
			// 
			this.labelXson.Location = new System.Drawing.Point(184, 176);
			this.labelXson.Size = new System.Drawing.Size(72, 20);
			this.labelXson.Text = "X Servo On";
			// 
			// textBoxNC
			// 
			this.textBoxNC.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxNC.Location = new System.Drawing.Point(80, 200);
			this.textBoxNC.MaxLength = 5;
			this.textBoxNC.ReadOnly = true;
			this.textBoxNC.Size = new System.Drawing.Size(72, 22);
			this.textBoxNC.Text = "";
			// 
			// labelNcmode
			// 
			this.labelNcmode.Location = new System.Drawing.Point(8, 200);
			this.labelNcmode.Size = new System.Drawing.Size(72, 20);
			this.labelNcmode.Text = "NC Mode";
			// 
			// textBoxYdir
			// 
			this.textBoxYdir.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxYdir.Location = new System.Drawing.Point(256, 152);
			this.textBoxYdir.MaxLength = 5;
			this.textBoxYdir.ReadOnly = true;
			this.textBoxYdir.Size = new System.Drawing.Size(72, 22);
			this.textBoxYdir.Text = "";
			// 
			// labelYdir
			// 
			this.labelYdir.Location = new System.Drawing.Point(184, 152);
			this.labelYdir.Size = new System.Drawing.Size(72, 20);
			this.labelYdir.Text = "Y Dir";
			// 
			// textBoxXdir
			// 
			this.textBoxXdir.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxXdir.Location = new System.Drawing.Point(256, 128);
			this.textBoxXdir.MaxLength = 5;
			this.textBoxXdir.ReadOnly = true;
			this.textBoxXdir.Size = new System.Drawing.Size(72, 22);
			this.textBoxXdir.Text = "";
			// 
			// labelXdir
			// 
			this.labelXdir.Location = new System.Drawing.Point(184, 128);
			this.labelXdir.Size = new System.Drawing.Size(72, 20);
			this.labelXdir.Text = "X Dir";
			// 
			// textBoxYmode
			// 
			this.textBoxYmode.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxYmode.Location = new System.Drawing.Point(256, 104);
			this.textBoxYmode.MaxLength = 3;
			this.textBoxYmode.ReadOnly = true;
			this.textBoxYmode.Size = new System.Drawing.Size(72, 22);
			this.textBoxYmode.Text = "";
			// 
			// labelYmode
			// 
			this.labelYmode.Location = new System.Drawing.Point(184, 104);
			this.labelYmode.Size = new System.Drawing.Size(72, 20);
			this.labelYmode.Text = "Y Mode";
			// 
			// textBoxXmode
			// 
			this.textBoxXmode.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxXmode.Location = new System.Drawing.Point(256, 80);
			this.textBoxXmode.MaxLength = 3;
			this.textBoxXmode.ReadOnly = true;
			this.textBoxXmode.Size = new System.Drawing.Size(72, 22);
			this.textBoxXmode.Text = "";
			// 
			// labelXmode
			// 
			this.labelXmode.Location = new System.Drawing.Point(184, 80);
			this.labelXmode.Size = new System.Drawing.Size(72, 20);
			this.labelXmode.Text = "X Mode";
			// 
			// btnInitial
			// 
			this.btnInitial.Enabled = false;
			this.btnInitial.Location = new System.Drawing.Point(24, 72);
			this.btnInitial.Size = new System.Drawing.Size(128, 20);
			this.btnInitial.Text = "Initial i8091 Card";
			this.btnInitial.Click += new System.EventHandler(this.btnInitial_Click);
			// 
			// comboBoxSlot
			// 
			this.comboBoxSlot.Items.Add("1");
			this.comboBoxSlot.Items.Add("2");
			this.comboBoxSlot.Items.Add("3");
			this.comboBoxSlot.Items.Add("4");
			this.comboBoxSlot.Items.Add("5");
			this.comboBoxSlot.Items.Add("6");
			this.comboBoxSlot.Items.Add("7");
			this.comboBoxSlot.Location = new System.Drawing.Point(88, 40);
			this.comboBoxSlot.Size = new System.Drawing.Size(64, 20);
			this.comboBoxSlot.SelectedIndexChanged += new System.EventHandler(this.comboBoxSlot_SelectedIndexChanged);
			// 
			// textBoxHSP
			// 
			this.textBoxHSP.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxHSP.Location = new System.Drawing.Point(80, 176);
			this.textBoxHSP.MaxLength = 5;
			this.textBoxHSP.ReadOnly = true;
			this.textBoxHSP.Size = new System.Drawing.Size(72, 22);
			this.textBoxHSP.Text = "";
			// 
			// labelHSP
			// 
			this.labelHSP.Location = new System.Drawing.Point(8, 176);
			this.labelHSP.Size = new System.Drawing.Size(72, 20);
			this.labelHSP.Text = "High Speed";
			// 
			// textBoxLSP
			// 
			this.textBoxLSP.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxLSP.Location = new System.Drawing.Point(80, 152);
			this.textBoxLSP.MaxLength = 5;
			this.textBoxLSP.ReadOnly = true;
			this.textBoxLSP.Size = new System.Drawing.Size(72, 22);
			this.textBoxLSP.Text = "";
			// 
			// labelLSP
			// 
			this.labelLSP.Location = new System.Drawing.Point(8, 152);
			this.labelLSP.Size = new System.Drawing.Size(72, 20);
			this.labelLSP.Text = "Low Speed";
			// 
			// textBoxAD
			// 
			this.textBoxAD.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxAD.Location = new System.Drawing.Point(80, 128);
			this.textBoxAD.MaxLength = 3;
			this.textBoxAD.ReadOnly = true;
			this.textBoxAD.Size = new System.Drawing.Size(72, 22);
			this.textBoxAD.Text = "";
			// 
			// labelAD
			// 
			this.labelAD.Location = new System.Drawing.Point(8, 128);
			this.labelAD.Size = new System.Drawing.Size(72, 20);
			this.labelAD.Text = "Acc Dec";
			// 
			// textBoxDDA
			// 
			this.textBoxDDA.BackColor = System.Drawing.SystemColors.Info;
			this.textBoxDDA.Location = new System.Drawing.Point(80, 104);
			this.textBoxDDA.MaxLength = 3;
			this.textBoxDDA.ReadOnly = true;
			this.textBoxDDA.Size = new System.Drawing.Size(72, 22);
			this.textBoxDDA.Text = "";
			// 
			// labelDDA
			// 
			this.labelDDA.Location = new System.Drawing.Point(8, 104);
			this.labelDDA.Size = new System.Drawing.Size(72, 20);
			this.labelDDA.Text = "DDA cycle";
			// 
			// labelCmd
			// 
			this.labelCmd.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelCmd.Location = new System.Drawing.Point(184, 16);
			this.labelCmd.Size = new System.Drawing.Size(144, 20);
			this.labelCmd.Text = "Current Command";
			// 
			// textBoxCmd
			// 
			this.textBoxCmd.BackColor = System.Drawing.SystemColors.ControlLight;
			this.textBoxCmd.ForeColor = System.Drawing.Color.Black;
			this.textBoxCmd.Location = new System.Drawing.Point(184, 40);
			this.textBoxCmd.ReadOnly = true;
			this.textBoxCmd.Size = new System.Drawing.Size(144, 22);
			this.textBoxCmd.Text = "";
			// 
			// labelReslutMsg
			// 
			this.labelReslutMsg.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelReslutMsg.Location = new System.Drawing.Point(16, 240);
			this.labelReslutMsg.Size = new System.Drawing.Size(144, 20);
			this.labelReslutMsg.Text = "Result Information";
			// 
			// listBoxMsg
			// 
			this.listBoxMsg.Location = new System.Drawing.Point(8, 264);
			this.listBoxMsg.Size = new System.Drawing.Size(160, 134);
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(496, 384);
			this.btnExit.Size = new System.Drawing.Size(128, 20);
			this.btnExit.Text = "Exit";
			this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
			// 
			// labelCard
			// 
			this.labelCard.Font = new System.Drawing.Font("PMingLiU", 9.75F, System.Drawing.FontStyle.Bold);
			this.labelCard.Location = new System.Drawing.Point(16, 16);
			this.labelCard.Size = new System.Drawing.Size(160, 16);
			this.labelCard.Text = "I-8091 Card : Not found";
			// 
			// fmMain
			// 
			this.BackColor = System.Drawing.Color.SkyBlue;
			this.ClientSize = new System.Drawing.Size(634, 430);
			this.Controls.Add(this.labelCard);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.labelReslutMsg);
			this.Controls.Add(this.listBoxMsg);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textBoxYson);
			this.Controls.Add(this.labelYson);
			this.Controls.Add(this.textBoxXson);
			this.Controls.Add(this.labelXson);
			this.Controls.Add(this.textBoxNC);
			this.Controls.Add(this.labelNcmode);
			this.Controls.Add(this.textBoxYdir);
			this.Controls.Add(this.labelYdir);
			this.Controls.Add(this.textBoxXdir);
			this.Controls.Add(this.labelXdir);
			this.Controls.Add(this.textBoxYmode);
			this.Controls.Add(this.labelYmode);
			this.Controls.Add(this.textBoxXmode);
			this.Controls.Add(this.labelXmode);
			this.Controls.Add(this.btnInitial);
			this.Controls.Add(this.comboBoxSlot);
			this.Controls.Add(this.textBoxHSP);
			this.Controls.Add(this.labelHSP);
			this.Controls.Add(this.textBoxLSP);
			this.Controls.Add(this.labelLSP);
			this.Controls.Add(this.textBoxAD);
			this.Controls.Add(this.labelAD);
			this.Controls.Add(this.textBoxDDA);
			this.Controls.Add(this.labelDDA);
			this.Controls.Add(this.labelCmd);
			this.Controls.Add(this.textBoxCmd);
			this.Controls.Add(this.labelSingle);
			this.Controls.Add(this.labelSet);
			this.Controls.Add(this.panel3);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.labelStop);
			this.Controls.Add(this.labelXY);
			this.Controls.Add(this.labelInfo);
			this.Controls.Add(this.panel5);
			this.Controls.Add(this.panel4);
			this.Controls.Add(this.panel2);
			this.Text = "Demo i8091 Card for Wincon8000";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new fmMain());
		}


		private void btnExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if ((MessageBox.Show("Do you want to Close the System?","Exit",MessageBoxButtons.YesNo,
				MessageBoxIcon.Question,0))==(DialogResult.No))
				e.Cancel=true;
		}

		private void infoShow()
		{
			comboBoxSlot.Text=System.Convert.ToString(slot91);
			textBoxDDA.Text=System.Convert.ToString(card1.DDA);
			textBoxAD.Text=System.Convert.ToString(card1.AD);
			textBoxLSP.Text=System.Convert.ToString(card1.LSP);
			textBoxHSP.Text=System.Convert.ToString(card1.HSP);
			textBoxXmode.Text=(card1.xmode==fmMain.CW_CCW)?"CW_CCW":"PULSE_DIR";
			textBoxYmode.Text=(card1.ymode==fmMain.CW_CCW)?"CW_CCW":"PULSE_DIR";
			textBoxXdir.Text=(card1.xdir==fmMain.NORMAL)?"NORMAL":"REVERSE";
			textBoxYdir.Text=(card1.ydir==fmMain.NORMAL)?"NORMAL":"REVERSE";
			textBoxXson.Text=(card1.xson==fmMain.OFF)?"OFF":"ON";
			textBoxYson.Text=(card1.yson==fmMain.OFF)?"OFF":"ON";
			textBoxNC.Text=(card1.NCmode==fmMain.OFF)?"OFF":"ON";
		}

		public void i8091_Initialize()
		{
			string moduleName="";
			if (Wcon.System.GetNameOfModule(slot91,ref moduleName)==91)
			{
				btnInitial.Enabled=true;
				panel1.Enabled=true;
				panel2.Enabled=true;
				panel3.Enabled=true;
				panel4.Enabled=true;
				panel5.Enabled=true;
				labelCard.Text="i8091 Card in "+System.Convert.ToString(slot91)+" slot";
				Wcon.i8091.REGISTRATION(slot91, slot91); 
				Wcon.i8091.RESET_SYSTEM(slot91);
				Wcon.i8091.SET_VAR(slot91, card1.DDA, card1.AD, card1.LSP, card1.HSP);
				Wcon.i8091.SET_DEFDIR(slot91, card1.xdir, card1.ydir);
				Wcon.i8091.SET_MODE(slot91, card1.xmode, card1.ymode);
				Wcon.i8091.SET_SERVO_ON(slot91, card1.xson, card1.yson);
				Wcon.i8091.SET_NC(slot91, card1.NCmode);		
			}
		}


		private void Form1_Load(object sender, System.EventArgs e)
		{
			byte ModuleNo;
			string moduleName="";
		
			card1.DDA   = 10;
			card1.AD    = 3;
			card1.LSP   = 5;
			card1.HSP   = 150;
			card1.xmode = fmMain.CW_CCW;		//CW_CCW=0  PULSE_DIR=1
			card1.ymode = fmMain.CW_CCW;		//CW_CCW=0  PULSE_DIR=1
			card1.xdir  = fmMain.NORMAL;		//NORMAL_DIR=0  REVERSE_DIR=1
			card1.ydir  = fmMain.NORMAL;		//NORMAL_DIR=0  REVERSE_DIR=1
			card1.xson  = fmMain.ON;		//ON=1  OFF=0
			card1.yson  = fmMain.ON;		//ON=1
			card1.NCmode= fmMain.OFF;		//OFF=0
			this.infoShow();


			for (int i=1;i<8;i++)
			{
				ModuleNo=(byte)Wcon.System.GetNameOfModule(i, ref moduleName);
				switch (ModuleNo)
				{
					case 91:
						slot91=(byte)i;
						find91=true;
						this.i8091_Initialize();
						break;
				}
				Thread.Sleep(1);
			}
			if (find91)
			{
				labelCard.Text="I-8091 Card in "+Convert.ToString(slot91)+" Slot";
				comboBoxSlot.Text=Convert.ToString(slot91);
			}
			else
			{
				labelCard.Text="I-8091 Card Not found";
				comboBoxSlot.Text="1";
			}
		}

		private void comboBoxSlot_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			byte tmp;
			string moduleName="";

			tmp=Convert.ToByte(comboBoxSlot.Text);
			if (Wcon.System.GetNameOfModule(tmp, ref moduleName)==91)
			{
				slot91=tmp;
				find91=true;
				labelCard.Text="I-8091 Card in "+comboBoxSlot.Text+" Slot";
				this.i8091_Initialize();
			}
			else
			{
				labelCard.Text="I-8091 Card Not found";
				btnInitial.Enabled=false;
				panel1.Enabled=false;
				panel2.Enabled=false;
				panel3.Enabled=false;
				panel4.Enabled=false;
				panel5.Enabled=false;
			}
		}

		private void btnResetSystem_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Reset System";
			Wcon.i8091.RESET_SYSTEM(slot91);
			//i8091_SET_VAR(CARD1, card1.DDA, card1.AD, card1.LSP, card1.HSP);
			//i8091_SET_DEFDIR(CARD1, card1.xdir, card1.ydir);
			//i8091_SET_MODE(CARD1, card1.xmode, card1.ymode);
			//i8091_SET_SERVO_ON(CARD1, card1.xson, card1.yson); 
			//i8091_SET_NC(CARD1, card1.NCmode);   
			//Thread.Sleep(50);
		}

		private void btnSetVar_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Set_Var;
			textBoxCmd.Text="Set Var";
			fmMain.btnOK=false;
			fmDlg1 fmInput=new fmDlg1();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
				Wcon.i8091.SET_VAR(slot91, fmMain.card1.DDA, fmMain.card1.AD, fmMain.card1.LSP, fmMain.card1.HSP);
		}

		private void btnSetDefdir_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Set_Defdir;
			textBoxCmd.Text="Set DefDir";
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)	
				Wcon.i8091.SET_DEFDIR(slot91, fmMain.card1.xdir, fmMain.card1.ydir);
		}

		private void btnSetMode_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Set_Mode;
			textBoxCmd.Text="Set Mode";
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			this.infoShow();		
			if (fmMain.btnOK)
				Wcon.i8091.SET_MODE(slot91, fmMain.card1.xmode, fmMain.card1.ymode);
		}

		private void btnSetServoOn_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Set_Servo_On;
			textBoxCmd.Text="Set Servo On";
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			this.infoShow();	
			if (fmMain.btnOK)
				Wcon.i8091.SET_SERVO_ON(slot91, fmMain.card1.xson, fmMain.card1.yson);		
		}

		private void btnSetNc_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Set_Nc;
			textBoxCmd.Text="Set NC";
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
				Wcon.i8091.SET_NC(slot91, fmMain.card1.NCmode);
		}

		private void btnInitial_Click(object sender, System.EventArgs e)
		{
			this.i8091_Initialize();
		}

		private void btnIsXStop_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Is X Stop";
			listBoxMsg.Items.Clear();
			if (Wcon.i8091.IS_X_STOP(slot91)==1)
				listBoxMsg.Items.Add("X Stop=Yes");
			else
				listBoxMsg.Items.Add("X Stop=No");		
		}

		private void btnIsYStop_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Is Y Stop";
			listBoxMsg.Items.Clear();
			if (Wcon.i8091.IS_Y_STOP(slot91)==1)
				listBoxMsg.Items.Add("Y Stop=Yes");
			else
				listBoxMsg.Items.Add("Y Stop=No");			
		}

		private void btnLimitX_Click(object sender, System.EventArgs e)
		{
			byte temp;
			textBoxCmd.Text="Limit X";
			temp=Wcon.i8091.LIMIT_X(slot91);
			listBoxMsg.Items.Clear();
			listBoxMsg.Items.Add("/ORG1="+System.Convert.ToString(temp&0x01));
			listBoxMsg.Items.Add("/LS11="+System.Convert.ToString((temp&0x02)>>1));
			listBoxMsg.Items.Add("xxx  ="+System.Convert.ToString((temp&0x04)>>2));
			listBoxMsg.Items.Add("xxx  ="+System.Convert.ToString((temp&0x08)>>3));
			listBoxMsg.Items.Add("/LS14="+System.Convert.ToString((temp&0x10)>>4));
			listBoxMsg.Items.Add("/FFEF="+System.Convert.ToString((temp&0x20)>>5));
			listBoxMsg.Items.Add("/FFFF="+System.Convert.ToString((temp&0x40)>>6));
			listBoxMsg.Items.Add("/EMG ="+System.Convert.ToString((temp&0x80)>>7));
		}

		private void btnLimitY_Click(object sender, System.EventArgs e)
		{
			byte temp;
			textBoxCmd.Text="Limit Y";
			temp=Wcon.i8091.LIMIT_X(slot91);
			listBoxMsg.Items.Clear();
			listBoxMsg.Items.Add("/ORG2 ="+System.Convert.ToString(temp&0x01));
			listBoxMsg.Items.Add("/LS21 ="+System.Convert.ToString((temp&0x02)>>1));
			listBoxMsg.Items.Add("xxx   ="+System.Convert.ToString((temp&0x04)>>2));
			listBoxMsg.Items.Add("xxx   ="+System.Convert.ToString((temp&0x08)>>3));
			listBoxMsg.Items.Add("/LS14 ="+System.Convert.ToString((temp&0x10)>>4));
			listBoxMsg.Items.Add(" CPUS ="+System.Convert.ToString((temp&0x20)>>5));
			listBoxMsg.Items.Add("/XSTOP="+System.Convert.ToString((temp&0x40)>>6));
			listBoxMsg.Items.Add("/YSTOP="+System.Convert.ToString((temp&0x80)>>7));
		}

		private void btnStopX_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Stop X";
			Wcon.i8091.STOP_X(slot91);
		}

		private void btnStopY_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Stop Y";
			Wcon.i8091.STOP_Y(slot91);
		}

		private void btnStopAll_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Stop ALL";
			Wcon.i8091.STOP_ALL(slot91);
		}

		private void btnSlowStop_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Slow Stop";
			cmdNo=fmMain.i8091_Slow_Stop;
			fmMain.axis=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.SLOW_STOP(slot91, axis);
		}

		private void btnSlowDown_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="Slow Down";
			cmdNo=fmMain.i8091_Slow_Down;
			fmMain.axis=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.SLOW_DOWN(slot91, axis);		
		}

		private void btnLspOrg_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="LSP ORG";
			cmdNo=fmMain.i8091_Lsp_Org;
			fmMain.axis=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.LSP_ORG(slot91, fmMain.CCW, fmMain.axis);		
		}

		private void btnHspOrg_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="HSP ORG";
			cmdNo=fmMain.i8091_Hsp_Org;
			fmMain.axis=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.HSP_ORG(slot91, fmMain.CCW, fmMain.axis);				
		}

		private void btnLspPulseMove_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="LSP Pulse Move";
			cmdNo=fmMain.i8091_Lsp_Pulse_Move;
			fmMain.axis=0;
			fmMain.pulse=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.LSP_PULSE_MOVE(slot91, fmMain.axis, fmMain.pulse);
		}

		private void btnHspPulseMove_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="HSP Pulse Move";
			cmdNo=fmMain.i8091_Hsp_Pulse_Move;
			fmMain.axis=0;
			fmMain.pulse=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.HSP_PULSE_MOVE(slot91, fmMain.axis, fmMain.pulse);		
		}

		private void btnLspMove_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="LSP MOVE";
			cmdNo=fmMain.i8091_Lsp_Move;
			fmMain.axis=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.LSP_MOVE(slot91, fmMain.dir, fmMain.axis);			
		}

		private void btnHspMove_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="HSP MOVE";
			cmdNo=fmMain.i8091_Hsp_Move;
			fmMain.axis=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.HSP_MOVE(slot91, fmMain.dir, fmMain.axis);	
		}

		private void btnCspMove_Click(object sender, System.EventArgs e)
		{
			textBoxCmd.Text="CSP Move";
			cmdNo=fmMain.i8091_Csp_Move;
			fmMain.axis=0;
			fmMain.pulse=0;
			fmMain.btnOK=false;
			fmDlg2 fmInput=new fmDlg2();
			fmInput.ShowDialog();
			if (fmMain.btnOK&&(fmMain.axis!=0))
				Wcon.i8091.CSP_MOVE(slot91, fmMain.dir, fmMain.axis, fmMain.speed);
		}

		private void btnIntpPulse_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Intp_Pulse;
			textBoxCmd.Text="Intp Pulse";
			fmMain.btnOK=false;
			fmMain.xpulse=0;
			fmMain.ypulse=0;
			fmDlg1 fmInput=new fmDlg1();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
				Wcon.i8091.INTP_PULSE(slot91, fmMain.xpulse, fmMain.ypulse);
		}

		private void btnIntpLine_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Intp_Line;
			textBoxCmd.Text="Intp Line";
			fmMain.btnOK=false;
			fmMain.xpulse=0;
			fmMain.ypulse=0;
			fmDlg1 fmInput=new fmDlg1();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
				Wcon.i8091.INTP_LINE(slot91, fmMain.x, fmMain.y);
		}

		private void btnIntpLine02_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Intp_Line02;
			textBoxCmd.Text="Intp Line02";
			fmMain.btnOK=false;
			fmMain.x=0;
			fmMain.y=0;
			fmMain.speed=fmMain.card1.LSP;
			fmDlg1 fmInput=new fmDlg1();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
			{
				Wcon.i8091.INTP_LINE02(slot91, fmMain.x, fmMain.y, fmMain.speed, 0);
				do 
				{
				} while (Wcon.i8091.INTP_STOP()!=fmMain.READY);
			}
		}

		private void btnCircle02_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Intp_Circle02;
			textBoxCmd.Text="Intp Circle02";
			fmMain.btnOK=false;
			fmMain.x=0;
			fmMain.y=0;
			fmMain.speed=fmMain.card1.LSP;
			fmDlg1 fmInput=new fmDlg1();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
			{
				Wcon.i8091.INTP_CIRCLE02(slot91, fmMain.x, fmMain.y, fmMain.dir,fmMain.speed, 0);
				do 
				{
				} while (Wcon.i8091.INTP_STOP()!=fmMain.READY);
			}		
		}

		private void btnArc02_Click(object sender, System.EventArgs e)
		{
			cmdNo=fmMain.i8091_Intp_Arc02;
			textBoxCmd.Text="Intp Arc02";
			fmMain.btnOK=false;
			fmMain.x=0;
			fmMain.y=0;
			fmMain.R=0;
			fmMain.speed=fmMain.card1.LSP;
			fmDlg1 fmInput=new fmDlg1();
			fmInput.ShowDialog();
			this.infoShow();
			if (fmMain.btnOK)
			{
				Wcon.i8091.INTP_ARC02(slot91, fmMain.x, fmMain.y, fmMain.R, fmMain.dir, fmMain.speed, 0);
				do 
				{
				} while (Wcon.i8091.INTP_STOP()!=fmMain.READY);
			}			
		}
	}
}
